/* Orientation.c generated by valac 0.40.6, the Vala compiler
 * generated from Orientation.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>


#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_ROTATION (rotation_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

typedef enum  {
	ROTATION_CLOCKWISE,
	ROTATION_COUNTERCLOCKWISE,
	ROTATION_MIRROR,
	ROTATION_UPSIDE_DOWN
} Rotation;

struct _Dimensions {
	gint width;
	gint height;
};

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};



GType orientation_get_type (void) G_GNUC_CONST;
gchar* orientation_to_string (Orientation self);
Orientation orientation_rotate_clockwise (Orientation self);
Orientation orientation_rotate_counterclockwise (Orientation self);
Orientation orientation_flip_top_to_bottom (Orientation self);
Orientation orientation_flip_left_to_right (Orientation self);
GType rotation_get_type (void) G_GNUC_CONST;
Orientation orientation_perform (Orientation self,
                                 Rotation rotation);
Rotation* orientation_to_rotations (Orientation self,
                                    int* result_length1);
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void orientation_rotate_dimensions (Orientation self,
                                    Dimensions* dim,
                                    Dimensions* result);
void dimensions_init (Dimensions *self,
                      gint width,
                      gint height);
void orientation_derotate_dimensions (Orientation self,
                                      Dimensions* dim,
                                      Dimensions* result);
GdkPixbuf* orientation_rotate_pixbuf (Orientation self,
                                      GdkPixbuf* pixbuf);
void orientation_rotate_point (Orientation self,
                               Dimensions* space,
                               GdkPoint* point,
                               GdkPoint* result);
gboolean dimensions_has_area (Dimensions *self);
void orientation_derotate_point (Orientation self,
                                 Dimensions* space,
                                 GdkPoint* point,
                                 GdkPoint* result);
GType box_get_type (void) G_GNUC_CONST;
Box* box_dup (const Box* self);
void box_free (Box* self);
void orientation_rotate_box (Orientation self,
                             Dimensions* space,
                             Box* box,
                             Box* result);
void box_get_points (Box *self,
                     GdkPoint* top_left,
                     GdkPoint* bottom_right);
void box_from_points (GdkPoint* corner1,
                      GdkPoint* corner2,
                      Box* result);
void orientation_derotate_box (Orientation self,
                               Dimensions* space,
                               Box* box,
                               Box* result);
GdkPixbuf* rotation_perform (Rotation self,
                             GdkPixbuf* pixbuf);
Rotation rotation_opposite (Rotation self);


gchar*
orientation_to_string (Orientation self)
{
	gchar* result = NULL;
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	switch (self) {
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 146 "Orientation.c"
		{
			gchar* _tmp0_;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp0_ = g_strdup ("top-left");
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp0_;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 155 "Orientation.c"
		}
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 159 "Orientation.c"
		{
			gchar* _tmp1_;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp1_ = g_strdup ("top-right");
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp1_;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 168 "Orientation.c"
		}
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 172 "Orientation.c"
		{
			gchar* _tmp2_;
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp2_ = g_strdup ("bottom-right");
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp2_;
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 181 "Orientation.c"
		}
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 185 "Orientation.c"
		{
			gchar* _tmp3_;
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp3_ = g_strdup ("bottom-left");
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp3_;
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 194 "Orientation.c"
		}
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 198 "Orientation.c"
		{
			gchar* _tmp4_;
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp4_ = g_strdup ("left-top");
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp4_;
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 207 "Orientation.c"
		}
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 211 "Orientation.c"
		{
			gchar* _tmp5_;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp5_ = g_strdup ("right-top");
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp5_;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 220 "Orientation.c"
		}
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 224 "Orientation.c"
		{
			gchar* _tmp6_;
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp6_ = g_strdup ("right-bottom");
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp6_;
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 233 "Orientation.c"
		}
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 237 "Orientation.c"
		{
			gchar* _tmp7_;
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp7_ = g_strdup ("left-bottom");
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp7_;
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 246 "Orientation.c"
		}
		default:
		{
			gchar* _tmp8_;
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp8_ = g_strdup_printf ("unknown orientation %d", (gint) self);
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp8_;
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 257 "Orientation.c"
		}
	}
}


Orientation
orientation_rotate_clockwise (Orientation self)
{
	Orientation result = 0;
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	switch (self) {
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 271 "Orientation.c"
		{
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_RIGHT_TOP;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 277 "Orientation.c"
		}
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 281 "Orientation.c"
		{
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_RIGHT_BOTTOM;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 287 "Orientation.c"
		}
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 291 "Orientation.c"
		{
#line 72 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_LEFT_BOTTOM;
#line 72 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 297 "Orientation.c"
		}
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 301 "Orientation.c"
		{
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_LEFT_TOP;
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 307 "Orientation.c"
		}
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 311 "Orientation.c"
		{
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_TOP_RIGHT;
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 317 "Orientation.c"
		}
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 321 "Orientation.c"
		{
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_BOTTOM_RIGHT;
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 327 "Orientation.c"
		}
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 331 "Orientation.c"
		{
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_BOTTOM_LEFT;
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 337 "Orientation.c"
		}
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 341 "Orientation.c"
		{
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_TOP_LEFT;
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 347 "Orientation.c"
		}
		default:
		{
#line 90 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			g_error ("Orientation.vala:90: rotate_clockwise: %d", (gint) self);
#line 353 "Orientation.c"
		}
	}
}


Orientation
orientation_rotate_counterclockwise (Orientation self)
{
	Orientation result = 0;
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	switch (self) {
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 367 "Orientation.c"
		{
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_LEFT_BOTTOM;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 373 "Orientation.c"
		}
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 377 "Orientation.c"
		{
#line 100 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_LEFT_TOP;
#line 100 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 383 "Orientation.c"
		}
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 387 "Orientation.c"
		{
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_RIGHT_TOP;
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 393 "Orientation.c"
		}
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 397 "Orientation.c"
		{
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_RIGHT_BOTTOM;
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 403 "Orientation.c"
		}
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 407 "Orientation.c"
		{
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_BOTTOM_LEFT;
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 413 "Orientation.c"
		}
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 417 "Orientation.c"
		{
#line 112 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_TOP_LEFT;
#line 112 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 423 "Orientation.c"
		}
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 427 "Orientation.c"
		{
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_TOP_RIGHT;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 433 "Orientation.c"
		}
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 437 "Orientation.c"
		{
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_BOTTOM_RIGHT;
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 443 "Orientation.c"
		}
		default:
		{
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			g_error ("Orientation.vala:121: rotate_counterclockwise: %d", (gint) self);
#line 449 "Orientation.c"
		}
	}
}


Orientation
orientation_flip_top_to_bottom (Orientation self)
{
	Orientation result = 0;
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	switch (self) {
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 463 "Orientation.c"
		{
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_BOTTOM_LEFT;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 469 "Orientation.c"
		}
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 473 "Orientation.c"
		{
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_BOTTOM_RIGHT;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 479 "Orientation.c"
		}
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 483 "Orientation.c"
		{
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_TOP_RIGHT;
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 489 "Orientation.c"
		}
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 493 "Orientation.c"
		{
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_TOP_LEFT;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 499 "Orientation.c"
		}
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 503 "Orientation.c"
		{
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_LEFT_BOTTOM;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 509 "Orientation.c"
		}
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 513 "Orientation.c"
		{
#line 143 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_RIGHT_BOTTOM;
#line 143 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 519 "Orientation.c"
		}
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 523 "Orientation.c"
		{
#line 146 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_RIGHT_TOP;
#line 146 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 529 "Orientation.c"
		}
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 533 "Orientation.c"
		{
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_LEFT_TOP;
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 539 "Orientation.c"
		}
		default:
		{
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			g_error ("Orientation.vala:152: flip_top_to_bottom: %d", (gint) self);
#line 545 "Orientation.c"
		}
	}
}


Orientation
orientation_flip_left_to_right (Orientation self)
{
	Orientation result = 0;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	switch (self) {
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 559 "Orientation.c"
		{
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_TOP_RIGHT;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 565 "Orientation.c"
		}
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 569 "Orientation.c"
		{
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_TOP_LEFT;
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 575 "Orientation.c"
		}
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 579 "Orientation.c"
		{
#line 165 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_BOTTOM_LEFT;
#line 165 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 585 "Orientation.c"
		}
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 589 "Orientation.c"
		{
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_BOTTOM_RIGHT;
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 595 "Orientation.c"
		}
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 599 "Orientation.c"
		{
#line 171 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_RIGHT_TOP;
#line 171 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 605 "Orientation.c"
		}
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 609 "Orientation.c"
		{
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_LEFT_TOP;
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 615 "Orientation.c"
		}
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 619 "Orientation.c"
		{
#line 177 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_LEFT_BOTTOM;
#line 177 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 625 "Orientation.c"
		}
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 629 "Orientation.c"
		{
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_RIGHT_BOTTOM;
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 635 "Orientation.c"
		}
		default:
		{
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			g_error ("Orientation.vala:183: flip_left_to_right: %d", (gint) self);
#line 641 "Orientation.c"
		}
	}
}


Orientation
orientation_perform (Orientation self,
                     Rotation rotation)
{
	Orientation result = 0;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	switch (rotation) {
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ROTATION_CLOCKWISE:
#line 656 "Orientation.c"
		{
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = orientation_rotate_clockwise (self);
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 662 "Orientation.c"
		}
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ROTATION_COUNTERCLOCKWISE:
#line 666 "Orientation.c"
		{
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = orientation_rotate_counterclockwise (self);
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 672 "Orientation.c"
		}
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ROTATION_MIRROR:
#line 676 "Orientation.c"
		{
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = orientation_flip_left_to_right (self);
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 682 "Orientation.c"
		}
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ROTATION_UPSIDE_DOWN:
#line 686 "Orientation.c"
		{
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = orientation_flip_top_to_bottom (self);
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 692 "Orientation.c"
		}
		default:
		{
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			g_error ("Orientation.vala:202: perform: %d", (gint) rotation);
#line 698 "Orientation.c"
		}
	}
}


Rotation*
orientation_to_rotations (Orientation self,
                          int* result_length1)
{
	Rotation* result = NULL;
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	switch (self) {
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 713 "Orientation.c"
		{
			Rotation* _tmp0_;
			Rotation* _tmp1_;
			gint _tmp1__length1;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp0_ = g_new0 (Rotation, 0);
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp1_ = _tmp0_;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp1__length1 = 0;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			if (result_length1) {
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
				*result_length1 = _tmp1__length1;
#line 728 "Orientation.c"
			}
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp1_;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 734 "Orientation.c"
		}
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 738 "Orientation.c"
		{
			Rotation* _tmp2_;
			Rotation* _tmp3_;
			gint _tmp3__length1;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp2_ = g_new0 (Rotation, 1);
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp2_[0] = ROTATION_MIRROR;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp3_ = _tmp2_;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp3__length1 = 1;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			if (result_length1) {
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
				*result_length1 = _tmp3__length1;
#line 755 "Orientation.c"
			}
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp3_;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 761 "Orientation.c"
		}
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 765 "Orientation.c"
		{
			Rotation* _tmp4_;
			Rotation* _tmp5_;
			gint _tmp5__length1;
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp4_ = g_new0 (Rotation, 1);
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp4_[0] = ROTATION_UPSIDE_DOWN;
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp5_ = _tmp4_;
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp5__length1 = 1;
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			if (result_length1) {
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
				*result_length1 = _tmp5__length1;
#line 782 "Orientation.c"
			}
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp5_;
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 788 "Orientation.c"
		}
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 792 "Orientation.c"
		{
			Rotation* _tmp6_;
			Rotation* _tmp7_;
			gint _tmp7__length1;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp6_ = g_new0 (Rotation, 2);
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp6_[0] = ROTATION_MIRROR;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp6_[1] = ROTATION_UPSIDE_DOWN;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp7_ = _tmp6_;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp7__length1 = 2;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			if (result_length1) {
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
				*result_length1 = _tmp7__length1;
#line 811 "Orientation.c"
			}
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp7_;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 817 "Orientation.c"
		}
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 821 "Orientation.c"
		{
			Rotation* _tmp8_;
			Rotation* _tmp9_;
			gint _tmp9__length1;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp8_ = g_new0 (Rotation, 2);
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp8_[0] = ROTATION_COUNTERCLOCKWISE;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp8_[1] = ROTATION_UPSIDE_DOWN;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp9_ = _tmp8_;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp9__length1 = 2;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			if (result_length1) {
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
				*result_length1 = _tmp9__length1;
#line 840 "Orientation.c"
			}
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp9_;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 846 "Orientation.c"
		}
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 850 "Orientation.c"
		{
			Rotation* _tmp10_;
			Rotation* _tmp11_;
			gint _tmp11__length1;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp10_ = g_new0 (Rotation, 1);
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp10_[0] = ROTATION_CLOCKWISE;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp11_ = _tmp10_;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp11__length1 = 1;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			if (result_length1) {
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
				*result_length1 = _tmp11__length1;
#line 867 "Orientation.c"
			}
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp11_;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 873 "Orientation.c"
		}
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 877 "Orientation.c"
		{
			Rotation* _tmp12_;
			Rotation* _tmp13_;
			gint _tmp13__length1;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp12_ = g_new0 (Rotation, 2);
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp12_[0] = ROTATION_CLOCKWISE;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp12_[1] = ROTATION_UPSIDE_DOWN;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp13_ = _tmp12_;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp13__length1 = 2;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			if (result_length1) {
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
				*result_length1 = _tmp13__length1;
#line 896 "Orientation.c"
			}
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp13_;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 902 "Orientation.c"
		}
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 906 "Orientation.c"
		{
			Rotation* _tmp14_;
			Rotation* _tmp15_;
			gint _tmp15__length1;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp14_ = g_new0 (Rotation, 1);
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp14_[0] = ROTATION_COUNTERCLOCKWISE;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp15_ = _tmp14_;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp15__length1 = 1;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			if (result_length1) {
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
				*result_length1 = _tmp15__length1;
#line 923 "Orientation.c"
			}
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp15_;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 929 "Orientation.c"
		}
		default:
		{
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			g_error ("Orientation.vala:235: to_rotations: %d", (gint) self);
#line 935 "Orientation.c"
		}
	}
}


void
orientation_rotate_dimensions (Orientation self,
                               Dimensions* dim,
                               Dimensions* result)
{
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	g_return_if_fail (dim != NULL);
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	switch (self) {
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 958 "Orientation.c"
		{
			Dimensions _tmp0_;
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp0_ = *dim;
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			*result = _tmp0_;
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return;
#line 967 "Orientation.c"
		}
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 977 "Orientation.c"
		{
			Dimensions _tmp1_;
			gint _tmp2_;
			Dimensions _tmp3_;
			gint _tmp4_;
			Dimensions _tmp5_ = {0};
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp1_ = *dim;
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp2_ = _tmp1_.height;
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp3_ = *dim;
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp4_ = _tmp3_.width;
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			dimensions_init (&_tmp5_, _tmp2_, _tmp4_);
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			*result = _tmp5_;
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return;
#line 998 "Orientation.c"
		}
		default:
		{
#line 256 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			g_error ("Orientation.vala:256: rotate_dimensions: %d", (gint) self);
#line 1004 "Orientation.c"
		}
	}
}


void
orientation_derotate_dimensions (Orientation self,
                                 Dimensions* dim,
                                 Dimensions* result)
{
	Dimensions _tmp0_;
	Dimensions _tmp1_ = {0};
#line 260 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	g_return_if_fail (dim != NULL);
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp0_ = *dim;
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	orientation_rotate_dimensions (self, &_tmp0_, &_tmp1_);
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	*result = _tmp1_;
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	return;
#line 1027 "Orientation.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 269 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	return self ? g_object_ref (self) : NULL;
#line 1036 "Orientation.c"
}


GdkPixbuf*
orientation_rotate_pixbuf (Orientation self,
                           GdkPixbuf* pixbuf)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* rotated = NULL;
#line 264 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	switch (self) {
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 1052 "Orientation.c"
		{
			GdkPixbuf* _tmp0_;
#line 269 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp0_ = _g_object_ref0 (pixbuf);
#line 269 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 269 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated = _tmp0_;
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1063 "Orientation.c"
		}
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 1067 "Orientation.c"
		{
			GdkPixbuf* _tmp1_;
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp1_ = gdk_pixbuf_flip (pixbuf, TRUE);
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated = _tmp1_;
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1078 "Orientation.c"
		}
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 1082 "Orientation.c"
		{
			GdkPixbuf* _tmp2_;
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp2_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_UPSIDEDOWN);
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated = _tmp2_;
#line 279 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1093 "Orientation.c"
		}
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 1097 "Orientation.c"
		{
			GdkPixbuf* _tmp3_;
#line 283 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp3_ = gdk_pixbuf_flip (pixbuf, FALSE);
#line 283 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 283 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated = _tmp3_;
#line 284 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1108 "Orientation.c"
		}
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 1112 "Orientation.c"
		{
			GdkPixbuf* _tmp4_;
			GdkPixbuf* _tmp5_;
			GdkPixbuf* _tmp6_;
#line 287 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp4_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE);
#line 287 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp5_ = _tmp4_;
#line 287 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp6_ = gdk_pixbuf_flip (_tmp5_, FALSE);
#line 287 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 287 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated = _tmp6_;
#line 287 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_g_object_unref0 (_tmp5_);
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1131 "Orientation.c"
		}
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 1135 "Orientation.c"
		{
			GdkPixbuf* _tmp7_;
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp7_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_CLOCKWISE);
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated = _tmp7_;
#line 292 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1146 "Orientation.c"
		}
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 1150 "Orientation.c"
		{
			GdkPixbuf* _tmp8_;
			GdkPixbuf* _tmp9_;
			GdkPixbuf* _tmp10_;
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp8_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_CLOCKWISE);
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp9_ = _tmp8_;
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp10_ = gdk_pixbuf_flip (_tmp9_, FALSE);
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated = _tmp10_;
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_g_object_unref0 (_tmp9_);
#line 296 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1169 "Orientation.c"
		}
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 1173 "Orientation.c"
		{
			GdkPixbuf* _tmp11_;
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp11_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE);
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated = _tmp11_;
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1184 "Orientation.c"
		}
		default:
		{
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			g_error ("Orientation.vala:303: rotate_pixbuf: %d", (gint) self);
#line 1190 "Orientation.c"
		}
	}
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	result = rotated;
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	return result;
#line 1197 "Orientation.c"
}


void
orientation_rotate_point (Orientation self,
                          Dimensions* space,
                          GdkPoint* point,
                          GdkPoint* result)
{
	GdkPoint _tmp0_;
	gint _tmp1_;
	GdkPoint _tmp2_;
	gint _tmp3_;
	Dimensions _tmp4_;
	gint _tmp5_;
	GdkPoint _tmp6_;
	gint _tmp7_;
	GdkPoint _tmp8_;
	gint _tmp9_;
	Dimensions _tmp10_;
	gint _tmp11_;
	GdkPoint rotated = {0};
#line 310 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	g_return_if_fail (space != NULL);
#line 310 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	g_return_if_fail (point != NULL);
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_vala_assert (dimensions_has_area (space), "space.has_area ()");
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp0_ = *point;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp1_ = _tmp0_.x;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_vala_assert (_tmp1_ >= 0, "point.x >= 0");
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp2_ = *point;
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp3_ = _tmp2_.x;
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp4_ = *space;
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp5_ = _tmp4_.width;
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_vala_assert (_tmp3_ < _tmp5_, "point.x < space.width");
#line 314 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp6_ = *point;
#line 314 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp7_ = _tmp6_.y;
#line 314 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_vala_assert (_tmp7_ >= 0, "point.y >= 0");
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp8_ = *point;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp9_ = _tmp8_.y;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp10_ = *space;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp11_ = _tmp10_.height;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_vala_assert (_tmp9_ < _tmp11_, "point.y < space.height");
#line 317 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	memset (&rotated, 0, sizeof (GdkPoint));
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	switch (self) {
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 1264 "Orientation.c"
		{
			GdkPoint _tmp12_;
#line 322 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp12_ = *point;
#line 322 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated = _tmp12_;
#line 323 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1273 "Orientation.c"
		}
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 1277 "Orientation.c"
		{
			Dimensions _tmp13_;
			gint _tmp14_;
			GdkPoint _tmp15_;
			gint _tmp16_;
			GdkPoint _tmp17_;
			gint _tmp18_;
#line 327 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp13_ = *space;
#line 327 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp14_ = _tmp13_.width;
#line 327 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp15_ = *point;
#line 327 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp16_ = _tmp15_.x;
#line 327 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.x = (_tmp14_ - _tmp16_) - 1;
#line 328 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp17_ = *point;
#line 328 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp18_ = _tmp17_.y;
#line 328 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.y = _tmp18_;
#line 329 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1303 "Orientation.c"
		}
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 1307 "Orientation.c"
		{
			Dimensions _tmp19_;
			gint _tmp20_;
			GdkPoint _tmp21_;
			gint _tmp22_;
			Dimensions _tmp23_;
			gint _tmp24_;
			GdkPoint _tmp25_;
			gint _tmp26_;
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp19_ = *space;
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp20_ = _tmp19_.width;
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp21_ = *point;
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp22_ = _tmp21_.x;
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.x = (_tmp20_ - _tmp22_) - 1;
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp23_ = *space;
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp24_ = _tmp23_.height;
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp25_ = *point;
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp26_ = _tmp25_.y;
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.y = (_tmp24_ - _tmp26_) - 1;
#line 335 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1339 "Orientation.c"
		}
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 1343 "Orientation.c"
		{
			GdkPoint _tmp27_;
			gint _tmp28_;
			Dimensions _tmp29_;
			gint _tmp30_;
			GdkPoint _tmp31_;
			gint _tmp32_;
#line 339 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp27_ = *point;
#line 339 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp28_ = _tmp27_.x;
#line 339 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.x = _tmp28_;
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp29_ = *space;
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp30_ = _tmp29_.height;
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp31_ = *point;
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp32_ = _tmp31_.y;
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.y = (_tmp30_ - _tmp32_) - 1;
#line 341 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1369 "Orientation.c"
		}
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 1373 "Orientation.c"
		{
			GdkPoint _tmp33_;
			gint _tmp34_;
			GdkPoint _tmp35_;
			gint _tmp36_;
#line 345 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp33_ = *point;
#line 345 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp34_ = _tmp33_.y;
#line 345 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.x = _tmp34_;
#line 346 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp35_ = *point;
#line 346 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp36_ = _tmp35_.x;
#line 346 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.y = _tmp36_;
#line 347 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1393 "Orientation.c"
		}
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 1397 "Orientation.c"
		{
			Dimensions _tmp37_;
			gint _tmp38_;
			GdkPoint _tmp39_;
			gint _tmp40_;
			GdkPoint _tmp41_;
			gint _tmp42_;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp37_ = *space;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp38_ = _tmp37_.height;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp39_ = *point;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp40_ = _tmp39_.y;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.x = (_tmp38_ - _tmp40_) - 1;
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp41_ = *point;
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp42_ = _tmp41_.x;
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.y = _tmp42_;
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1423 "Orientation.c"
		}
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 1427 "Orientation.c"
		{
			Dimensions _tmp43_;
			gint _tmp44_;
			GdkPoint _tmp45_;
			gint _tmp46_;
			Dimensions _tmp47_;
			gint _tmp48_;
			GdkPoint _tmp49_;
			gint _tmp50_;
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp43_ = *space;
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp44_ = _tmp43_.height;
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp45_ = *point;
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp46_ = _tmp45_.y;
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.x = (_tmp44_ - _tmp46_) - 1;
#line 358 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp47_ = *space;
#line 358 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp48_ = _tmp47_.width;
#line 358 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp49_ = *point;
#line 358 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp50_ = _tmp49_.x;
#line 358 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.y = (_tmp48_ - _tmp50_) - 1;
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1459 "Orientation.c"
		}
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 1463 "Orientation.c"
		{
			GdkPoint _tmp51_;
			gint _tmp52_;
			Dimensions _tmp53_;
			gint _tmp54_;
			GdkPoint _tmp55_;
			gint _tmp56_;
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp51_ = *point;
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp52_ = _tmp51_.y;
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.x = _tmp52_;
#line 364 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp53_ = *space;
#line 364 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp54_ = _tmp53_.width;
#line 364 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp55_ = *point;
#line 364 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp56_ = _tmp55_.x;
#line 364 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.y = (_tmp54_ - _tmp56_) - 1;
#line 365 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1489 "Orientation.c"
		}
		default:
		{
#line 368 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			g_error ("Orientation.vala:368: rotate_point: %d", (gint) self);
#line 1495 "Orientation.c"
		}
	}
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	*result = rotated;
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	return;
#line 1502 "Orientation.c"
}


void
orientation_derotate_point (Orientation self,
                            Dimensions* space,
                            GdkPoint* point,
                            GdkPoint* result)
{
	GdkPoint derotated = {0};
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	g_return_if_fail (space != NULL);
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	g_return_if_fail (point != NULL);
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_vala_assert (dimensions_has_area (space), "space.has_area ()");
#line 378 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	memset (&derotated, 0, sizeof (GdkPoint));
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	switch (self) {
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 1525 "Orientation.c"
		{
			GdkPoint _tmp0_;
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp0_ = *point;
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated = _tmp0_;
#line 384 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1534 "Orientation.c"
		}
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 1538 "Orientation.c"
		{
			Dimensions _tmp1_;
			gint _tmp2_;
			GdkPoint _tmp3_;
			gint _tmp4_;
			GdkPoint _tmp5_;
			gint _tmp6_;
#line 388 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp1_ = *space;
#line 388 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp2_ = _tmp1_.width;
#line 388 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp3_ = *point;
#line 388 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp4_ = _tmp3_.x;
#line 388 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.x = (_tmp2_ - _tmp4_) - 1;
#line 389 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp5_ = *point;
#line 389 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp6_ = _tmp5_.y;
#line 389 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.y = _tmp6_;
#line 390 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1564 "Orientation.c"
		}
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 1568 "Orientation.c"
		{
			Dimensions _tmp7_;
			gint _tmp8_;
			GdkPoint _tmp9_;
			gint _tmp10_;
			Dimensions _tmp11_;
			gint _tmp12_;
			GdkPoint _tmp13_;
			gint _tmp14_;
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp7_ = *space;
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp8_ = _tmp7_.width;
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp9_ = *point;
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp10_ = _tmp9_.x;
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.x = (_tmp8_ - _tmp10_) - 1;
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp11_ = *space;
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp12_ = _tmp11_.height;
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp13_ = *point;
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp14_ = _tmp13_.y;
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.y = (_tmp12_ - _tmp14_) - 1;
#line 396 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1600 "Orientation.c"
		}
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 1604 "Orientation.c"
		{
			GdkPoint _tmp15_;
			gint _tmp16_;
			Dimensions _tmp17_;
			gint _tmp18_;
			GdkPoint _tmp19_;
			gint _tmp20_;
#line 400 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp15_ = *point;
#line 400 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp16_ = _tmp15_.x;
#line 400 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.x = _tmp16_;
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp17_ = *space;
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp18_ = _tmp17_.height;
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp19_ = *point;
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp20_ = _tmp19_.y;
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.y = (_tmp18_ - _tmp20_) - 1;
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1630 "Orientation.c"
		}
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 1634 "Orientation.c"
		{
			GdkPoint _tmp21_;
			gint _tmp22_;
			GdkPoint _tmp23_;
			gint _tmp24_;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp21_ = *point;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp22_ = _tmp21_.y;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.x = _tmp22_;
#line 407 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp23_ = *point;
#line 407 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp24_ = _tmp23_.x;
#line 407 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.y = _tmp24_;
#line 408 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1654 "Orientation.c"
		}
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 1658 "Orientation.c"
		{
			GdkPoint _tmp25_;
			gint _tmp26_;
			Dimensions _tmp27_;
			gint _tmp28_;
			GdkPoint _tmp29_;
			gint _tmp30_;
#line 412 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp25_ = *point;
#line 412 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp26_ = _tmp25_.y;
#line 412 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.x = _tmp26_;
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp27_ = *space;
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp28_ = _tmp27_.height;
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp29_ = *point;
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp30_ = _tmp29_.x;
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.y = (_tmp28_ - _tmp30_) - 1;
#line 414 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1684 "Orientation.c"
		}
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 1688 "Orientation.c"
		{
			Dimensions _tmp31_;
			gint _tmp32_;
			GdkPoint _tmp33_;
			gint _tmp34_;
			Dimensions _tmp35_;
			gint _tmp36_;
			GdkPoint _tmp37_;
			gint _tmp38_;
#line 418 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp31_ = *space;
#line 418 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp32_ = _tmp31_.width;
#line 418 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp33_ = *point;
#line 418 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp34_ = _tmp33_.y;
#line 418 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.x = (_tmp32_ - _tmp34_) - 1;
#line 419 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp35_ = *space;
#line 419 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp36_ = _tmp35_.height;
#line 419 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp37_ = *point;
#line 419 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp38_ = _tmp37_.x;
#line 419 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.y = (_tmp36_ - _tmp38_) - 1;
#line 420 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1720 "Orientation.c"
		}
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 1724 "Orientation.c"
		{
			Dimensions _tmp39_;
			gint _tmp40_;
			GdkPoint _tmp41_;
			gint _tmp42_;
			GdkPoint _tmp43_;
			gint _tmp44_;
#line 424 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp39_ = *space;
#line 424 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp40_ = _tmp39_.width;
#line 424 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp41_ = *point;
#line 424 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp42_ = _tmp41_.y;
#line 424 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.x = (_tmp40_ - _tmp42_) - 1;
#line 425 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp43_ = *point;
#line 425 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp44_ = _tmp43_.x;
#line 425 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.y = _tmp44_;
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1750 "Orientation.c"
		}
		default:
		{
#line 429 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			g_error ("Orientation.vala:429: rotate_point: %d", (gint) self);
#line 1756 "Orientation.c"
		}
	}
#line 432 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	*result = derotated;
#line 432 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	return;
#line 1763 "Orientation.c"
}


void
orientation_rotate_box (Orientation self,
                        Dimensions* space,
                        Box* box,
                        Box* result)
{
	GdkPoint top_left = {0};
	GdkPoint bottom_right = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_ = {0};
	GdkPoint _tmp2_;
	gint _tmp3_;
	Dimensions _tmp4_;
	gint _tmp5_;
	GdkPoint _tmp6_;
	gint _tmp7_;
	Dimensions _tmp8_;
	gint _tmp9_;
	GdkPoint _tmp10_;
	gint _tmp11_;
	Dimensions _tmp12_;
	gint _tmp13_;
	GdkPoint _tmp14_;
	gint _tmp15_;
	Dimensions _tmp16_;
	gint _tmp17_;
	Dimensions _tmp18_;
	GdkPoint _tmp19_;
	GdkPoint _tmp20_ = {0};
	Dimensions _tmp21_;
	GdkPoint _tmp22_;
	GdkPoint _tmp23_ = {0};
	GdkPoint _tmp24_;
	GdkPoint _tmp25_;
	Box _tmp26_ = {0};
#line 436 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	g_return_if_fail (space != NULL);
#line 436 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	g_return_if_fail (box != NULL);
#line 438 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	box_get_points (box, &_tmp0_, &_tmp1_);
#line 438 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	top_left = _tmp0_;
#line 438 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	bottom_right = _tmp1_;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp2_ = top_left;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp3_ = _tmp2_.x;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp4_ = *space;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp5_ = _tmp4_.width;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	top_left.x = CLAMP (_tmp3_, 0, _tmp5_ - 1);
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp6_ = top_left;
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp7_ = _tmp6_.y;
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp8_ = *space;
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp9_ = _tmp8_.height;
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	top_left.y = CLAMP (_tmp7_, 0, _tmp9_ - 1);
#line 443 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp10_ = bottom_right;
#line 443 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp11_ = _tmp10_.x;
#line 443 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp12_ = *space;
#line 443 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp13_ = _tmp12_.width;
#line 443 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	bottom_right.x = CLAMP (_tmp11_, 0, _tmp13_ - 1);
#line 444 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp14_ = bottom_right;
#line 444 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp15_ = _tmp14_.y;
#line 444 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp16_ = *space;
#line 444 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp17_ = _tmp16_.height;
#line 444 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	bottom_right.y = CLAMP (_tmp15_, 0, _tmp17_ - 1);
#line 446 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp18_ = *space;
#line 446 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp19_ = top_left;
#line 446 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	orientation_rotate_point (self, &_tmp18_, &_tmp19_, &_tmp20_);
#line 446 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	top_left = _tmp20_;
#line 447 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp21_ = *space;
#line 447 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp22_ = bottom_right;
#line 447 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	orientation_rotate_point (self, &_tmp21_, &_tmp22_, &_tmp23_);
#line 447 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	bottom_right = _tmp23_;
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp24_ = top_left;
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp25_ = bottom_right;
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	box_from_points (&_tmp24_, &_tmp25_, &_tmp26_);
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	*result = _tmp26_;
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	return;
#line 1878 "Orientation.c"
}


void
orientation_derotate_box (Orientation self,
                          Dimensions* space,
                          Box* box,
                          Box* result)
{
	GdkPoint top_left = {0};
	GdkPoint bottom_right = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_ = {0};
	Dimensions _tmp2_;
	GdkPoint _tmp3_;
	GdkPoint _tmp4_ = {0};
	Dimensions _tmp5_;
	GdkPoint _tmp6_;
	GdkPoint _tmp7_ = {0};
	GdkPoint _tmp8_;
	GdkPoint _tmp9_;
	Box _tmp10_ = {0};
#line 453 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	g_return_if_fail (space != NULL);
#line 453 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	g_return_if_fail (box != NULL);
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	box_get_points (box, &_tmp0_, &_tmp1_);
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	top_left = _tmp0_;
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	bottom_right = _tmp1_;
#line 457 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp2_ = *space;
#line 457 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp3_ = top_left;
#line 457 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	orientation_derotate_point (self, &_tmp2_, &_tmp3_, &_tmp4_);
#line 457 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	top_left = _tmp4_;
#line 458 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp5_ = *space;
#line 458 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp6_ = bottom_right;
#line 458 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	orientation_derotate_point (self, &_tmp5_, &_tmp6_, &_tmp7_);
#line 458 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	bottom_right = _tmp7_;
#line 460 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp8_ = top_left;
#line 460 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp9_ = bottom_right;
#line 460 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	box_from_points (&_tmp8_, &_tmp9_, &_tmp10_);
#line 460 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	*result = _tmp10_;
#line 460 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	return;
#line 1937 "Orientation.c"
}


GType
orientation_get_type (void)
{
	static volatile gsize orientation_type_id__volatile = 0;
	if (g_once_init_enter (&orientation_type_id__volatile)) {
		static const GEnumValue values[] = {{ORIENTATION_MIN, "ORIENTATION_MIN", "min"}, {ORIENTATION_TOP_LEFT, "ORIENTATION_TOP_LEFT", "top-left"}, {ORIENTATION_TOP_RIGHT, "ORIENTATION_TOP_RIGHT", "top-right"}, {ORIENTATION_BOTTOM_RIGHT, "ORIENTATION_BOTTOM_RIGHT", "bottom-right"}, {ORIENTATION_BOTTOM_LEFT, "ORIENTATION_BOTTOM_LEFT", "bottom-left"}, {ORIENTATION_LEFT_TOP, "ORIENTATION_LEFT_TOP", "left-top"}, {ORIENTATION_RIGHT_TOP, "ORIENTATION_RIGHT_TOP", "right-top"}, {ORIENTATION_RIGHT_BOTTOM, "ORIENTATION_RIGHT_BOTTOM", "right-bottom"}, {ORIENTATION_LEFT_BOTTOM, "ORIENTATION_LEFT_BOTTOM", "left-bottom"}, {ORIENTATION_MAX, "ORIENTATION_MAX", "max"}, {0, NULL, NULL}};
		GType orientation_type_id;
		orientation_type_id = g_enum_register_static ("Orientation", values);
		g_once_init_leave (&orientation_type_id__volatile, orientation_type_id);
	}
	return orientation_type_id__volatile;
}


GdkPixbuf*
rotation_perform (Rotation self,
                  GdkPixbuf* pixbuf)
{
	GdkPixbuf* result = NULL;
#line 470 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 471 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	switch (self) {
#line 471 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ROTATION_CLOCKWISE:
#line 1966 "Orientation.c"
		{
			GdkPixbuf* _tmp0_;
#line 473 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp0_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_CLOCKWISE);
#line 473 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp0_;
#line 473 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 1975 "Orientation.c"
		}
#line 471 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ROTATION_COUNTERCLOCKWISE:
#line 1979 "Orientation.c"
		{
			GdkPixbuf* _tmp1_;
#line 476 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp1_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE);
#line 476 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp1_;
#line 476 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 1988 "Orientation.c"
		}
#line 471 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ROTATION_MIRROR:
#line 1992 "Orientation.c"
		{
			GdkPixbuf* _tmp2_;
#line 479 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp2_ = gdk_pixbuf_flip (pixbuf, TRUE);
#line 479 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp2_;
#line 479 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 2001 "Orientation.c"
		}
#line 471 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ROTATION_UPSIDE_DOWN:
#line 2005 "Orientation.c"
		{
			GdkPixbuf* _tmp3_;
#line 482 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp3_ = gdk_pixbuf_flip (pixbuf, FALSE);
#line 482 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp3_;
#line 482 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 2014 "Orientation.c"
		}
		default:
		{
#line 485 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			g_error ("Orientation.vala:485: Unknown rotation: %d", (gint) self);
#line 2020 "Orientation.c"
		}
	}
}


Rotation
rotation_opposite (Rotation self)
{
	Rotation result = 0;
#line 490 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	switch (self) {
#line 490 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ROTATION_CLOCKWISE:
#line 2034 "Orientation.c"
		{
#line 492 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ROTATION_COUNTERCLOCKWISE;
#line 492 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 2040 "Orientation.c"
		}
#line 490 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ROTATION_COUNTERCLOCKWISE:
#line 2044 "Orientation.c"
		{
#line 495 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ROTATION_CLOCKWISE;
#line 495 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 2050 "Orientation.c"
		}
#line 490 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ROTATION_MIRROR:
#line 490 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ROTATION_UPSIDE_DOWN:
#line 2056 "Orientation.c"
		{
#line 499 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = self;
#line 499 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 2062 "Orientation.c"
		}
		default:
		{
#line 502 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			g_error ("Orientation.vala:502: Unknown rotation: %d", (gint) self);
#line 2068 "Orientation.c"
		}
	}
}


GType
rotation_get_type (void)
{
	static volatile gsize rotation_type_id__volatile = 0;
	if (g_once_init_enter (&rotation_type_id__volatile)) {
		static const GEnumValue values[] = {{ROTATION_CLOCKWISE, "ROTATION_CLOCKWISE", "clockwise"}, {ROTATION_COUNTERCLOCKWISE, "ROTATION_COUNTERCLOCKWISE", "counterclockwise"}, {ROTATION_MIRROR, "ROTATION_MIRROR", "mirror"}, {ROTATION_UPSIDE_DOWN, "ROTATION_UPSIDE_DOWN", "upside-down"}, {0, NULL, NULL}};
		GType rotation_type_id;
		rotation_type_id = g_enum_register_static ("Rotation", values);
		g_once_init_leave (&rotation_type_id__volatile, rotation_type_id);
	}
	return rotation_type_id__volatile;
}



