/* DatabaseTable.c generated by valac 0.40.6, the Vala compiler
 * generated from DatabaseTable.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <sqlite3.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>


#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
typedef struct _ParamSpecDatabaseTable ParamSpecDatabaseTable;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _ParamSpecDatabaseTable {
	GParamSpec parent_instance;
};


static gpointer database_table_parent_class = NULL;
extern sqlite3* database_table_db;
sqlite3* database_table_db = NULL;
static gint database_table_in_transaction;
static gint database_table_in_transaction = 0;

GQuark database_error_quark (void);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_database_table (GValue* value,
                               gpointer v_object);
void value_take_database_table (GValue* value,
                                gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
#define DATABASE_TABLE_SCHEMA_VERSION 21
static void database_table_prepare_db (const gchar* filename);
void app_window_panic (const gchar* msg);
#define DB_IN_MEMORY_NAME ":memory:"
void database_table_init (const gchar* filename);
void database_table_warning (const gchar* op,
                             gint res);
void database_table_terminate (void);
void database_table_fatal (const gchar* op,
                           gint res);
void database_table_set_table_name (DatabaseTable* self,
                                    const gchar* table_name);
void database_table_throw_error (const gchar* method,
                                 gint res,
                                 GError** error);
sqlite3_stmt* database_table_create_stmt (DatabaseTable* self,
                                          const gchar* data);
static void database_table_assert_test (gboolean condition,
                                 const gchar* data);
void database_table_bind_text (sqlite3_stmt* stmt,
                               gint column,
                               const gchar* data);
void database_table_bind_int (sqlite3_stmt* stmt,
                              gint column,
                              gint data);
void database_table_bind_int64 (sqlite3_stmt* stmt,
                                gint column,
                                gint64 data);
void database_table_bind_double (sqlite3_stmt* stmt,
                                 gint column,
                                 gdouble data);
gboolean database_table_exists_by_id (DatabaseTable* self,
                                      gint64 id);
gboolean database_table_select_by_id (DatabaseTable* self,
                                      gint64 id,
                                      const gchar* columns,
                                      sqlite3_stmt* * stmt);
static void database_table_prepare_update_by_id (DatabaseTable* self,
                                          gint64 id,
                                          const gchar* column,
                                          sqlite3_stmt* * stmt);
static gboolean database_table_execute_update_by_id (DatabaseTable* self,
                                              sqlite3_stmt* stmt);
gboolean database_table_update_text_by_id (DatabaseTable* self,
                                           gint64 id,
                                           const gchar* column,
                                           const gchar* text);
void database_table_update_text_by_id_2 (DatabaseTable* self,
                                         gint64 id,
                                         const gchar* column,
                                         const gchar* text,
                                         GError** error);
gboolean database_table_update_int_by_id (DatabaseTable* self,
                                          gint64 id,
                                          const gchar* column,
                                          gint value);
void database_table_update_int_by_id_2 (DatabaseTable* self,
                                        gint64 id,
                                        const gchar* column,
                                        gint value,
                                        GError** error);
gboolean database_table_update_int64_by_id (DatabaseTable* self,
                                            gint64 id,
                                            const gchar* column,
                                            gint64 value);
void database_table_update_int64_by_id_2 (DatabaseTable* self,
                                          gint64 id,
                                          const gchar* column,
                                          gint64 value,
                                          GError** error);
void database_table_delete_by_id (DatabaseTable* self,
                                  gint64 id,
                                  GError** error);
gboolean database_table_has_column (const gchar* table_name,
                                    const gchar* column_name);
gboolean database_table_has_table (const gchar* table_name);
gboolean database_table_add_column (const gchar* table_name,
                                    const gchar* column_name,
                                    const gchar* column_constraints);
gboolean database_table_ensure_column (const gchar* table_name,
                                       const gchar* column_name,
                                       const gchar* column_constraints,
                                       const gchar* upgrade_msg);
gint database_table_get_row_count (DatabaseTable* self);
void database_table_begin_transaction (void);
void database_table_commit_transaction (GError** error);
DatabaseTable* database_table_construct (GType object_type);
static void database_table_finalize (DatabaseTable * obj);


GQuark
database_error_quark (void)
{
	return g_quark_from_static_string ("database_error-quark");
}


static void
database_table_prepare_db (const gchar* filename)
{
	gint res = 0;
	sqlite3* _tmp0_ = NULL;
	gint _tmp1_;
	gint _tmp2_;
	GError * _inner_error_ = NULL;
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_if_fail (filename != NULL);
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp1_ = sqlite3_open_v2 (filename, &_tmp0_, SQLITE_OPEN_READWRITE | SQLITE_OPEN_CREATE, NULL);
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_close0 (database_table_db);
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	database_table_db = _tmp0_;
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = _tmp1_;
#line 49 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp2_ = res;
#line 49 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (_tmp2_ != SQLITE_OK) {
#line 223 "DatabaseTable.c"
		gint _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp3_ = res;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp4_ = g_strdup_printf (_ ("Unable to open/create photo database %s: error code %d"), filename, _tmp3_);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp5_ = _tmp4_;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		app_window_panic (_tmp5_);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_g_free0 (_tmp5_);
#line 237 "DatabaseTable.c"
	}
#line 54 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (g_strcmp0 (filename, DB_IN_MEMORY_NAME) != 0) {
#line 241 "DatabaseTable.c"
		{
			GFile* file_db = NULL;
			GFile* _tmp6_;
			GFileInfo* info = NULL;
			GFile* _tmp7_;
			GFileInfo* _tmp8_;
			GFileInfo* _tmp9_;
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_tmp6_ = g_file_new_for_path (filename);
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			file_db = _tmp6_;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_tmp7_ = file_db;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_tmp8_ = g_file_query_info (_tmp7_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error_);
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			info = _tmp8_;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				_g_object_unref0 (file_db);
#line 263 "DatabaseTable.c"
				goto __catch493_g_error;
			}
#line 58 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_tmp9_ = info;
#line 58 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			if (!g_file_info_get_attribute_boolean (_tmp9_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE)) {
#line 270 "DatabaseTable.c"
				gchar* _tmp10_;
				gchar* _tmp11_;
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				_tmp10_ = g_strdup_printf (_ ("Unable to write to photo database file:\n %s"), filename);
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				_tmp11_ = _tmp10_;
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				app_window_panic (_tmp11_);
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				_g_free0 (_tmp11_);
#line 281 "DatabaseTable.c"
			}
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_g_object_unref0 (info);
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_g_object_unref0 (file_db);
#line 287 "DatabaseTable.c"
		}
		goto __finally493;
		__catch493_g_error:
		{
			GError* e = NULL;
			GError* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			e = _inner_error_;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_inner_error_ = NULL;
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_tmp12_ = e;
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_tmp13_ = _tmp12_->message;
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_tmp14_ = g_strdup_printf (_ ("Error accessing database file:\n %s\n\nError was: \n%s"), filename, _tmp13_);
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_tmp15_ = _tmp14_;
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			app_window_panic (_tmp15_);
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_g_free0 (_tmp15_);
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_g_error_free0 (e);
#line 315 "DatabaseTable.c"
		}
		__finally493:
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			g_clear_error (&_inner_error_);
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			return;
#line 326 "DatabaseTable.c"
		}
	}
}


static gint
_sqlite3_exec (sqlite3* self,
               const gchar* sql,
               sqlite3_callback callback,
               void* callback_target,
               gchar* * errmsg)
{
	gchar* _vala_errmsg = NULL;
	gint result = 0;
	const gchar* sqlite_errmsg = NULL;
	gint ec = 0;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_;
	const gchar* _tmp4_;
#line 34 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
	g_return_val_if_fail (sql != NULL, 0);
#line 36 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
	_tmp1_ = sqlite3_exec (self, sql, callback, callback_target, (char**) (&_tmp0_));
#line 36 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
	sqlite_errmsg = _tmp0_;
#line 36 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
	ec = _tmp1_;
#line 37 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
	if ((&_vala_errmsg) != NULL) {
#line 358 "DatabaseTable.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 38 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
		_tmp2_ = sqlite_errmsg;
#line 38 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
		_tmp3_ = g_strdup (_tmp2_);
#line 38 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 38 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
		_vala_errmsg = _tmp3_;
#line 369 "DatabaseTable.c"
	}
#line 40 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
	_tmp4_ = sqlite_errmsg;
#line 40 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
	sqlite3_free ((void*) _tmp4_);
#line 41 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
	result = ec;
#line 41 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
	if (errmsg) {
#line 41 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
		*errmsg = _vala_errmsg;
#line 381 "DatabaseTable.c"
	} else {
#line 41 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 385 "DatabaseTable.c"
	}
#line 41 "/usr/share/vala-0.40/vapi/sqlite3.vapi"
	return result;
#line 389 "DatabaseTable.c"
}


void
database_table_init (const gchar* filename)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	sqlite3* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_if_fail (filename != NULL);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	database_table_prepare_db (filename);
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_warning ("DatabaseTable.vala:70: NAME: %s", filename);
#line 74 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 74 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "CREATE TABLE IF NOT EXISTS VersionTable (" "id INTEGER PRIMARY KEY, " "schema_version INTEGER, " "app_version TEXT, " "user_data TEXT NULL" ")", -1, &_tmp1_, NULL);
#line 74 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 74 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	stmt = _tmp1_;
#line 74 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = _tmp2_;
#line 82 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp3_ = res;
#line 82 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (_tmp3_ != SQLITE_OK) {
#line 425 "DatabaseTable.c"
		gchar* backup_path = NULL;
		gchar* _tmp4_;
		gchar* cmdline = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_sqlite3_close0 (database_table_db);
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		database_table_db = NULL;
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp4_ = g_strconcat (filename, ".bak", NULL);
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		backup_path = _tmp4_;
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp5_ = backup_path;
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp6_ = g_strconcat ("cp ", _tmp5_, NULL);
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp7_ = _tmp6_;
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp8_ = g_strconcat (_tmp7_, " ", NULL);
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp9_ = _tmp8_;
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp10_ = g_strconcat (_tmp9_, filename, NULL);
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp11_ = _tmp10_;
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_g_free0 (_tmp9_);
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_g_free0 (_tmp7_);
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		cmdline = _tmp11_;
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp12_ = cmdline;
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		system (_tmp12_);
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		database_table_prepare_db (filename);
#line 82 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_g_free0 (cmdline);
#line 82 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_g_free0 (backup_path);
#line 475 "DatabaseTable.c"
	}
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp13_ = database_table_db;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp14_ = _sqlite3_exec (_tmp13_, "PRAGMA synchronous=OFF", NULL, NULL, NULL);
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = _tmp14_;
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp15_ = res;
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (_tmp15_ != SQLITE_OK) {
#line 487 "DatabaseTable.c"
		gint _tmp16_;
#line 96 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp16_ = res;
#line 96 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		database_table_warning ("Unable to disable synchronous mode", _tmp16_);
#line 493 "DatabaseTable.c"
	}
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 497 "DatabaseTable.c"
}


void
database_table_terminate (void)
{
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_close0 (database_table_db);
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	database_table_db = NULL;
#line 508 "DatabaseTable.c"
}


void
database_table_fatal (const gchar* op,
                      gint res)
{
	sqlite3* _tmp0_;
	const gchar* _tmp1_;
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_if_fail (op != NULL);
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp1_ = sqlite3_errmsg (_tmp0_);
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_error ("DatabaseTable.vala:106: %s: [%d] %s", op, res, _tmp1_);
#line 526 "DatabaseTable.c"
}


void
database_table_warning (const gchar* op,
                        gint res)
{
	sqlite3* _tmp0_;
	const gchar* _tmp1_;
#line 110 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_if_fail (op != NULL);
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp1_ = sqlite3_errmsg (_tmp0_);
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_warning ("DatabaseTable.vala:111: %s: [%d] %s", op, res, _tmp1_);
#line 544 "DatabaseTable.c"
}


void
database_table_set_table_name (DatabaseTable* self,
                               const gchar* table_name)
{
	gchar* _tmp0_;
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_if_fail (self != NULL);
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_if_fail (table_name != NULL);
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp0_ = g_strdup (table_name);
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_g_free0 (self->table_name);
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	self->table_name = _tmp0_;
#line 563 "DatabaseTable.c"
}


void
database_table_throw_error (const gchar* method,
                            gint res,
                            GError** error)
{
	gchar* msg = NULL;
	sqlite3* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	GError * _inner_error_ = NULL;
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_if_fail (method != NULL);
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp1_ = sqlite3_errmsg (_tmp0_);
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup_printf ("(%s) [%d] - %s", method, res, _tmp1_);
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	msg = _tmp2_;
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	switch (res) {
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_OK:
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_DONE:
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_ROW:
#line 595 "DatabaseTable.c"
		{
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_g_free0 (msg);
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			return;
#line 601 "DatabaseTable.c"
		}
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_PERM:
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_BUSY:
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_READONLY:
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_IOERR:
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_CORRUPT:
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_CANTOPEN:
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_NOLFS:
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_AUTH:
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_FORMAT:
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_NOTADB:
#line 623 "DatabaseTable.c"
		{
			const gchar* _tmp3_;
			GError* _tmp4_;
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_tmp3_ = msg;
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_tmp4_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_BACKING, _tmp3_);
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_inner_error_ = _tmp4_;
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error_);
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				return;
#line 641 "DatabaseTable.c"
			} else {
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error_);
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				return;
#line 651 "DatabaseTable.c"
			}
		}
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_NOMEM:
#line 656 "DatabaseTable.c"
		{
			const gchar* _tmp5_;
			GError* _tmp6_;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_tmp5_ = msg;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_tmp6_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_MEMORY, _tmp5_);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_inner_error_ = _tmp6_;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error_);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				return;
#line 674 "DatabaseTable.c"
			} else {
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error_);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				return;
#line 684 "DatabaseTable.c"
			}
		}
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_ABORT:
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_LOCKED:
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_INTERRUPT:
#line 693 "DatabaseTable.c"
		{
			const gchar* _tmp7_;
			GError* _tmp8_;
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_tmp7_ = msg;
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_tmp8_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_ABORT, _tmp7_);
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_inner_error_ = _tmp8_;
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error_);
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				return;
#line 711 "DatabaseTable.c"
			} else {
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error_);
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				return;
#line 721 "DatabaseTable.c"
			}
		}
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_FULL:
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_EMPTY:
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_TOOBIG:
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_CONSTRAINT:
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_RANGE:
#line 734 "DatabaseTable.c"
		{
			const gchar* _tmp9_;
			GError* _tmp10_;
#line 154 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_tmp9_ = msg;
#line 154 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_tmp10_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_LIMITS, _tmp9_);
#line 154 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_inner_error_ = _tmp10_;
#line 154 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 154 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error_);
#line 154 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 154 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				return;
#line 752 "DatabaseTable.c"
			} else {
#line 154 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 154 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 154 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error_);
#line 154 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				return;
#line 762 "DatabaseTable.c"
			}
		}
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_SCHEMA:
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_MISMATCH:
#line 769 "DatabaseTable.c"
		{
			const gchar* _tmp11_;
			GError* _tmp12_;
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_tmp11_ = msg;
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_tmp12_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_TYPESPEC, _tmp11_);
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_inner_error_ = _tmp12_;
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error_);
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				return;
#line 787 "DatabaseTable.c"
			} else {
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error_);
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				return;
#line 797 "DatabaseTable.c"
			}
		}
		default:
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_ERROR:
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_INTERNAL:
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		case SQLITE_MISUSE:
#line 807 "DatabaseTable.c"
		{
			const gchar* _tmp13_;
			GError* _tmp14_;
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_tmp13_ = msg;
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_tmp14_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_ERROR, _tmp13_);
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_inner_error_ = _tmp14_;
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error_);
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				return;
#line 825 "DatabaseTable.c"
			} else {
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error_);
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				return;
#line 835 "DatabaseTable.c"
			}
		}
	}
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_g_free0 (msg);
#line 841 "DatabaseTable.c"
}


sqlite3_stmt*
database_table_create_stmt (DatabaseTable* self,
                            const gchar* data)
{
	sqlite3_stmt* result = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_debug ("DatabaseTable.vala:169: Running statement: %s\n", data);
#line 172 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 172 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, data, -1, &_tmp1_, NULL);
#line 172 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 172 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	stmt = _tmp1_;
#line 172 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = _tmp2_;
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	database_table_assert_test (res == SQLITE_OK, data);
#line 175 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	result = stmt;
#line 175 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	return result;
#line 877 "DatabaseTable.c"
}


void
database_table_bind_text (sqlite3_stmt* stmt,
                          gint column,
                          const gchar* data)
{
	gint res = 0;
	gchar* _tmp0_;
	GDestroyNotify _tmp1_;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_if_fail (stmt != NULL);
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_if_fail (data != NULL);
#line 179 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp0_ = g_strdup (data);
#line 179 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp1_ = g_free;
#line 179 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = sqlite3_bind_text (stmt, column, _tmp0_, -1, _tmp1_);
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 901 "DatabaseTable.c"
}


void
database_table_bind_int (sqlite3_stmt* stmt,
                         gint column,
                         gint data)
{
	gint res = 0;
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_if_fail (stmt != NULL);
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = sqlite3_bind_int (stmt, column, data);
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 917 "DatabaseTable.c"
}


void
database_table_bind_int64 (sqlite3_stmt* stmt,
                           gint column,
                           gint64 data)
{
	gint res = 0;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_if_fail (stmt != NULL);
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = sqlite3_bind_int64 (stmt, column, data);
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 933 "DatabaseTable.c"
}


void
database_table_bind_double (sqlite3_stmt* stmt,
                            gint column,
                            gdouble data)
{
	gint res = 0;
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_if_fail (stmt != NULL);
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = sqlite3_bind_double (stmt, column, data);
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 949 "DatabaseTable.c"
}


static void
database_table_assert_test (gboolean condition,
                            const gchar* data)
{
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_if_fail (data != NULL);
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (!condition) {
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		g_error ("DatabaseTable.vala:200: SQL statement failed: %s\n", data);
#line 963 "DatabaseTable.c"
	}
}


gboolean
database_table_exists_by_id (DatabaseTable* self,
                             gint64 id)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	sqlite3_stmt* _tmp8_;
	gint _tmp9_;
	sqlite3_stmt* _tmp10_;
	gboolean _tmp11_ = FALSE;
	gint _tmp12_;
	gint _tmp20_;
#line 204 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp1_ = self->table_name;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup_printf ("SELECT id FROM %s WHERE id=?", _tmp1_);
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp3_ = _tmp2_;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp5_ = sqlite3_prepare_v2 (_tmp0_, _tmp3_, -1, &_tmp4_, NULL);
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	stmt = _tmp4_;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp6_ = _tmp5_;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_g_free0 (_tmp3_);
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = _tmp6_;
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp7_ = res;
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_vala_assert (_tmp7_ == SQLITE_OK, "res == Sqlite.OK");
#line 209 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp8_ = stmt;
#line 209 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = sqlite3_bind_int64 (_tmp8_, 1, id);
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp9_ = res;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_vala_assert (_tmp9_ == SQLITE_OK, "res == Sqlite.OK");
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp10_ = stmt;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp10_);
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp12_ = res;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (_tmp12_ != SQLITE_ROW) {
#line 1031 "DatabaseTable.c"
		gint _tmp13_;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp13_ = res;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp11_ = _tmp13_ != SQLITE_DONE;
#line 1037 "DatabaseTable.c"
	} else {
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp11_ = FALSE;
#line 1041 "DatabaseTable.c"
	}
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (_tmp11_) {
#line 1045 "DatabaseTable.c"
		gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gint _tmp19_;
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp14_ = g_strdup_printf ("%" G_GINT64_FORMAT, id);
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp15_ = _tmp14_;
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp16_ = self->table_name;
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp17_ = g_strdup_printf ("exists_by_id [%s] %s", _tmp15_, _tmp16_);
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp18_ = _tmp17_;
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp19_ = res;
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		database_table_fatal (_tmp18_, _tmp19_);
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_g_free0 (_tmp18_);
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_g_free0 (_tmp15_);
#line 1070 "DatabaseTable.c"
	}
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp20_ = res;
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	result = _tmp20_ == SQLITE_ROW;
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	return result;
#line 1080 "DatabaseTable.c"
}


gboolean
database_table_select_by_id (DatabaseTable* self,
                             gint64 id,
                             const gchar* columns,
                             sqlite3_stmt* * stmt)
{
	sqlite3_stmt* _vala_stmt = NULL;
	gboolean result = FALSE;
	gchar* sql = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gint res = 0;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_;
	gint _tmp8_;
	sqlite3_stmt* _tmp9_;
	gboolean _tmp10_ = FALSE;
	gint _tmp11_;
	gint _tmp19_;
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (columns != NULL, FALSE);
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp0_ = self->table_name;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp1_ = g_strdup_printf ("SELECT %s FROM %s WHERE id=?", columns, _tmp0_);
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	sql = _tmp1_;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp2_ = database_table_db;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp3_ = sql;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp5_ = sqlite3_prepare_v2 (_tmp2_, _tmp3_, -1, &_tmp4_, NULL);
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (_vala_stmt);
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_vala_stmt = _tmp4_;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = _tmp5_;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp6_ = res;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_vala_assert (_tmp6_ == SQLITE_OK, "res == Sqlite.OK");
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp7_ = _vala_stmt;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = sqlite3_bind_int64 (_tmp7_, 1, id);
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp8_ = res;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_vala_assert (_tmp8_ == SQLITE_OK, "res == Sqlite.OK");
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp9_ = _vala_stmt;
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp9_);
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp11_ = res;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (_tmp11_ != SQLITE_ROW) {
#line 1149 "DatabaseTable.c"
		gint _tmp12_;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp12_ = res;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp10_ = _tmp12_ != SQLITE_DONE;
#line 1155 "DatabaseTable.c"
	} else {
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp10_ = FALSE;
#line 1159 "DatabaseTable.c"
	}
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (_tmp10_) {
#line 1163 "DatabaseTable.c"
		gchar* _tmp13_;
		gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gint _tmp18_;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp13_ = g_strdup_printf ("%" G_GINT64_FORMAT, id);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp14_ = _tmp13_;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp15_ = self->table_name;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp16_ = g_strdup_printf ("select_by_id [%s] %s %s", _tmp14_, _tmp15_, columns);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp17_ = _tmp16_;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp18_ = res;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		database_table_fatal (_tmp17_, _tmp18_);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_g_free0 (_tmp17_);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_g_free0 (_tmp14_);
#line 1188 "DatabaseTable.c"
	}
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp19_ = res;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	result = _tmp19_ == SQLITE_ROW;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_g_free0 (sql);
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (stmt) {
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		*stmt = _vala_stmt;
#line 1200 "DatabaseTable.c"
	} else {
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_sqlite3_finalize0 (_vala_stmt);
#line 1204 "DatabaseTable.c"
	}
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	return result;
#line 1208 "DatabaseTable.c"
}


static void
database_table_prepare_update_by_id (DatabaseTable* self,
                                     gint64 id,
                                     const gchar* column,
                                     sqlite3_stmt* * stmt)
{
	sqlite3_stmt* _vala_stmt = NULL;
	gchar* sql = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gint res = 0;
	sqlite3* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
#line 236 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_if_fail (self != NULL);
#line 236 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_if_fail (column != NULL);
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp0_ = self->table_name;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp1_ = g_strdup_printf ("UPDATE %s SET %s=? WHERE id=?", _tmp0_, column);
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	sql = _tmp1_;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp2_ = database_table_db;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp2_, sql, -1, &_tmp3_, NULL);
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (_vala_stmt);
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_vala_stmt = _tmp3_;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = _tmp4_;
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp5_ = res;
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_vala_assert (_tmp5_ == SQLITE_OK, "res == Sqlite.OK");
#line 242 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = sqlite3_bind_int64 (_vala_stmt, 2, id);
#line 243 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp6_ = res;
#line 243 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_vala_assert (_tmp6_ == SQLITE_OK, "res == Sqlite.OK");
#line 236 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_g_free0 (sql);
#line 236 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (stmt) {
#line 236 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		*stmt = _vala_stmt;
#line 1264 "DatabaseTable.c"
	} else {
#line 236 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_sqlite3_finalize0 (_vala_stmt);
#line 1268 "DatabaseTable.c"
	}
}


static gboolean
database_table_execute_update_by_id (DatabaseTable* self,
                                     sqlite3_stmt* stmt)
{
	gboolean result = FALSE;
	gint res = 0;
	gint _tmp0_;
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (stmt != NULL, FALSE);
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = sqlite3_step (stmt);
#line 248 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp0_ = res;
#line 248 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (_tmp0_ != SQLITE_DONE) {
#line 1290 "DatabaseTable.c"
		gint _tmp1_;
#line 249 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp1_ = res;
#line 249 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		database_table_fatal ("execute_update_by_id", _tmp1_);
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		result = FALSE;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		return result;
#line 1300 "DatabaseTable.c"
	}
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	result = TRUE;
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	return result;
#line 1306 "DatabaseTable.c"
}


gboolean
database_table_update_text_by_id (DatabaseTable* self,
                                  gint64 id,
                                  const gchar* column,
                                  const gchar* text)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint res = 0;
	gchar* _tmp1_;
	GDestroyNotify _tmp2_;
#line 257 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 257 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (column != NULL, FALSE);
#line 257 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	stmt = _tmp0_;
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp1_ = g_strdup (text);
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp2_ = g_free;
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = sqlite3_bind_text (stmt, 1, _tmp1_, -1, _tmp2_);
#line 262 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 264 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	result = database_table_execute_update_by_id (self, stmt);
#line 264 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 264 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	return result;
#line 1348 "DatabaseTable.c"
}


void
database_table_update_text_by_id_2 (DatabaseTable* self,
                                    gint64 id,
                                    const gchar* column,
                                    const gchar* text,
                                    GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	gchar* _tmp2_;
	GDestroyNotify _tmp3_;
	gint _tmp4_;
	sqlite3_stmt* _tmp5_;
	gint _tmp6_;
	GError * _inner_error_ = NULL;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_if_fail (self != NULL);
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_if_fail (column != NULL);
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_if_fail (text != NULL);
#line 269 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
#line 269 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 269 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	stmt = _tmp0_;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp1_ = stmt;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup (text);
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp3_ = g_free;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = sqlite3_bind_text (_tmp1_, 1, _tmp2_, -1, _tmp3_);
#line 272 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp4_ = res;
#line 272 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_vala_assert (_tmp4_ == SQLITE_OK, "res == Sqlite.OK");
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp5_ = stmt;
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp5_);
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp6_ = res;
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (_tmp6_ != SQLITE_DONE) {
#line 1401 "DatabaseTable.c"
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gint _tmp10_;
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp7_ = self->table_name;
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp8_ = g_strdup_printf ("DatabaseTable.update_text_by_id_2 %s.%s", _tmp7_, column);
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp9_ = _tmp8_;
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp10_ = res;
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		database_table_throw_error (_tmp9_, _tmp10_, &_inner_error_);
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_g_free0 (_tmp9_);
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error_);
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				return;
#line 1428 "DatabaseTable.c"
			} else {
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error_);
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				return;
#line 1438 "DatabaseTable.c"
			}
		}
	}
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1444 "DatabaseTable.c"
}


gboolean
database_table_update_int_by_id (DatabaseTable* self,
                                 gint64 id,
                                 const gchar* column,
                                 gint value)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint res = 0;
#line 279 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 279 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (column != NULL, FALSE);
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	stmt = _tmp0_;
#line 283 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = sqlite3_bind_int (stmt, 1, value);
#line 284 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	result = database_table_execute_update_by_id (self, stmt);
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	return result;
#line 1478 "DatabaseTable.c"
}


void
database_table_update_int_by_id_2 (DatabaseTable* self,
                                   gint64 id,
                                   const gchar* column,
                                   gint value,
                                   GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	gint _tmp4_;
	GError * _inner_error_ = NULL;
#line 289 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_if_fail (self != NULL);
#line 289 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_if_fail (column != NULL);
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	stmt = _tmp0_;
#line 293 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp1_ = stmt;
#line 293 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = sqlite3_bind_int (_tmp1_, 1, value);
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp2_ = res;
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_vala_assert (_tmp2_ == SQLITE_OK, "res == Sqlite.OK");
#line 296 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp3_ = stmt;
#line 296 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp3_);
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp4_ = res;
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (_tmp4_ != SQLITE_DONE) {
#line 1523 "DatabaseTable.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gint _tmp8_;
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp5_ = self->table_name;
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp6_ = g_strdup_printf ("DatabaseTable.update_int_by_id_2 %s.%s", _tmp5_, column);
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp7_ = _tmp6_;
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp8_ = res;
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		database_table_throw_error (_tmp7_, _tmp8_, &_inner_error_);
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_g_free0 (_tmp7_);
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error_);
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				return;
#line 1550 "DatabaseTable.c"
			} else {
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error_);
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				return;
#line 1560 "DatabaseTable.c"
			}
		}
	}
#line 289 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1566 "DatabaseTable.c"
}


gboolean
database_table_update_int64_by_id (DatabaseTable* self,
                                   gint64 id,
                                   const gchar* column,
                                   gint64 value)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint res = 0;
#line 301 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 301 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (column != NULL, FALSE);
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	stmt = _tmp0_;
#line 305 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = sqlite3_bind_int64 (stmt, 1, value);
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 308 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	result = database_table_execute_update_by_id (self, stmt);
#line 308 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 308 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	return result;
#line 1600 "DatabaseTable.c"
}


void
database_table_update_int64_by_id_2 (DatabaseTable* self,
                                     gint64 id,
                                     const gchar* column,
                                     gint64 value,
                                     GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	gint _tmp4_;
	GError * _inner_error_ = NULL;
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_if_fail (self != NULL);
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_if_fail (column != NULL);
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	stmt = _tmp0_;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp1_ = stmt;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = sqlite3_bind_int64 (_tmp1_, 1, value);
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp2_ = res;
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_vala_assert (_tmp2_ == SQLITE_OK, "res == Sqlite.OK");
#line 318 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp3_ = stmt;
#line 318 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp3_);
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp4_ = res;
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (_tmp4_ != SQLITE_DONE) {
#line 1645 "DatabaseTable.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gint _tmp8_;
#line 320 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp5_ = self->table_name;
#line 320 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp6_ = g_strdup_printf ("DatabaseTable.update_int64_by_id_2 %s.%s", _tmp5_, column);
#line 320 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp7_ = _tmp6_;
#line 320 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp8_ = res;
#line 320 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		database_table_throw_error (_tmp7_, _tmp8_, &_inner_error_);
#line 320 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_g_free0 (_tmp7_);
#line 320 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 320 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 320 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error_);
#line 320 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 320 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				return;
#line 1672 "DatabaseTable.c"
			} else {
#line 320 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 320 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 320 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error_);
#line 320 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				return;
#line 1682 "DatabaseTable.c"
			}
		}
	}
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1688 "DatabaseTable.c"
}


void
database_table_delete_by_id (DatabaseTable* self,
                             gint64 id,
                             GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	sqlite3_stmt* _tmp8_;
	gint _tmp9_;
	sqlite3_stmt* _tmp10_;
	gint _tmp11_;
	GError * _inner_error_ = NULL;
#line 323 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_if_fail (self != NULL);
#line 325 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 325 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp1_ = self->table_name;
#line 325 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup_printf ("DELETE FROM %s WHERE id=?", _tmp1_);
#line 325 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp3_ = _tmp2_;
#line 325 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp5_ = sqlite3_prepare_v2 (_tmp0_, _tmp3_, -1, &_tmp4_, NULL);
#line 325 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 325 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	stmt = _tmp4_;
#line 325 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp6_ = _tmp5_;
#line 325 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_g_free0 (_tmp3_);
#line 325 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = _tmp6_;
#line 326 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp7_ = res;
#line 326 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_vala_assert (_tmp7_ == SQLITE_OK, "res == Sqlite.OK");
#line 328 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp8_ = stmt;
#line 328 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = sqlite3_bind_int64 (_tmp8_, 1, id);
#line 329 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp9_ = res;
#line 329 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_vala_assert (_tmp9_ == SQLITE_OK, "res == Sqlite.OK");
#line 331 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp10_ = stmt;
#line 331 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp10_);
#line 332 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp11_ = res;
#line 332 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (_tmp11_ != SQLITE_DONE) {
#line 1754 "DatabaseTable.c"
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gint _tmp15_;
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp12_ = self->table_name;
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp13_ = g_strdup_printf ("%s.remove", _tmp12_);
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp14_ = _tmp13_;
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp15_ = res;
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		database_table_throw_error (_tmp14_, _tmp15_, &_inner_error_);
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_g_free0 (_tmp14_);
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error_);
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				return;
#line 1781 "DatabaseTable.c"
			} else {
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error_);
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				return;
#line 1791 "DatabaseTable.c"
			}
		}
	}
#line 323 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1797 "DatabaseTable.c"
}


gboolean
database_table_has_column (const gchar* table_name,
                           const gchar* column_name)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
#line 336 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (table_name != NULL, FALSE);
#line 336 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (column_name != NULL, FALSE);
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp1_ = g_strdup_printf ("PRAGMA table_info(%s)", table_name);
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp2_ = _tmp1_;
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp0_, _tmp2_, -1, &_tmp3_, NULL);
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	stmt = _tmp3_;
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp5_ = _tmp4_;
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_g_free0 (_tmp2_);
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = _tmp5_;
#line 339 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp6_ = res;
#line 339 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_vala_assert (_tmp6_ == SQLITE_OK, "res == Sqlite.OK");
#line 1841 "DatabaseTable.c"
	{
		gboolean _tmp7_ = FALSE;
#line 341 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp7_ = TRUE;
#line 341 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		while (TRUE) {
#line 1848 "DatabaseTable.c"
			sqlite3_stmt* _tmp8_;
			gint _tmp9_;
#line 341 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			if (!_tmp7_) {
#line 1853 "DatabaseTable.c"
			}
#line 341 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_tmp7_ = FALSE;
#line 342 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_tmp8_ = stmt;
#line 342 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			res = sqlite3_step (_tmp8_);
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			_tmp9_ = res;
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			if (_tmp9_ == SQLITE_DONE) {
#line 344 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				break;
#line 1867 "DatabaseTable.c"
			} else {
				gint _tmp10_;
#line 345 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				_tmp10_ = res;
#line 345 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				if (_tmp10_ != SQLITE_ROW) {
#line 1874 "DatabaseTable.c"
					gchar* _tmp11_;
					gchar* _tmp12_;
					gint _tmp13_;
#line 346 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
					_tmp11_ = g_strdup_printf ("has_column %s", table_name);
#line 346 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
					_tmp12_ = _tmp11_;
#line 346 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
					_tmp13_ = res;
#line 346 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
					database_table_fatal (_tmp12_, _tmp13_);
#line 346 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
					_g_free0 (_tmp12_);
#line 348 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
					break;
#line 1890 "DatabaseTable.c"
				} else {
					gchar* column = NULL;
					sqlite3_stmt* _tmp14_;
					const gchar* _tmp15_;
					gchar* _tmp16_;
					gboolean _tmp17_ = FALSE;
					const gchar* _tmp18_;
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
					_tmp14_ = stmt;
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
					_tmp15_ = sqlite3_column_text (_tmp14_, 1);
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
					_tmp16_ = g_strdup (_tmp15_);
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
					column = _tmp16_;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
					_tmp18_ = column;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
					if (_tmp18_ != NULL) {
#line 1910 "DatabaseTable.c"
						const gchar* _tmp19_;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
						_tmp19_ = column;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
						_tmp17_ = g_strcmp0 (_tmp19_, column_name) == 0;
#line 1916 "DatabaseTable.c"
					} else {
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
						_tmp17_ = FALSE;
#line 1920 "DatabaseTable.c"
					}
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
					if (_tmp17_) {
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
						result = TRUE;
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
						_g_free0 (column);
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
						_sqlite3_finalize0 (stmt);
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
						return result;
#line 1932 "DatabaseTable.c"
					}
#line 345 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
					_g_free0 (column);
#line 1936 "DatabaseTable.c"
				}
			}
		}
	}
#line 356 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	result = FALSE;
#line 356 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 356 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	return result;
#line 1947 "DatabaseTable.c"
}


gboolean
database_table_has_table (const gchar* table_name)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (table_name != NULL, FALSE);
#line 361 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 361 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp1_ = g_strdup_printf ("PRAGMA table_info(%s)", table_name);
#line 361 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp2_ = _tmp1_;
#line 361 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp0_, _tmp2_, -1, &_tmp3_, NULL);
#line 361 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 361 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	stmt = _tmp3_;
#line 361 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp5_ = _tmp4_;
#line 361 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_g_free0 (_tmp2_);
#line 361 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = _tmp5_;
#line 362 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp6_ = res;
#line 362 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_vala_assert (_tmp6_ == SQLITE_OK, "res == Sqlite.OK");
#line 364 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = sqlite3_step (stmt);
#line 366 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp7_ = res;
#line 366 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	result = _tmp7_ != SQLITE_DONE;
#line 366 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 366 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	return result;
#line 1999 "DatabaseTable.c"
}


gboolean
database_table_add_column (const gchar* table_name,
                           const gchar* column_name,
                           const gchar* column_constraints)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_;
	gint _tmp8_;
#line 369 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (table_name != NULL, FALSE);
#line 369 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (column_name != NULL, FALSE);
#line 369 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (column_constraints != NULL, FALSE);
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp1_ = g_strdup_printf ("ALTER TABLE %s ADD COLUMN %s %s", table_name, column_name, column_constraints);
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp2_ = _tmp1_;
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp0_, _tmp2_, -1, &_tmp3_, NULL);
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	stmt = _tmp3_;
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp5_ = _tmp4_;
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_g_free0 (_tmp2_);
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = _tmp5_;
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp6_ = res;
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_vala_assert (_tmp6_ == SQLITE_OK, "res == Sqlite.OK");
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp7_ = stmt;
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp7_);
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp8_ = res;
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (_tmp8_ != SQLITE_DONE) {
#line 2056 "DatabaseTable.c"
		gint _tmp9_;
		sqlite3* _tmp10_;
		const gchar* _tmp11_;
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp9_ = res;
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp10_ = database_table_db;
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp11_ = sqlite3_errmsg (_tmp10_);
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		g_critical ("DatabaseTable.vala:377: Unable to add column %s %s %s: (%d) %s", table_name, column_name, column_constraints, _tmp9_, _tmp11_);
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		result = FALSE;
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_sqlite3_finalize0 (stmt);
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		return result;
#line 2074 "DatabaseTable.c"
	}
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	result = TRUE;
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	return result;
#line 2082 "DatabaseTable.c"
}


gboolean
database_table_ensure_column (const gchar* table_name,
                              const gchar* column_name,
                              const gchar* column_constraints,
                              const gchar* upgrade_msg)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 389 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (table_name != NULL, FALSE);
#line 389 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (column_name != NULL, FALSE);
#line 389 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (column_constraints != NULL, FALSE);
#line 389 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (upgrade_msg != NULL, FALSE);
#line 391 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (!database_table_has_table (table_name)) {
#line 391 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp0_ = TRUE;
#line 2106 "DatabaseTable.c"
	} else {
#line 391 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp0_ = database_table_has_column (table_name, column_name);
#line 2110 "DatabaseTable.c"
	}
#line 391 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (_tmp0_) {
#line 392 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		result = TRUE;
#line 392 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		return result;
#line 2118 "DatabaseTable.c"
	}
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_message ("DatabaseTable.vala:394: %s", upgrade_msg);
#line 396 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	result = database_table_add_column (table_name, column_name, column_constraints);
#line 396 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	return result;
#line 2126 "DatabaseTable.c"
}


gint
database_table_get_row_count (DatabaseTable* self)
{
	gint result = 0;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	sqlite3_stmt* _tmp8_;
	gint _tmp9_;
	sqlite3_stmt* _tmp14_;
#line 399 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp1_ = self->table_name;
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup_printf ("SELECT COUNT(id) AS RowCount FROM %s", _tmp1_);
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp3_ = _tmp2_;
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp5_ = sqlite3_prepare_v2 (_tmp0_, _tmp3_, -1, &_tmp4_, NULL);
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	stmt = _tmp4_;
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp6_ = _tmp5_;
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_g_free0 (_tmp3_);
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = _tmp6_;
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp7_ = res;
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_vala_assert (_tmp7_ == SQLITE_OK, "res == Sqlite.OK");
#line 404 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp8_ = stmt;
#line 404 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp8_);
#line 405 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp9_ = res;
#line 405 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (_tmp9_ != SQLITE_ROW) {
#line 2181 "DatabaseTable.c"
		const gchar* _tmp10_;
		gint _tmp11_;
		sqlite3* _tmp12_;
		const gchar* _tmp13_;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp10_ = self->table_name;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp11_ = res;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp12_ = database_table_db;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp13_ = sqlite3_errmsg (_tmp12_);
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		g_critical ("DatabaseTable.vala:406: Unable to retrieve row count on %s: (%d) %s", _tmp10_, _tmp11_, _tmp13_);
#line 408 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		result = 0;
#line 408 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_sqlite3_finalize0 (stmt);
#line 408 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		return result;
#line 2202 "DatabaseTable.c"
	}
#line 411 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp14_ = stmt;
#line 411 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	result = sqlite3_column_int (_tmp14_, 0);
#line 411 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 411 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	return result;
#line 2212 "DatabaseTable.c"
}


void
database_table_begin_transaction (void)
{
	gint _tmp0_;
	gint res = 0;
	sqlite3* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 416 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp0_ = database_table_in_transaction;
#line 416 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	database_table_in_transaction = _tmp0_ + 1;
#line 416 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (_tmp0_ != 0) {
#line 417 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		return;
#line 2232 "DatabaseTable.c"
	}
#line 419 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp1_ = database_table_db;
#line 419 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp2_ = _sqlite3_exec (_tmp1_, "BEGIN TRANSACTION", NULL, NULL, NULL);
#line 419 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = _tmp2_;
#line 420 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp3_ = res;
#line 420 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 2244 "DatabaseTable.c"
}


void
database_table_commit_transaction (GError** error)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint res = 0;
	sqlite3* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GError * _inner_error_ = NULL;
#line 425 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp0_ = database_table_in_transaction;
#line 425 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_vala_assert (_tmp0_ > 0, "in_transaction > 0");
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp1_ = database_table_in_transaction;
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	database_table_in_transaction = _tmp1_ - 1;
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp2_ = database_table_in_transaction;
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (_tmp2_ != 0) {
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		return;
#line 2273 "DatabaseTable.c"
	}
#line 429 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp3_ = database_table_db;
#line 429 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp4_ = _sqlite3_exec (_tmp3_, "COMMIT TRANSACTION", NULL, NULL, NULL);
#line 429 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	res = _tmp4_;
#line 430 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_tmp5_ = res;
#line 430 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (_tmp5_ != SQLITE_DONE) {
#line 2285 "DatabaseTable.c"
		gint _tmp6_;
#line 431 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		_tmp6_ = res;
#line 431 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		database_table_throw_error ("commit_transaction", _tmp6_, &_inner_error_);
#line 431 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 431 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 431 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error_);
#line 431 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				return;
#line 2299 "DatabaseTable.c"
			} else {
#line 431 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 431 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error_);
#line 431 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
				return;
#line 2307 "DatabaseTable.c"
			}
		}
	}
}


DatabaseTable*
database_table_construct (GType object_type)
{
	DatabaseTable* self = NULL;
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	self = (DatabaseTable*) g_type_create_instance (object_type);
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	return self;
#line 2322 "DatabaseTable.c"
}


static void
value_database_table_init (GValue* value)
{
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	value->data[0].v_pointer = NULL;
#line 2331 "DatabaseTable.c"
}


static void
value_database_table_free_value (GValue* value)
{
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (value->data[0].v_pointer) {
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		database_table_unref (value->data[0].v_pointer);
#line 2342 "DatabaseTable.c"
	}
}


static void
value_database_table_copy_value (const GValue* src_value,
                                 GValue* dest_value)
{
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (src_value->data[0].v_pointer) {
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		dest_value->data[0].v_pointer = database_table_ref (src_value->data[0].v_pointer);
#line 2355 "DatabaseTable.c"
	} else {
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2359 "DatabaseTable.c"
	}
}


static gpointer
value_database_table_peek_pointer (const GValue* value)
{
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	return value->data[0].v_pointer;
#line 2369 "DatabaseTable.c"
}


static gchar*
value_database_table_collect_value (GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (collect_values[0].v_pointer) {
#line 2381 "DatabaseTable.c"
		DatabaseTable * object;
		object = collect_values[0].v_pointer;
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2388 "DatabaseTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2392 "DatabaseTable.c"
		}
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		value->data[0].v_pointer = database_table_ref (object);
#line 2396 "DatabaseTable.c"
	} else {
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		value->data[0].v_pointer = NULL;
#line 2400 "DatabaseTable.c"
	}
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	return NULL;
#line 2404 "DatabaseTable.c"
}


static gchar*
value_database_table_lcopy_value (const GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	DatabaseTable ** object_p;
	object_p = collect_values[0].v_pointer;
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (!object_p) {
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2420 "DatabaseTable.c"
	}
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (!value->data[0].v_pointer) {
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		*object_p = NULL;
#line 2426 "DatabaseTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		*object_p = value->data[0].v_pointer;
#line 2430 "DatabaseTable.c"
	} else {
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		*object_p = database_table_ref (value->data[0].v_pointer);
#line 2434 "DatabaseTable.c"
	}
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	return NULL;
#line 2438 "DatabaseTable.c"
}


GParamSpec*
param_spec_database_table (const gchar* name,
                           const gchar* nick,
                           const gchar* blurb,
                           GType object_type,
                           GParamFlags flags)
{
	ParamSpecDatabaseTable* spec;
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_DATABASE_TABLE), NULL);
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	return G_PARAM_SPEC (spec);
#line 2458 "DatabaseTable.c"
}


gpointer
value_get_database_table (const GValue* value)
{
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATABASE_TABLE), NULL);
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	return value->data[0].v_pointer;
#line 2469 "DatabaseTable.c"
}


void
value_set_database_table (GValue* value,
                          gpointer v_object)
{
	DatabaseTable * old;
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATABASE_TABLE));
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	old = value->data[0].v_pointer;
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (v_object) {
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATABASE_TABLE));
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		value->data[0].v_pointer = v_object;
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		database_table_ref (value->data[0].v_pointer);
#line 2492 "DatabaseTable.c"
	} else {
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		value->data[0].v_pointer = NULL;
#line 2496 "DatabaseTable.c"
	}
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (old) {
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		database_table_unref (old);
#line 2502 "DatabaseTable.c"
	}
}


void
value_take_database_table (GValue* value,
                           gpointer v_object)
{
	DatabaseTable * old;
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATABASE_TABLE));
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	old = value->data[0].v_pointer;
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (v_object) {
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATABASE_TABLE));
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		value->data[0].v_pointer = v_object;
#line 2524 "DatabaseTable.c"
	} else {
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		value->data[0].v_pointer = NULL;
#line 2528 "DatabaseTable.c"
	}
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (old) {
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		database_table_unref (old);
#line 2534 "DatabaseTable.c"
	}
}


static void
database_table_class_init (DatabaseTableClass * klass)
{
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	database_table_parent_class = g_type_class_peek_parent (klass);
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	((DatabaseTableClass *) klass)->finalize = database_table_finalize;
#line 2546 "DatabaseTable.c"
}


static void
database_table_instance_init (DatabaseTable * self)
{
#line 43 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	self->table_name = NULL;
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	self->ref_count = 1;
#line 2557 "DatabaseTable.c"
}


static void
database_table_finalize (DatabaseTable * obj)
{
	DatabaseTable * self;
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DATABASE_TABLE, DatabaseTable);
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_signal_handlers_destroy (self);
#line 43 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	_g_free0 (self->table_name);
#line 2571 "DatabaseTable.c"
}


GType
database_table_get_type (void)
{
	static volatile gsize database_table_type_id__volatile = 0;
	if (g_once_init_enter (&database_table_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_database_table_init, value_database_table_free_value, value_database_table_copy_value, value_database_table_peek_pointer, "p", value_database_table_collect_value, "p", value_database_table_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DatabaseTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) database_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DatabaseTable), 0, (GInstanceInitFunc) database_table_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType database_table_type_id;
		database_table_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DatabaseTable", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&database_table_type_id__volatile, database_table_type_id);
	}
	return database_table_type_id__volatile;
}


gpointer
database_table_ref (gpointer instance)
{
	DatabaseTable * self;
	self = instance;
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	return instance;
#line 2600 "DatabaseTable.c"
}


void
database_table_unref (gpointer instance)
{
	DatabaseTable * self;
	self = instance;
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		DATABASE_TABLE_GET_CLASS (self)->finalize (self);
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/db/DatabaseTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2615 "DatabaseTable.c"
	}
}



