/* DataSource.c generated by valac 0.40.6, the Vala compiler
 * generated from DataSource.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/**/
/* DataSource*/
/**/
/* A DataSource is an object that is unique throughout the system.  DataSources*/
/* commonly have external and/or persistent representations, hence they have a notion of being*/
/* destroyed (versus removed or freed).  Several DataViews may exist that reference a single*/
/* DataSource.  Note that DataSources MUST be destroyed (rather than simply removed) from their*/
/* SourceCollection, and that they MUST be destroyed via their SourceCollection (rather than*/
/* calling DataSource.destroy () directly.)*/
/**/
/* Destroying a DataSource indicates it should remove all secondary and tertiary structures (such*/
/* as thumbnails) and any records pointing to its backing store.  SourceCollection.destroy_marked ()*/
/* has a parameter indicating if the backing should be destroyed as well; that is when*/
/* internal_delete_backing () is called.*/
/**/
/* There are no provisions (currently) for a DataSource to be removed from its SourceCollection*/
/* without destroying its backing and/or secondary and tertiary structures.  DataSources are intended*/
/* to go to the grave with their SourceCollection otherwise.  If a need arises for a DataSource to*/
/* be peaceably removed from its SourceCollection, code will need to be written.  SourceSnapshots*/
/* may be one solution to this problem.*/
/**/
/* Some DataSources cannot be reconstituted (for example, if its backing file is deleted).  In*/
/* that case, dehydrate () should return null.  When reconstituted, it is the responsibility of the*/
/* implementation to ensure an exact clone is produced, minus any details that are not relevant or*/
/* exposed (such as a database ID).*/
/**/
/* If other DataSources refer to this DataSource, their state will *not* be*/
/* saved/restored.  This must be achieved via other means.  However, implementations *should**/
/* track when changes to external state would break the proxy and call notify_broken ();*/
/**/


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>


#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;
typedef struct _DataObjectPrivate DataObjectPrivate;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;
typedef struct _DataSourcePrivate DataSourcePrivate;

#define TYPE_SOURCE_HOLDING_TANK (source_holding_tank_get_type ())
#define SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank))
#define SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))
#define IS_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_HOLDING_TANK))
#define IS_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_HOLDING_TANK))
#define SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))

typedef struct _SourceHoldingTank SourceHoldingTank;
typedef struct _SourceHoldingTankClass SourceHoldingTankClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_SOURCE_SNAPSHOT (source_snapshot_get_type ())
#define SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshot))
#define SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))
#define IS_SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_SNAPSHOT))
#define IS_SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_SNAPSHOT))
#define SOURCE_SNAPSHOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))

typedef struct _SourceSnapshot SourceSnapshot;
typedef struct _SourceSnapshotClass SourceSnapshotClass;

#define TYPE_DATA_VIEW (data_view_get_type ())
#define DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_VIEW, DataView))
#define DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_VIEW, DataViewClass))
#define IS_DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_VIEW))
#define IS_DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_VIEW))
#define DATA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_VIEW, DataViewClass))

typedef struct _DataView DataView;
typedef struct _DataViewClass DataViewClass;
enum  {
	DATA_SOURCE_0_PROPERTY,
	DATA_SOURCE_NUM_PROPERTIES
};
static GParamSpec* data_source_properties[DATA_SOURCE_NUM_PROPERTIES];
#define _source_holding_tank_unref0(var) ((var == NULL) ? NULL : (var = (source_holding_tank_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;
#define _source_backlink_unref0(var) ((var == NULL) ? NULL : (var = (source_backlink_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	DATA_SOURCE_UNLINKED_SIGNAL,
	DATA_SOURCE_RELINKED_SIGNAL,
	DATA_SOURCE_DESTROYED_SIGNAL,
	DATA_SOURCE_NUM_SIGNALS
};
static guint data_source_signals[DATA_SOURCE_NUM_SIGNALS] = {0};
typedef struct _SourceSnapshotPrivate SourceSnapshotPrivate;
typedef struct _ParamSpecSourceSnapshot ParamSpecSourceSnapshot;
enum  {
	SOURCE_SNAPSHOT_BROKEN_SIGNAL,
	SOURCE_SNAPSHOT_NUM_SIGNALS
};
static guint source_snapshot_signals[SOURCE_SNAPSHOT_NUM_SIGNALS] = {0};
typedef struct _SourceBacklinkPrivate SourceBacklinkPrivate;
typedef struct _ParamSpecSourceBacklink ParamSpecSourceBacklink;

#define TYPE_SOURCE_PROXY (source_proxy_get_type ())
#define SOURCE_PROXY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_PROXY, SourceProxy))
#define SOURCE_PROXY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_PROXY, SourceProxyClass))
#define IS_SOURCE_PROXY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_PROXY))
#define IS_SOURCE_PROXY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_PROXY))
#define SOURCE_PROXY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_PROXY, SourceProxyClass))

typedef struct _SourceProxy SourceProxy;
typedef struct _SourceProxyClass SourceProxyClass;
typedef struct _SourceProxyPrivate SourceProxyPrivate;
#define _source_snapshot_unref0(var) ((var == NULL) ? NULL : (var = (source_snapshot_unref (var), NULL)))
typedef struct _ParamSpecSourceProxy ParamSpecSourceProxy;
enum  {
	SOURCE_PROXY_RECONSTITUTED_SIGNAL,
	SOURCE_PROXY_DEHYDRATED_SIGNAL,
	SOURCE_PROXY_BROKEN_SIGNAL,
	SOURCE_PROXY_NUM_SIGNALS
};
static guint source_proxy_signals[SOURCE_PROXY_NUM_SIGNALS] = {0};

#define TYPE_PROXYABLE (proxyable_get_type ())
#define PROXYABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROXYABLE, Proxyable))
#define IS_PROXYABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROXYABLE))
#define PROXYABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_PROXYABLE, ProxyableIface))

typedef struct _Proxyable Proxyable;
typedef struct _ProxyableIface ProxyableIface;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _DataObject {
	GObject parent_instance;
	DataObjectPrivate * priv;
};

struct _DataObjectClass {
	GObjectClass parent_class;
	void (*notify_altered) (DataObject* self, Alteration* alteration);
	void (*notify_membership_changed) (DataObject* self, DataCollection* collection);
	void (*notify_collection_property_set) (DataObject* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_collection_property_cleared) (DataObject* self, const gchar* name);
	gchar* (*get_name) (DataObject* self);
	gchar* (*to_string) (DataObject* self);
};

struct _DataSource {
	DataObject parent_instance;
	DataSourcePrivate * priv;
};

struct _DataSourceClass {
	DataObjectClass parent_class;
	void (*notify_held_in_tank) (DataSource* self, SourceHoldingTank* holding_tank);
	void (*notify_unlinking) (DataSource* self, SourceCollection* collection);
	void (*notify_unlinked) (DataSource* self);
	void (*notify_relinking) (DataSource* self, SourceCollection* collection);
	void (*notify_relinked) (DataSource* self);
	gchar* (*get_typename) (DataSource* self);
	gint64 (*get_instance_id) (DataSource* self);
	gchar* (*get_source_id) (DataSource* self);
	void (*commit_backlinks) (DataSource* self, SourceCollection* sources, const gchar* dehydrated);
	SourceSnapshot* (*save_snapshot) (DataSource* self);
	gboolean (*internal_delete_backing) (DataSource* self, GError** error);
	gboolean (*equals) (DataSource* self, DataSource* source);
	void (*destroy) (DataSource* self);
	void (*unlinked) (DataSource* self, SourceCollection* sources);
	void (*relinked) (DataSource* self, SourceCollection* sources);
	void (*destroyed) (DataSource* self);
};

struct _DataSourcePrivate {
	DataView** subscribers;
	gint subscribers_length1;
	gint _subscribers_size_;
	SourceHoldingTank* holding_tank;
	SourceCollection* unlinked_from_collection;
	GeeHashMap* backlinks;
	gboolean in_contact;
	gboolean marked_for_destroy;
	gboolean is_destroyed;
};

typedef void (*DataSourceContactSubscriber) (DataView* view, void* user_data);
typedef void (*DataSourceContactSubscriberAlteration) (DataView* view, Alteration* alteration, void* user_data);
struct _SourceSnapshot {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceSnapshotPrivate * priv;
};

struct _SourceSnapshotClass {
	GTypeClass parent_class;
	void (*finalize) (SourceSnapshot *self);
	void (*notify_broken) (SourceSnapshot* self);
	void (*broken) (SourceSnapshot* self);
};

struct _SourceSnapshotPrivate {
	gboolean snapshot_broken;
};

struct _ParamSpecSourceSnapshot {
	GParamSpec parent_instance;
};

struct _SourceBacklink {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceBacklinkPrivate * priv;
};

struct _SourceBacklinkClass {
	GTypeClass parent_class;
	void (*finalize) (SourceBacklink *self);
};

struct _SourceBacklinkPrivate {
	gchar* _name;
	gchar* _value;
};

struct _ParamSpecSourceBacklink {
	GParamSpec parent_instance;
};

struct _SourceProxy {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceProxyPrivate * priv;
};

struct _SourceProxyClass {
	GTypeClass parent_class;
	void (*finalize) (SourceProxy *self);
	DataSource* (*reconstitute) (SourceProxy* self, gint64 object_id, SourceSnapshot* snapshot);
	void (*notify_reconstituted) (SourceProxy* self, DataSource* source);
	void (*notify_dehydrated) (SourceProxy* self);
	void (*notify_broken) (SourceProxy* self);
	void (*reconstituted) (SourceProxy* self, DataSource* source);
	void (*dehydrated) (SourceProxy* self);
	void (*broken) (SourceProxy* self);
};

struct _SourceProxyPrivate {
	gint64 object_id;
	gchar* source_string;
	DataSource* source;
	SourceSnapshot* snapshot;
	SourceCollection* membership;
};

struct _ParamSpecSourceProxy {
	GParamSpec parent_instance;
};

struct _ProxyableIface {
	GTypeInterface parent_iface;
	SourceProxy* (*get_proxy) (Proxyable* self);
};


static gpointer data_source_parent_class = NULL;
static gpointer source_snapshot_parent_class = NULL;
static gpointer source_backlink_parent_class = NULL;
static gpointer source_proxy_parent_class = NULL;

GType data_object_get_type (void) G_GNUC_CONST;
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_alteration (GValue* value,
                           gpointer v_object);
void value_take_alteration (GValue* value,
                            gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_data_collection (GValue* value,
                                gpointer v_object);
void value_take_data_collection (GValue* value,
                                 gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
gpointer source_holding_tank_ref (gpointer instance);
void source_holding_tank_unref (gpointer instance);
GParamSpec* param_spec_source_holding_tank (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
void value_set_source_holding_tank (GValue* value,
                                    gpointer v_object);
void value_take_source_holding_tank (GValue* value,
                                     gpointer v_object);
gpointer value_get_source_holding_tank (const GValue* value);
GType source_holding_tank_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
gpointer source_snapshot_ref (gpointer instance);
void source_snapshot_unref (gpointer instance);
GParamSpec* param_spec_source_snapshot (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_source_snapshot (GValue* value,
                                gpointer v_object);
void value_take_source_snapshot (GValue* value,
                                 gpointer v_object);
gpointer value_get_source_snapshot (const GValue* value);
GType source_snapshot_get_type (void) G_GNUC_CONST;
GType data_view_get_type (void) G_GNUC_CONST;
#define DATA_SOURCE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATA_SOURCE, DataSourcePrivate))
DataSource* data_source_construct (GType object_type,
                                   gint64 object_id);
DataObject* data_object_construct (GType object_type,
                                   gint64 object_id);
static void data_source_real_notify_membership_changed (DataObject* base,
                                                 DataCollection* collection);
void data_source_notify_unlinked (DataSource* self);
void data_object_notify_membership_changed (DataObject* self,
                                            DataCollection* collection);
void data_source_notify_held_in_tank (DataSource* self,
                                      SourceHoldingTank* holding_tank);
static void data_source_real_notify_held_in_tank (DataSource* self,
                                           SourceHoldingTank* holding_tank);
DataCollection* data_object_get_membership (DataObject* self);
static void data_source_real_notify_altered (DataObject* base,
                                      Alteration* alteration);
void source_holding_tank_internal_notify_altered (SourceHoldingTank* self,
                                                  DataSource* source,
                                                  Alteration* alteration);
void data_source_contact_subscribers_alteration (DataSource* self,
                                                 Alteration* alteration);
void data_object_notify_altered (DataObject* self,
                                 Alteration* alteration);
void data_source_notify_unlinking (DataSource* self,
                                   SourceCollection* collection);
static void data_source_real_notify_unlinking (DataSource* self,
                                        SourceCollection* collection);
static void data_source_real_notify_unlinked (DataSource* self);
void data_source_commit_backlinks (DataSource* self,
                                   SourceCollection* sources,
                                   const gchar* dehydrated);
static gchar* data_source_dehydrate_backlinks (DataSource* self);
void data_source_notify_relinking (DataSource* self,
                                   SourceCollection* collection);
static void data_source_real_notify_relinking (DataSource* self,
                                        SourceCollection* collection);
void data_source_notify_relinked (DataSource* self);
static void data_source_real_notify_relinked (DataSource* self);
gchar* data_source_get_typename (DataSource* self);
static gchar* data_source_real_get_typename (DataSource* self);
gint64 data_source_get_instance_id (DataSource* self);
static gint64 data_source_real_get_instance_id (DataSource* self);
gchar* data_source_get_source_id (DataSource* self);
static gchar* data_source_real_get_source_id (DataSource* self);
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_source_backlink (GValue* value,
                                gpointer v_object);
void value_take_source_backlink (GValue* value,
                                 gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
gboolean data_source_has_backlink (DataSource* self,
                                   SourceBacklink* backlink);
const gchar* source_backlink_get_name (SourceBacklink* self);
const gchar* source_backlink_get_value (SourceBacklink* self);
GeeList* data_source_get_backlinks (DataSource* self,
                                    const gchar* name);
SourceBacklink* source_backlink_new (const gchar* name,
                                     const gchar* value);
SourceBacklink* source_backlink_construct (GType object_type,
                                           const gchar* name,
                                           const gchar* value);
void data_source_set_backlink (DataSource* self,
                               SourceBacklink* backlink);
void source_collection_internal_backlink_set (SourceCollection* self,
                                              DataSource* source,
                                              SourceBacklink* backlink);
gboolean data_source_remove_backlink (DataSource* self,
                                      SourceBacklink* backlink);
void source_collection_internal_backlink_removed (SourceCollection* self,
                                                  DataSource* source,
                                                  SourceBacklink* backlink);
static void data_source_real_commit_backlinks (DataSource* self,
                                        SourceCollection* sources,
                                        const gchar* dehydrated);
gchar* data_object_to_string (DataObject* self);
gboolean is_string_empty (const gchar* s);
void data_source_rehydrate_backlinks (DataSource* self,
                                      SourceCollection* unlinked_from,
                                      const gchar* dehydrated);
SourceSnapshot* data_source_save_snapshot (DataSource* self);
static SourceSnapshot* data_source_real_save_snapshot (DataSource* self);
void data_source_internal_mark_for_destroy (DataSource* self);
gboolean data_source_internal_delete_backing (DataSource* self,
                                              GError** error);
static gboolean data_source_real_internal_delete_backing (DataSource* self,
                                                   GError** error);
gboolean data_source_equals (DataSource* self,
                             DataSource* source);
static gboolean data_source_real_equals (DataSource* self,
                                  DataSource* source);
void data_source_destroy (DataSource* self);
static void data_source_real_destroy (DataSource* self);
void data_view_notify_unsubscribed (DataView* self,
                                    DataSource* source);
gboolean data_source_destroy_orphan (DataSource* self,
                                     gboolean delete_backing);
void source_collection_notify_unlinked_destroyed (SourceCollection* self,
                                                  DataSource* unlinked);
void data_source_internal_subscribe (DataSource* self,
                                     DataView* view);
static void _vala_array_add135 (DataView** * array,
                         int* length,
                         int* size,
                         DataView* value);
void data_source_internal_unsubscribe (DataSource* self,
                                       DataView* view);
void data_source_contact_subscribers (DataSource* self,
                                      DataSourceContactSubscriber contact_subscriber,
                                      void* contact_subscriber_target);
static void data_source_real_unlinked (DataSource* self,
                                SourceCollection* sources);
static void g_cclosure_user_marshal_VOID__DATA_COLLECTION (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data);
static void data_source_real_relinked (DataSource* self,
                                SourceCollection* sources);
static void data_source_real_destroyed (DataSource* self);
static void data_source_finalize (GObject * obj);
#define SOURCE_SNAPSHOT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SOURCE_SNAPSHOT, SourceSnapshotPrivate))
void source_snapshot_notify_broken (SourceSnapshot* self);
static void source_snapshot_real_notify_broken (SourceSnapshot* self);
gboolean source_snapshot_is_broken (SourceSnapshot* self);
SourceSnapshot* source_snapshot_construct (GType object_type);
static void source_snapshot_real_broken (SourceSnapshot* self);
static void source_snapshot_finalize (SourceSnapshot * obj);
#define SOURCE_BACKLINK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SOURCE_BACKLINK, SourceBacklinkPrivate))
static gboolean source_backlink_validate_name_value (const gchar* name,
                                              const gchar* value);
SourceBacklink* source_backlink_new_from_source (DataSource* source);
SourceBacklink* source_backlink_construct_from_source (GType object_type,
                                                       DataSource* source);
gchar* source_backlink_to_string (SourceBacklink* self);
guint source_backlink_hash_func (SourceBacklink* backlink);
gboolean source_backlink_equal_func (SourceBacklink* alink,
                                     SourceBacklink* blink);
const gchar* source_backlink_get_typename (SourceBacklink* self);
gint64 source_backlink_get_instance_id (SourceBacklink* self);
static void source_backlink_finalize (SourceBacklink * obj);
gpointer source_proxy_ref (gpointer instance);
void source_proxy_unref (gpointer instance);
GParamSpec* param_spec_source_proxy (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
void value_set_source_proxy (GValue* value,
                             gpointer v_object);
void value_take_source_proxy (GValue* value,
                              gpointer v_object);
gpointer value_get_source_proxy (const GValue* value);
GType source_proxy_get_type (void) G_GNUC_CONST;
#define SOURCE_PROXY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SOURCE_PROXY, SourceProxyPrivate))
static void source_proxy_drop_source (SourceProxy* self);
static void source_proxy_on_source_added (SourceProxy* self,
                                   GeeIterable* added);
static void _source_proxy_on_source_added_data_collection_items_added (DataCollection* _sender,
                                                                GeeIterable* added,
                                                                gpointer self);
SourceProxy* source_proxy_construct (GType object_type,
                                     DataSource* source);
gint64 data_object_get_object_id (DataObject* self);
static void source_proxy_on_snapshot_broken (SourceProxy* self);
static void _source_proxy_on_snapshot_broken_source_snapshot_broken (SourceSnapshot* _sender,
                                                              gpointer self);
static void source_proxy_set_source (SourceProxy* self,
                              DataSource* source);
DataSource* source_proxy_reconstitute (SourceProxy* self,
                                       gint64 object_id,
                                       SourceSnapshot* snapshot);
static DataSource* source_proxy_real_reconstitute (SourceProxy* self,
                                            gint64 object_id,
                                            SourceSnapshot* snapshot);
void source_proxy_notify_reconstituted (SourceProxy* self,
                                        DataSource* source);
static void source_proxy_real_notify_reconstituted (SourceProxy* self,
                                             DataSource* source);
void source_proxy_notify_dehydrated (SourceProxy* self);
static void source_proxy_real_notify_dehydrated (SourceProxy* self);
void source_proxy_notify_broken (SourceProxy* self);
static void source_proxy_real_notify_broken (SourceProxy* self);
static void source_proxy_on_destroyed (SourceProxy* self);
static void _source_proxy_on_destroyed_data_source_destroyed (DataSource* _sender,
                                                       gpointer self);
DataSource* source_proxy_get_source (SourceProxy* self);
gboolean data_collection_contains (DataCollection* self,
                                   DataObject* object);
static void source_proxy_real_reconstituted (SourceProxy* self,
                                      DataSource* source);
static void source_proxy_real_dehydrated (SourceProxy* self);
static void source_proxy_real_broken (SourceProxy* self);
static void source_proxy_finalize (SourceProxy * obj);
GType proxyable_get_type (void) G_GNUC_CONST;
SourceProxy* proxyable_get_proxy (Proxyable* self);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


DataSource*
data_source_construct (GType object_type,
                       gint64 object_id)
{
	DataSource * self = NULL;
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self = (DataSource*) data_object_construct (object_type, object_id);
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return self;
#line 629 "DataSource.c"
}


static void
data_source_real_notify_membership_changed (DataObject* base,
                                            DataCollection* collection)
{
	DataSource * self;
	gboolean _tmp4_ = FALSE;
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self = (DataSource*) base;
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (collection == NULL) {
#line 643 "DataSource.c"
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp1_ = self->priv->is_destroyed;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		if (_tmp1_) {
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp0_ = TRUE;
#line 652 "DataSource.c"
		} else {
			GeeHashMap* _tmp2_;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp2_ = self->priv->backlinks;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp0_ = _tmp2_ != NULL;
#line 659 "DataSource.c"
		}
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_vala_assert (_tmp0_, "is_destroyed || backlinks != null");
#line 663 "DataSource.c"
	} else {
		gboolean _tmp3_;
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp3_ = self->priv->is_destroyed;
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_vala_assert (!_tmp3_, "!is_destroyed");
#line 670 "DataSource.c"
	}
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (collection == NULL) {
#line 674 "DataSource.c"
		GeeHashMap* _tmp5_;
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp5_ = self->priv->backlinks;
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp4_ = _tmp5_ != NULL;
#line 680 "DataSource.c"
	} else {
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp4_ = FALSE;
#line 684 "DataSource.c"
	}
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp4_) {
#line 96 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		data_source_notify_unlinked (self);
#line 690 "DataSource.c"
	}
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	DATA_OBJECT_CLASS (data_source_parent_class)->notify_membership_changed (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), collection);
#line 694 "DataSource.c"
}


static gpointer
_source_holding_tank_ref0 (gpointer self)
{
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return self ? source_holding_tank_ref (self) : NULL;
#line 703 "DataSource.c"
}


static void
data_source_real_notify_held_in_tank (DataSource* self,
                                      SourceHoldingTank* holding_tank)
{
	DataCollection* _tmp0_;
	DataCollection* _tmp1_;
	SourceHoldingTank* _tmp4_;
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = data_object_get_membership ((DataObject*) self);
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp1_ = _tmp0_;
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_vala_assert (_tmp1_ == NULL, "get_membership () == null");
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_data_collection_unref0 (_tmp1_);
#line 107 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (holding_tank != NULL) {
#line 724 "DataSource.c"
		SourceHoldingTank* _tmp2_;
#line 108 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp2_ = self->priv->holding_tank;
#line 108 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_vala_assert (_tmp2_ == NULL, "this.holding_tank == null");
#line 730 "DataSource.c"
	} else {
		SourceHoldingTank* _tmp3_;
#line 110 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp3_ = self->priv->holding_tank;
#line 110 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_vala_assert (_tmp3_ != NULL, "this.holding_tank != null");
#line 737 "DataSource.c"
	}
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp4_ = _source_holding_tank_ref0 (holding_tank);
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_source_holding_tank_unref0 (self->priv->holding_tank);
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->holding_tank = _tmp4_;
#line 745 "DataSource.c"
}


void
data_source_notify_held_in_tank (DataSource* self,
                                 SourceHoldingTank* holding_tank)
{
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	DATA_SOURCE_GET_CLASS (self)->notify_held_in_tank (self, holding_tank);
#line 757 "DataSource.c"
}


static void
data_source_real_notify_altered (DataObject* base,
                                 Alteration* alteration)
{
	DataSource * self;
	SourceHoldingTank* _tmp0_;
#line 116 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self = (DataSource*) base;
#line 116 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (alteration != NULL);
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = self->priv->holding_tank;
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp0_ != NULL) {
#line 775 "DataSource.c"
		SourceHoldingTank* _tmp1_;
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp1_ = self->priv->holding_tank;
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		source_holding_tank_internal_notify_altered (_tmp1_, self, alteration);
#line 781 "DataSource.c"
	} else {
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		data_source_contact_subscribers_alteration (self, alteration);
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		DATA_OBJECT_CLASS (data_source_parent_class)->notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), alteration);
#line 787 "DataSource.c"
	}
}


static void
data_source_real_notify_unlinking (DataSource* self,
                                   SourceCollection* collection)
{
	gboolean _tmp0_ = FALSE;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp3_;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (collection != NULL);
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp1_ = self->priv->backlinks;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp1_ == NULL) {
#line 805 "DataSource.c"
		SourceCollection* _tmp2_;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp2_ = self->priv->unlinked_from_collection;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 811 "DataSource.c"
	} else {
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp0_ = FALSE;
#line 815 "DataSource.c"
	}
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_vala_assert (_tmp0_, "backlinks == null && unlinked_from_collection == null");
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->unlinked_from_collection = collection;
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp3_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_g_object_unref0 (self->priv->backlinks);
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->backlinks = _tmp3_;
#line 827 "DataSource.c"
}


void
data_source_notify_unlinking (DataSource* self,
                              SourceCollection* collection)
{
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	DATA_SOURCE_GET_CLASS (self)->notify_unlinking (self, collection);
#line 839 "DataSource.c"
}


static void
data_source_real_notify_unlinked (DataSource* self)
{
	gboolean _tmp0_ = FALSE;
	SourceCollection* _tmp1_;
	SourceCollection* _tmp3_;
	GeeHashMap* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp1_ = self->priv->unlinked_from_collection;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp1_ != NULL) {
#line 856 "DataSource.c"
		GeeHashMap* _tmp2_;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp2_ = self->priv->backlinks;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 862 "DataSource.c"
	} else {
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp0_ = FALSE;
#line 866 "DataSource.c"
	}
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_vala_assert (_tmp0_, "unlinked_from_collection != null && backlinks != null");
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp3_ = self->priv->unlinked_from_collection;
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_signal_emit (self, data_source_signals[DATA_SOURCE_UNLINKED_SIGNAL], 0, _tmp3_);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp4_ = self->priv->backlinks;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp5_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp4_);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp6_ = _tmp5_;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp6_ > 0) {
#line 882 "DataSource.c"
		SourceCollection* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 143 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp7_ = self->priv->unlinked_from_collection;
#line 143 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp8_ = data_source_dehydrate_backlinks (self);
#line 143 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp9_ = _tmp8_;
#line 143 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		data_source_commit_backlinks (self, _tmp7_, _tmp9_);
#line 143 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_g_free0 (_tmp9_);
#line 896 "DataSource.c"
	}
}


void
data_source_notify_unlinked (DataSource* self)
{
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	DATA_SOURCE_GET_CLASS (self)->notify_unlinked (self);
#line 908 "DataSource.c"
}


static void
data_source_real_notify_relinking (DataSource* self,
                                   SourceCollection* collection)
{
	gboolean _tmp0_ = FALSE;
	GeeHashMap* _tmp1_;
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (collection != NULL);
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp1_ = self->priv->backlinks;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp1_ != NULL) {
#line 924 "DataSource.c"
		SourceCollection* _tmp2_;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp2_ = self->priv->unlinked_from_collection;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp0_ = _tmp2_ == collection;
#line 930 "DataSource.c"
	} else {
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp0_ = FALSE;
#line 934 "DataSource.c"
	}
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_vala_assert (_tmp0_, "(backlinks != null) && (unlinked_from_collection == collection)");
#line 938 "DataSource.c"
}


void
data_source_notify_relinking (DataSource* self,
                              SourceCollection* collection)
{
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	DATA_SOURCE_GET_CLASS (self)->notify_relinking (self, collection);
#line 950 "DataSource.c"
}


static gpointer
_data_collection_ref0 (gpointer self)
{
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return self ? data_collection_ref (self) : NULL;
#line 959 "DataSource.c"
}


static void
data_source_real_notify_relinked (DataSource* self)
{
	gboolean _tmp0_ = FALSE;
	GeeHashMap* _tmp1_;
	SourceCollection* relinked_to = NULL;
	SourceCollection* _tmp3_;
	SourceCollection* _tmp4_;
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp1_ = self->priv->backlinks;
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp1_ != NULL) {
#line 975 "DataSource.c"
		SourceCollection* _tmp2_;
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp2_ = self->priv->unlinked_from_collection;
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 981 "DataSource.c"
	} else {
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp0_ = FALSE;
#line 985 "DataSource.c"
	}
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_vala_assert (_tmp0_, "backlinks != null && unlinked_from_collection != null");
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp3_ = self->priv->unlinked_from_collection;
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp4_ = _data_collection_ref0 (_tmp3_);
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	relinked_to = _tmp4_;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_g_object_unref0 (self->priv->backlinks);
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->backlinks = NULL;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->unlinked_from_collection = NULL;
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_signal_emit (self, data_source_signals[DATA_SOURCE_RELINKED_SIGNAL], 0, relinked_to);
#line 161 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	data_source_commit_backlinks (self, NULL, NULL);
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_data_collection_unref0 (relinked_to);
#line 1007 "DataSource.c"
}


void
data_source_notify_relinked (DataSource* self)
{
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	DATA_SOURCE_GET_CLASS (self)->notify_relinked (self);
#line 1018 "DataSource.c"
}


static gchar*
data_source_real_get_typename (DataSource* self)
{
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_critical ("Type `%s' does not implement abstract method `data_source_get_typename'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return NULL;
#line 1029 "DataSource.c"
}


gchar*
data_source_get_typename (DataSource* self)
{
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return DATA_SOURCE_GET_CLASS (self)->get_typename (self);
#line 1040 "DataSource.c"
}


static gint64
data_source_real_get_instance_id (DataSource* self)
{
	gint64 _tmp0_ = 0LL;
#line 175 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_critical ("Type `%s' does not implement abstract method `data_source_get_instance_id'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 175 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return _tmp0_;
#line 1052 "DataSource.c"
}


gint64
data_source_get_instance_id (DataSource* self)
{
#line 175 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 175 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return DATA_SOURCE_GET_CLASS (self)->get_instance_id (self);
#line 1063 "DataSource.c"
}


static gchar*
data_source_real_get_source_id (DataSource* self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = data_source_get_typename (self);
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp1_ = _tmp0_;
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp2_ = g_strdup_printf ("%s-%016" G_GINT64_MODIFIER "x", _tmp1_, data_source_get_instance_id (self));
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp3_ = _tmp2_;
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_g_free0 (_tmp1_);
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	result = _tmp3_;
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return result;
#line 1089 "DataSource.c"
}


gchar*
data_source_get_source_id (DataSource* self)
{
#line 179 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 179 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return DATA_SOURCE_GET_CLASS (self)->get_source_id (self);
#line 1100 "DataSource.c"
}


gboolean
data_source_has_backlink (DataSource* self,
                          SourceBacklink* backlink)
{
	gboolean result = FALSE;
	GeeHashMap* _tmp0_;
	GeeList* values = NULL;
	GeeHashMap* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gpointer _tmp4_;
	gboolean _tmp5_ = FALSE;
	GeeList* _tmp6_;
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (backlink != NULL, FALSE);
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = self->priv->backlinks;
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp0_ == NULL) {
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		result = FALSE;
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		return result;
#line 1129 "DataSource.c"
	}
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp1_ = self->priv->backlinks;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp2_ = source_backlink_get_name (backlink);
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp3_ = _tmp2_;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, _tmp3_);
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	values = (GeeList*) _tmp4_;
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp6_ = values;
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp6_ != NULL) {
#line 1145 "DataSource.c"
		GeeList* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp7_ = values;
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp8_ = source_backlink_get_value (backlink);
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp9_ = _tmp8_;
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp5_ = gee_collection_contains ((GeeCollection*) _tmp7_, _tmp9_);
#line 1157 "DataSource.c"
	} else {
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp5_ = FALSE;
#line 1161 "DataSource.c"
	}
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	result = _tmp5_;
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_g_object_unref0 (values);
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return result;
#line 1169 "DataSource.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return self ? g_object_ref (self) : NULL;
#line 1178 "DataSource.c"
}


GeeList*
data_source_get_backlinks (DataSource* self,
                           const gchar* name)
{
	GeeList* result = NULL;
	GeeHashMap* _tmp0_;
	GeeList* values = NULL;
	GeeHashMap* _tmp1_;
	gpointer _tmp2_;
	gboolean _tmp3_ = FALSE;
	GeeList* _tmp4_;
	GeeList* backlinks = NULL;
	GeeArrayList* _tmp8_;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = self->priv->backlinks;
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp0_ == NULL) {
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		result = NULL;
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		return result;
#line 1207 "DataSource.c"
	}
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp1_ = self->priv->backlinks;
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, name);
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	values = (GeeList*) _tmp2_;
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp4_ = values;
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp4_ == NULL) {
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp3_ = TRUE;
#line 1221 "DataSource.c"
	} else {
		GeeList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp5_ = values;
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp6_ = gee_collection_get_size ((GeeCollection*) _tmp5_);
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp7_ = _tmp6_;
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp3_ = _tmp7_ == 0;
#line 1234 "DataSource.c"
	}
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp3_) {
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		result = NULL;
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_g_object_unref0 (values);
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		return result;
#line 1244 "DataSource.c"
	}
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp8_ = gee_array_list_new (TYPE_SOURCE_BACKLINK, (GBoxedCopyFunc) source_backlink_ref, (GDestroyNotify) source_backlink_unref, NULL, NULL, NULL);
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	backlinks = (GeeList*) _tmp8_;
#line 1250 "DataSource.c"
	{
		GeeList* _value_list = NULL;
		GeeList* _tmp9_;
		GeeList* _tmp10_;
		gint _value_size = 0;
		GeeList* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gint _value_index = 0;
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp9_ = values;
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp10_ = _g_object_ref0 (_tmp9_);
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_value_list = _tmp10_;
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp11_ = _value_list;
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp12_ = gee_collection_get_size ((GeeCollection*) _tmp11_);
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp13_ = _tmp12_;
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_value_size = _tmp13_;
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_value_index = -1;
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		while (TRUE) {
#line 1278 "DataSource.c"
			gint _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
			gchar* value = NULL;
			GeeList* _tmp17_;
			gint _tmp18_;
			gpointer _tmp19_;
			GeeList* _tmp20_;
			const gchar* _tmp21_;
			SourceBacklink* _tmp22_;
			SourceBacklink* _tmp23_;
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp14_ = _value_index;
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_value_index = _tmp14_ + 1;
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp15_ = _value_index;
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp16_ = _value_size;
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			if (!(_tmp15_ < _tmp16_)) {
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				break;
#line 1302 "DataSource.c"
			}
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp17_ = _value_list;
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp18_ = _value_index;
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp19_ = gee_list_get (_tmp17_, _tmp18_);
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			value = (gchar*) _tmp19_;
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp20_ = backlinks;
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp21_ = value;
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp22_ = source_backlink_new (name, _tmp21_);
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp23_ = _tmp22_;
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			gee_collection_add ((GeeCollection*) _tmp20_, _tmp23_);
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_source_backlink_unref0 (_tmp23_);
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_g_free0 (value);
#line 1326 "DataSource.c"
		}
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_g_object_unref0 (_value_list);
#line 1330 "DataSource.c"
	}
#line 204 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	result = backlinks;
#line 204 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_g_object_unref0 (values);
#line 204 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return result;
#line 1338 "DataSource.c"
}


void
data_source_set_backlink (DataSource* self,
                          SourceBacklink* backlink)
{
	GeeHashMap* _tmp0_;
	GeeList* values = NULL;
	GeeHashMap* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gpointer _tmp4_;
	GeeList* _tmp5_;
	GeeList* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	SourceCollection* sources = NULL;
	DataCollection* _tmp14_;
	SourceCollection* _tmp15_;
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (backlink != NULL);
#line 209 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = self->priv->backlinks;
#line 209 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_vala_assert (_tmp0_ != NULL, "backlinks != null");
#line 211 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp1_ = self->priv->backlinks;
#line 211 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp2_ = source_backlink_get_name (backlink);
#line 211 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp3_ = _tmp2_;
#line 211 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, _tmp3_);
#line 211 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	values = (GeeList*) _tmp4_;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp5_ = values;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp5_ == NULL) {
#line 1381 "DataSource.c"
		GeeArrayList* _tmp6_;
		GeeHashMap* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		GeeList* _tmp10_;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp6_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_g_object_unref0 (values);
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		values = (GeeList*) _tmp6_;
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp7_ = self->priv->backlinks;
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp8_ = source_backlink_get_name (backlink);
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp9_ = _tmp8_;
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp10_ = values;
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp7_, _tmp9_, _tmp10_);
#line 1403 "DataSource.c"
	}
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp11_ = values;
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp12_ = source_backlink_get_value (backlink);
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp13_ = _tmp12_;
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	gee_collection_add ((GeeCollection*) _tmp11_, _tmp13_);
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp14_ = data_object_get_membership ((DataObject*) self);
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	sources = G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_SOURCE_COLLECTION, SourceCollection);
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp15_ = sources;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp15_ != NULL) {
#line 1421 "DataSource.c"
		SourceCollection* _tmp16_;
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp16_ = sources;
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		source_collection_internal_backlink_set (_tmp16_, self, backlink);
#line 1427 "DataSource.c"
	}
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_data_collection_unref0 (sources);
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_g_object_unref0 (values);
#line 1433 "DataSource.c"
}


gboolean
data_source_remove_backlink (DataSource* self,
                             SourceBacklink* backlink)
{
	gboolean result = FALSE;
	GeeHashMap* _tmp0_;
	GeeList* values = NULL;
	GeeHashMap* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gpointer _tmp4_;
	GeeList* _tmp5_;
	gint original_size = 0;
	GeeList* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	GeeIterator* iter = NULL;
	GeeList* _tmp10_;
	GeeIterator* _tmp11_;
	GeeList* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	SourceCollection* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	SourceCollection* sources = NULL;
	DataCollection* _tmp29_;
	SourceCollection* _tmp30_;
	GeeList* _tmp32_;
	gint _tmp33_;
	gint _tmp34_;
	gint _tmp35_;
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (backlink != NULL, FALSE);
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = self->priv->backlinks;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp0_ == NULL) {
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		result = FALSE;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		return result;
#line 1482 "DataSource.c"
	}
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp1_ = self->priv->backlinks;
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp2_ = source_backlink_get_name (backlink);
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp3_ = _tmp2_;
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, _tmp3_);
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	values = (GeeList*) _tmp4_;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp5_ = values;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp5_ == NULL) {
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		result = FALSE;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_g_object_unref0 (values);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		return result;
#line 1504 "DataSource.c"
	}
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp6_ = values;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp7_ = gee_collection_get_size ((GeeCollection*) _tmp6_);
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp8_ = _tmp7_;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	original_size = _tmp8_;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp9_ = original_size;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_vala_assert (_tmp9_ > 0, "original_size > 0");
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp10_ = values;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp11_ = gee_iterable_iterator ((GeeIterable*) _tmp10_);
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	iter = _tmp11_;
#line 236 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	while (TRUE) {
#line 1526 "DataSource.c"
		GeeIterator* _tmp12_;
		GeeIterator* _tmp13_;
		gpointer _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		gboolean _tmp18_;
#line 236 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp12_ = iter;
#line 236 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		if (!gee_iterator_next (_tmp12_)) {
#line 236 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			break;
#line 1540 "DataSource.c"
		}
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp13_ = iter;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp14_ = gee_iterator_get (_tmp13_);
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp15_ = (gchar*) _tmp14_;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp16_ = source_backlink_get_value (backlink);
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp17_ = _tmp16_;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp18_ = g_strcmp0 (_tmp15_, _tmp17_) == 0;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_g_free0 (_tmp15_);
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		if (_tmp18_) {
#line 1558 "DataSource.c"
			GeeIterator* _tmp19_;
#line 238 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp19_ = iter;
#line 238 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			gee_iterator_remove (_tmp19_);
#line 1564 "DataSource.c"
		}
	}
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp20_ = values;
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp21_ = gee_collection_get_size ((GeeCollection*) _tmp20_);
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp22_ = _tmp21_;
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp22_ == 0) {
#line 1575 "DataSource.c"
		GeeHashMap* _tmp23_;
		const gchar* _tmp24_;
		const gchar* _tmp25_;
#line 242 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp23_ = self->priv->backlinks;
#line 242 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp24_ = source_backlink_get_name (backlink);
#line 242 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp25_ = _tmp24_;
#line 242 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp23_, _tmp25_, NULL);
#line 1587 "DataSource.c"
	}
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp26_ = self->priv->unlinked_from_collection;
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp27_ = data_source_dehydrate_backlinks (self);
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp28_ = _tmp27_;
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	data_source_commit_backlinks (self, _tmp26_, _tmp28_);
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_g_free0 (_tmp28_);
#line 248 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp29_ = data_object_get_membership ((DataObject*) self);
#line 248 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	sources = G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, TYPE_SOURCE_COLLECTION, SourceCollection);
#line 249 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp30_ = sources;
#line 249 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp30_ != NULL) {
#line 1607 "DataSource.c"
		SourceCollection* _tmp31_;
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp31_ = sources;
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		source_collection_internal_backlink_removed (_tmp31_, self, backlink);
#line 1613 "DataSource.c"
	}
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp32_ = values;
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp33_ = gee_collection_get_size ((GeeCollection*) _tmp32_);
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp34_ = _tmp33_;
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp35_ = original_size;
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	result = _tmp34_ != _tmp35_;
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_data_collection_unref0 (sources);
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_g_object_unref0 (iter);
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_g_object_unref0 (values);
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return result;
#line 1633 "DataSource.c"
}


static void
data_source_real_commit_backlinks (DataSource* self,
                                   SourceCollection* sources,
                                   const gchar* dehydrated)
{
	gboolean _tmp0_ = FALSE;
#line 262 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (sources != NULL) {
#line 262 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp0_ = TRUE;
#line 1647 "DataSource.c"
	} else {
#line 262 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp0_ = dehydrated != NULL;
#line 1651 "DataSource.c"
	}
#line 262 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp0_) {
#line 1655 "DataSource.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp1_ = data_object_to_string ((DataObject*) self);
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp2_ = _tmp1_;
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		g_warning ("DataSource.vala:263: No implementation to commit link state for %s", _tmp2_);
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_g_free0 (_tmp2_);
#line 1666 "DataSource.c"
	}
}


void
data_source_commit_backlinks (DataSource* self,
                              SourceCollection* sources,
                              const gchar* dehydrated)
{
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	DATA_SOURCE_GET_CLASS (self)->commit_backlinks (self, sources, dehydrated);
#line 1680 "DataSource.c"
}


static gchar*
data_source_dehydrate_backlinks (DataSource* self)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	GeeHashMap* _tmp1_;
	GString* builder = NULL;
	GString* _tmp5_;
	const gchar* _tmp49_ = NULL;
	GString* _tmp50_;
	const gchar* _tmp51_;
	gint _tmp52_;
	gint _tmp53_;
	gchar* _tmp56_;
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp1_ = self->priv->backlinks;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp1_ == NULL) {
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp0_ = TRUE;
#line 1706 "DataSource.c"
	} else {
		GeeHashMap* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp2_ = self->priv->backlinks;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp3_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp2_);
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp4_ = _tmp3_;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp0_ = _tmp4_ == 0;
#line 1719 "DataSource.c"
	}
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp0_) {
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		result = NULL;
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		return result;
#line 1727 "DataSource.c"
	}
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp5_ = g_string_new ("");
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	builder = _tmp5_;
#line 1733 "DataSource.c"
	{
		GeeIterator* _name_it = NULL;
		GeeHashMap* _tmp6_;
		GeeSet* _tmp7_;
		GeeSet* _tmp8_;
		GeeSet* _tmp9_;
		GeeIterator* _tmp10_;
		GeeIterator* _tmp11_;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp6_ = self->priv->backlinks;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp7_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp6_);
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp8_ = _tmp7_;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp9_ = _tmp8_;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp11_ = _tmp10_;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_g_object_unref0 (_tmp9_);
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_name_it = _tmp11_;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		while (TRUE) {
#line 1760 "DataSource.c"
			GeeIterator* _tmp12_;
			gchar* name = NULL;
			GeeIterator* _tmp13_;
			gpointer _tmp14_;
			GeeList* values = NULL;
			GeeHashMap* _tmp15_;
			const gchar* _tmp16_;
			gpointer _tmp17_;
			gboolean _tmp18_ = FALSE;
			GeeList* _tmp19_;
			gchar* value_field = NULL;
			gchar* _tmp23_;
			const gchar* _tmp41_;
			gint _tmp42_;
			gint _tmp43_;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp12_ = _name_it;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			if (!gee_iterator_next (_tmp12_)) {
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				break;
#line 1782 "DataSource.c"
			}
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp13_ = _name_it;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp14_ = gee_iterator_get (_tmp13_);
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			name = (gchar*) _tmp14_;
#line 272 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp15_ = self->priv->backlinks;
#line 272 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp16_ = name;
#line 272 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp17_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp15_, _tmp16_);
#line 272 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			values = (GeeList*) _tmp17_;
#line 273 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp19_ = values;
#line 273 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			if (_tmp19_ == NULL) {
#line 273 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp18_ = TRUE;
#line 1804 "DataSource.c"
			} else {
				GeeList* _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
#line 273 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp20_ = values;
#line 273 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp21_ = gee_collection_get_size ((GeeCollection*) _tmp20_);
#line 273 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp22_ = _tmp21_;
#line 273 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp18_ = _tmp22_ == 0;
#line 1817 "DataSource.c"
			}
#line 273 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			if (_tmp18_) {
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_g_object_unref0 (values);
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_g_free0 (name);
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				continue;
#line 1827 "DataSource.c"
			}
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp23_ = g_strdup ("");
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			value_field = _tmp23_;
#line 1833 "DataSource.c"
			{
				GeeList* _value_list = NULL;
				GeeList* _tmp24_;
				GeeList* _tmp25_;
				gint _value_size = 0;
				GeeList* _tmp26_;
				gint _tmp27_;
				gint _tmp28_;
				gint _value_index = 0;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp24_ = values;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp25_ = _g_object_ref0 (_tmp24_);
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_value_list = _tmp25_;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp26_ = _value_list;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp27_ = gee_collection_get_size ((GeeCollection*) _tmp26_);
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp28_ = _tmp27_;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_value_size = _tmp28_;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_value_index = -1;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				while (TRUE) {
#line 1861 "DataSource.c"
					gint _tmp29_;
					gint _tmp30_;
					gint _tmp31_;
					gchar* value = NULL;
					GeeList* _tmp32_;
					gint _tmp33_;
					gpointer _tmp34_;
					const gchar* _tmp35_;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp29_ = _value_index;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_value_index = _tmp29_ + 1;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp30_ = _value_index;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp31_ = _value_size;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					if (!(_tmp30_ < _tmp31_)) {
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
						break;
#line 1882 "DataSource.c"
					}
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp32_ = _value_list;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp33_ = _value_index;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp34_ = gee_list_get (_tmp32_, _tmp33_);
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					value = (gchar*) _tmp34_;
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp35_ = value;
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					if (!is_string_empty (_tmp35_)) {
#line 1896 "DataSource.c"
						const gchar* _tmp36_;
						const gchar* _tmp37_;
						gchar* _tmp38_;
						gchar* _tmp39_;
						gchar* _tmp40_;
#line 279 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
						_tmp36_ = value_field;
#line 279 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
						_tmp37_ = value;
#line 279 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
						_tmp38_ = g_strconcat (_tmp37_, "|", NULL);
#line 279 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
						_tmp39_ = _tmp38_;
#line 279 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
						_tmp40_ = g_strconcat (_tmp36_, _tmp39_, NULL);
#line 279 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
						_g_free0 (value_field);
#line 279 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
						value_field = _tmp40_;
#line 279 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
						_g_free0 (_tmp39_);
#line 1918 "DataSource.c"
					}
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_g_free0 (value);
#line 1922 "DataSource.c"
				}
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_g_object_unref0 (_value_list);
#line 1926 "DataSource.c"
			}
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp41_ = value_field;
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp42_ = strlen (_tmp41_);
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp43_ = _tmp42_;
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			if (_tmp43_ > 0) {
#line 1936 "DataSource.c"
				GString* _tmp44_;
				const gchar* _tmp45_;
				const gchar* _tmp46_;
				gchar* _tmp47_;
				gchar* _tmp48_;
#line 283 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp44_ = builder;
#line 283 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp45_ = name;
#line 283 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp46_ = value_field;
#line 283 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp47_ = g_strdup_printf ("%s=%s\n", _tmp45_, _tmp46_);
#line 283 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp48_ = _tmp47_;
#line 283 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				g_string_append (_tmp44_, _tmp48_);
#line 283 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_g_free0 (_tmp48_);
#line 1956 "DataSource.c"
			}
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_g_free0 (value_field);
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_g_object_unref0 (values);
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_g_free0 (name);
#line 1964 "DataSource.c"
		}
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_g_object_unref0 (_name_it);
#line 1968 "DataSource.c"
	}
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp50_ = builder;
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp51_ = _tmp50_->str;
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp52_ = strlen (_tmp51_);
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp53_ = _tmp52_;
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp53_ > 0) {
#line 1980 "DataSource.c"
		GString* _tmp54_;
		const gchar* _tmp55_;
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp54_ = builder;
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp55_ = _tmp54_->str;
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp49_ = _tmp55_;
#line 1989 "DataSource.c"
	} else {
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp49_ = NULL;
#line 1993 "DataSource.c"
	}
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp56_ = g_strdup (_tmp49_);
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	result = _tmp56_;
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_g_string_free0 (builder);
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return result;
#line 2003 "DataSource.c"
}


void
data_source_rehydrate_backlinks (DataSource* self,
                                 SourceCollection* unlinked_from,
                                 const gchar* dehydrated)
{
	GeeHashMap* _tmp0_;
	gchar** lines = NULL;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint lines_length1;
	gint _lines_size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (unlinked_from != NULL);
#line 292 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->unlinked_from_collection = unlinked_from;
#line 293 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 293 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_g_object_unref0 (self->priv->backlinks);
#line 293 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->backlinks = _tmp0_;
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (dehydrated == NULL) {
#line 296 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		return;
#line 2036 "DataSource.c"
	}
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp2_ = _tmp1_ = g_strsplit (dehydrated, "\n", 0);
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	lines = _tmp2_;
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	lines_length1 = _vala_array_length (_tmp1_);
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_lines_size_ = lines_length1;
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp3_ = lines;
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp3__length1 = lines_length1;
#line 2050 "DataSource.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		line_collection = _tmp3_;
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		line_collection_length1 = _tmp3__length1;
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		for (line_it = 0; line_it < _tmp3__length1; line_it = line_it + 1) {
#line 2062 "DataSource.c"
			gchar* _tmp4_;
			gchar* line = NULL;
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp4_ = g_strdup (line_collection[line_it]);
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			line = _tmp4_;
#line 2069 "DataSource.c"
			{
				const gchar* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				gchar** tokens = NULL;
				const gchar* _tmp8_;
				gchar** _tmp9_;
				gchar** _tmp10_;
				gint tokens_length1;
				gint _tokens_size_;
				gchar** _tmp11_;
				gint _tmp11__length1;
				gchar** decoded_values = NULL;
				gchar** _tmp15_;
				gint _tmp15__length1;
				const gchar* _tmp16_;
				gchar** _tmp17_;
				gchar** _tmp18_;
				gint decoded_values_length1;
				gint _decoded_values_size_;
				GeeList* values = NULL;
				GeeArrayList* _tmp19_;
				gchar** _tmp20_;
				gint _tmp20__length1;
				GeeList* _tmp29_;
				gint _tmp30_;
				gint _tmp31_;
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp5_ = line;
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp6_ = strlen (_tmp5_);
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp7_ = _tmp6_;
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				if (_tmp7_ == 0) {
#line 301 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_g_free0 (line);
#line 301 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					continue;
#line 2109 "DataSource.c"
				}
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp8_ = line;
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp10_ = _tmp9_ = g_strsplit (_tmp8_, "=", 2);
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				tokens = _tmp10_;
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				tokens_length1 = _vala_array_length (_tmp9_);
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tokens_size_ = tokens_length1;
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp11_ = tokens;
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp11__length1 = tokens_length1;
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				if (_tmp11__length1 < 2) {
#line 2127 "DataSource.c"
					const gchar* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
#line 305 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp12_ = line;
#line 305 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp13_ = data_object_to_string ((DataObject*) self);
#line 305 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp14_ = _tmp13_;
#line 305 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					g_warning ("DataSource.vala:305: Unable to rehydrate \"%s\" for %s: name and value" \
" not present", _tmp12_, _tmp14_);
#line 305 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_g_free0 (_tmp14_);
#line 308 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 308 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_g_free0 (line);
#line 308 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					continue;
#line 2147 "DataSource.c"
				}
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp15_ = tokens;
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp15__length1 = tokens_length1;
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp16_ = _tmp15_[1];
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp18_ = _tmp17_ = g_strsplit (_tmp16_, "|", 0);
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				decoded_values = _tmp18_;
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				decoded_values_length1 = _vala_array_length (_tmp17_);
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_decoded_values_size_ = decoded_values_length1;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp19_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				values = (GeeList*) _tmp19_;
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp20_ = decoded_values;
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp20__length1 = decoded_values_length1;
#line 2171 "DataSource.c"
				{
					gchar** value_collection = NULL;
					gint value_collection_length1 = 0;
					gint _value_collection_size_ = 0;
					gint value_it = 0;
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					value_collection = _tmp20_;
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					value_collection_length1 = _tmp20__length1;
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					for (value_it = 0; value_it < _tmp20__length1; value_it = value_it + 1) {
#line 2183 "DataSource.c"
						gchar* _tmp21_;
						gchar* value = NULL;
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
						_tmp21_ = g_strdup (value_collection[value_it]);
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
						value = _tmp21_;
#line 2190 "DataSource.c"
						{
							gboolean _tmp22_ = FALSE;
							const gchar* _tmp23_;
#line 314 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
							_tmp23_ = value;
#line 314 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
							if (_tmp23_ != NULL) {
#line 2198 "DataSource.c"
								const gchar* _tmp24_;
								gint _tmp25_;
								gint _tmp26_;
#line 314 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
								_tmp24_ = value;
#line 314 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
								_tmp25_ = strlen (_tmp24_);
#line 314 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
								_tmp26_ = _tmp25_;
#line 314 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
								_tmp22_ = _tmp26_ > 0;
#line 2210 "DataSource.c"
							} else {
#line 314 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
								_tmp22_ = FALSE;
#line 2214 "DataSource.c"
							}
#line 314 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
							if (_tmp22_) {
#line 2218 "DataSource.c"
								GeeList* _tmp27_;
								const gchar* _tmp28_;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
								_tmp27_ = values;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
								_tmp28_ = value;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
								gee_collection_add ((GeeCollection*) _tmp27_, _tmp28_);
#line 2227 "DataSource.c"
							}
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
							_g_free0 (value);
#line 2231 "DataSource.c"
						}
					}
				}
#line 318 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp29_ = values;
#line 318 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp30_ = gee_collection_get_size ((GeeCollection*) _tmp29_);
#line 318 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp31_ = _tmp30_;
#line 318 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				if (_tmp31_ > 0) {
#line 2243 "DataSource.c"
					GeeHashMap* _tmp32_;
					gchar** _tmp33_;
					gint _tmp33__length1;
					const gchar* _tmp34_;
					GeeList* _tmp35_;
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp32_ = self->priv->backlinks;
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp33_ = tokens;
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp33__length1 = tokens_length1;
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp34_ = _tmp33_[0];
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp35_ = values;
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp32_, _tmp34_, _tmp35_);
#line 2261 "DataSource.c"
				}
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_g_object_unref0 (values);
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				decoded_values = (_vala_array_free (decoded_values, decoded_values_length1, (GDestroyNotify) g_free), NULL);
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_g_free0 (line);
#line 2271 "DataSource.c"
			}
		}
	}
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 2277 "DataSource.c"
}


static SourceSnapshot*
data_source_real_save_snapshot (DataSource* self)
{
	SourceSnapshot* result = NULL;
#line 325 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	result = NULL;
#line 325 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return result;
#line 2289 "DataSource.c"
}


SourceSnapshot*
data_source_save_snapshot (DataSource* self)
{
#line 324 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 324 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return DATA_SOURCE_GET_CLASS (self)->save_snapshot (self);
#line 2300 "DataSource.c"
}


void
data_source_internal_mark_for_destroy (DataSource* self)
{
#line 329 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 330 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->marked_for_destroy = TRUE;
#line 2311 "DataSource.c"
}


static gboolean
data_source_real_internal_delete_backing (DataSource* self,
                                          GError** error)
{
	gboolean result = FALSE;
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	result = TRUE;
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return result;
#line 2324 "DataSource.c"
}


gboolean
data_source_internal_delete_backing (DataSource* self,
                                     GError** error)
{
#line 337 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 337 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return DATA_SOURCE_GET_CLASS (self)->internal_delete_backing (self, error);
#line 2336 "DataSource.c"
}


static gboolean
data_source_real_equals (DataSource* self,
                         DataSource* source)
{
	gboolean result = FALSE;
#line 344 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	result = self == source;
#line 344 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return result;
#line 2349 "DataSource.c"
}


gboolean
data_source_equals (DataSource* self,
                    DataSource* source)
{
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return DATA_SOURCE_GET_CLASS (self)->equals (self, source);
#line 2361 "DataSource.c"
}


static void
data_source_real_destroy (DataSource* self)
{
	gboolean _tmp0_;
#line 354 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = self->priv->marked_for_destroy;
#line 354 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_vala_assert (_tmp0_, "marked_for_destroy");
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->is_destroyed = TRUE;
#line 2375 "DataSource.c"
	{
		gint ctr = 0;
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		ctr = 0;
#line 2380 "DataSource.c"
		{
			gboolean _tmp1_ = FALSE;
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp1_ = TRUE;
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			while (TRUE) {
#line 2387 "DataSource.c"
				gint _tmp3_;
				DataView** _tmp4_;
				gint _tmp4__length1;
				DataView** _tmp5_;
				gint _tmp5__length1;
				gint _tmp6_;
				DataView* _tmp7_;
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				if (!_tmp1_) {
#line 2397 "DataSource.c"
					gint _tmp2_;
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp2_ = ctr;
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					ctr = _tmp2_ + 1;
#line 2403 "DataSource.c"
				}
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp1_ = FALSE;
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp3_ = ctr;
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp4_ = self->priv->subscribers;
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp4__length1 = self->priv->subscribers_length1;
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				if (!(_tmp3_ < _tmp4__length1)) {
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					break;
#line 2417 "DataSource.c"
				}
#line 361 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp5_ = self->priv->subscribers;
#line 361 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp5__length1 = self->priv->subscribers_length1;
#line 361 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp6_ = ctr;
#line 361 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp7_ = _tmp5_[_tmp6_];
#line 361 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				if (_tmp7_ != NULL) {
#line 2429 "DataSource.c"
					DataView* view = NULL;
					DataView** _tmp8_;
					gint _tmp8__length1;
					gint _tmp9_;
					DataView* _tmp10_;
					DataView* _tmp11_;
					DataView** _tmp12_;
					gint _tmp12__length1;
					gint _tmp13_;
					DataView* _tmp14_;
					DataView* _tmp15_;
#line 362 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp8_ = self->priv->subscribers;
#line 362 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp8__length1 = self->priv->subscribers_length1;
#line 362 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp9_ = ctr;
#line 362 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp10_ = _tmp8_[_tmp9_];
#line 362 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp11_ = _g_object_ref0 (_tmp10_);
#line 362 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					view = _tmp11_;
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp12_ = self->priv->subscribers;
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp12__length1 = self->priv->subscribers_length1;
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp13_ = ctr;
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_g_object_unref0 (_tmp12_[_tmp13_]);
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp12_[_tmp13_] = NULL;
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp14_ = _tmp12_[_tmp13_];
#line 365 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp15_ = view;
#line 365 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					data_view_notify_unsubscribed (_tmp15_, self);
#line 361 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_g_object_unref0 (view);
#line 2471 "DataSource.c"
				}
			}
		}
	}
#line 370 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_signal_emit (self, data_source_signals[DATA_SOURCE_DESTROYED_SIGNAL], 0);
#line 2478 "DataSource.c"
}


void
data_source_destroy (DataSource* self)
{
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	DATA_SOURCE_GET_CLASS (self)->destroy (self);
#line 2489 "DataSource.c"
}


gboolean
data_source_destroy_orphan (DataSource* self,
                            gboolean delete_backing)
{
	gboolean result = FALSE;
	gboolean ret = FALSE;
	SourceCollection* _tmp9_;
	GError * _inner_error_ = NULL;
#line 379 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	ret = TRUE;
#line 381 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (delete_backing) {
#line 2507 "DataSource.c"
		{
			gboolean _tmp0_ = FALSE;
			gboolean _tmp1_;
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp0_ = data_source_internal_delete_backing (self, &_inner_error_);
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2515 "DataSource.c"
				goto __catch491_g_error;
			}
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			ret = _tmp0_;
#line 384 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp1_ = ret;
#line 384 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			if (!_tmp1_) {
#line 2524 "DataSource.c"
				gchar* _tmp2_;
				gchar* _tmp3_;
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp2_ = data_object_to_string ((DataObject*) self);
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp3_ = _tmp2_;
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				g_warning ("DataSource.vala:385: Unable to delete backing for %s", _tmp3_);
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_g_free0 (_tmp3_);
#line 2535 "DataSource.c"
			}
		}
		goto __finally491;
		__catch491_g_error:
		{
			GError* err = NULL;
			gchar* _tmp4_;
			gchar* _tmp5_;
			GError* _tmp6_;
			const gchar* _tmp7_;
#line 382 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			err = _inner_error_;
#line 382 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_inner_error_ = NULL;
#line 388 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp4_ = data_object_to_string ((DataObject*) self);
#line 388 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp5_ = _tmp4_;
#line 388 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp6_ = err;
#line 388 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp7_ = _tmp6_->message;
#line 388 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			g_warning ("DataSource.vala:388: Unable to delete backing for %s: %s", _tmp5_, _tmp7_);
#line 388 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_g_free0 (_tmp5_);
#line 389 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			ret = FALSE;
#line 382 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_g_error_free0 (err);
#line 2566 "DataSource.c"
		}
		__finally491:
#line 382 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2571 "DataSource.c"
			gboolean _tmp8_ = FALSE;
#line 382 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 382 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			g_clear_error (&_inner_error_);
#line 382 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			return _tmp8_;
#line 2579 "DataSource.c"
		}
	}
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	data_source_internal_mark_for_destroy (self);
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	data_source_destroy (self);
#line 396 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp9_ = self->priv->unlinked_from_collection;
#line 396 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp9_ != NULL) {
#line 2590 "DataSource.c"
		SourceCollection* _tmp10_;
#line 397 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp10_ = self->priv->unlinked_from_collection;
#line 397 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		source_collection_notify_unlinked_destroyed (_tmp10_, self);
#line 2596 "DataSource.c"
	}
#line 399 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	result = ret;
#line 399 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return result;
#line 2602 "DataSource.c"
}


static void
_vala_array_add135 (DataView** * array,
                    int* length,
                    int* size,
                    DataView* value)
{
#line 419 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if ((*length) == (*size)) {
#line 419 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 419 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		*array = g_renew (DataView*, *array, (*size) + 1);
#line 2618 "DataSource.c"
	}
#line 419 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	(*array)[(*length)++] = value;
#line 419 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	(*array)[*length] = NULL;
#line 2624 "DataSource.c"
}


void
data_source_internal_subscribe (DataSource* self,
                                DataView* view)
{
	gboolean _tmp0_;
	DataView** _tmp12_;
	gint _tmp12__length1;
	DataView* _tmp13_;
#line 408 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 408 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (view != NULL);
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = self->priv->in_contact;
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_vala_assert (!_tmp0_, "!in_contact");
#line 2644 "DataSource.c"
	{
		gint ctr = 0;
#line 411 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		ctr = 0;
#line 2649 "DataSource.c"
		{
			gboolean _tmp1_ = FALSE;
#line 411 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp1_ = TRUE;
#line 411 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			while (TRUE) {
#line 2656 "DataSource.c"
				gint _tmp3_;
				DataView** _tmp4_;
				gint _tmp4__length1;
				DataView** _tmp5_;
				gint _tmp5__length1;
				gint _tmp6_;
				DataView* _tmp7_;
#line 411 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				if (!_tmp1_) {
#line 2666 "DataSource.c"
					gint _tmp2_;
#line 411 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp2_ = ctr;
#line 411 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					ctr = _tmp2_ + 1;
#line 2672 "DataSource.c"
				}
#line 411 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp1_ = FALSE;
#line 411 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp3_ = ctr;
#line 411 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp4_ = self->priv->subscribers;
#line 411 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp4__length1 = self->priv->subscribers_length1;
#line 411 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				if (!(_tmp3_ < _tmp4__length1)) {
#line 411 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					break;
#line 2686 "DataSource.c"
				}
#line 412 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp5_ = self->priv->subscribers;
#line 412 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp5__length1 = self->priv->subscribers_length1;
#line 412 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp6_ = ctr;
#line 412 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp7_ = _tmp5_[_tmp6_];
#line 412 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				if (_tmp7_ == NULL) {
#line 2698 "DataSource.c"
					DataView** _tmp8_;
					gint _tmp8__length1;
					gint _tmp9_;
					DataView* _tmp10_;
					DataView* _tmp11_;
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp8_ = self->priv->subscribers;
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp8__length1 = self->priv->subscribers_length1;
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp9_ = ctr;
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp10_ = _g_object_ref0 (view);
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_g_object_unref0 (_tmp8_[_tmp9_]);
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp8_[_tmp9_] = _tmp10_;
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp11_ = _tmp8_[_tmp9_];
#line 415 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					return;
#line 2720 "DataSource.c"
				}
			}
		}
	}
#line 419 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp12_ = self->priv->subscribers;
#line 419 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp12__length1 = self->priv->subscribers_length1;
#line 419 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp13_ = _g_object_ref0 (view);
#line 419 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_vala_array_add135 (&self->priv->subscribers, &self->priv->subscribers_length1, &self->priv->_subscribers_size_, _tmp13_);
#line 2733 "DataSource.c"
}


void
data_source_internal_unsubscribe (DataSource* self,
                                  DataView* view)
{
	gboolean _tmp0_;
#line 424 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 424 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (view != NULL);
#line 425 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = self->priv->in_contact;
#line 425 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_vala_assert (!_tmp0_, "!in_contact");
#line 2750 "DataSource.c"
	{
		gint ctr = 0;
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		ctr = 0;
#line 2755 "DataSource.c"
		{
			gboolean _tmp1_ = FALSE;
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp1_ = TRUE;
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			while (TRUE) {
#line 2762 "DataSource.c"
				gint _tmp3_;
				DataView** _tmp4_;
				gint _tmp4__length1;
				DataView** _tmp5_;
				gint _tmp5__length1;
				gint _tmp6_;
				DataView* _tmp7_;
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				if (!_tmp1_) {
#line 2772 "DataSource.c"
					gint _tmp2_;
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp2_ = ctr;
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					ctr = _tmp2_ + 1;
#line 2778 "DataSource.c"
				}
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp1_ = FALSE;
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp3_ = ctr;
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp4_ = self->priv->subscribers;
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp4__length1 = self->priv->subscribers_length1;
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				if (!(_tmp3_ < _tmp4__length1)) {
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					break;
#line 2792 "DataSource.c"
				}
#line 428 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp5_ = self->priv->subscribers;
#line 428 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp5__length1 = self->priv->subscribers_length1;
#line 428 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp6_ = ctr;
#line 428 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp7_ = _tmp5_[_tmp6_];
#line 428 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				if (_tmp7_ == view) {
#line 2804 "DataSource.c"
					DataView** _tmp8_;
					gint _tmp8__length1;
					gint _tmp9_;
					DataView* _tmp10_;
#line 429 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp8_ = self->priv->subscribers;
#line 429 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp8__length1 = self->priv->subscribers_length1;
#line 429 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp9_ = ctr;
#line 429 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_g_object_unref0 (_tmp8_[_tmp9_]);
#line 429 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp8_[_tmp9_] = NULL;
#line 429 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp10_ = _tmp8_[_tmp9_];
#line 431 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					return;
#line 2823 "DataSource.c"
				}
			}
		}
	}
}


void
data_source_contact_subscribers (DataSource* self,
                                 DataSourceContactSubscriber contact_subscriber,
                                 void* contact_subscriber_target)
{
	gboolean _tmp0_;
#line 436 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 437 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = self->priv->in_contact;
#line 437 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_vala_assert (!_tmp0_, "!in_contact");
#line 439 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->in_contact = TRUE;
#line 2845 "DataSource.c"
	{
		gint ctr = 0;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		ctr = 0;
#line 2850 "DataSource.c"
		{
			gboolean _tmp1_ = FALSE;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp1_ = TRUE;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			while (TRUE) {
#line 2857 "DataSource.c"
				gint _tmp3_;
				DataView** _tmp4_;
				gint _tmp4__length1;
				DataView** _tmp5_;
				gint _tmp5__length1;
				gint _tmp6_;
				DataView* _tmp7_;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				if (!_tmp1_) {
#line 2867 "DataSource.c"
					gint _tmp2_;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp2_ = ctr;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					ctr = _tmp2_ + 1;
#line 2873 "DataSource.c"
				}
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp1_ = FALSE;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp3_ = ctr;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp4_ = self->priv->subscribers;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp4__length1 = self->priv->subscribers_length1;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				if (!(_tmp3_ < _tmp4__length1)) {
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					break;
#line 2887 "DataSource.c"
				}
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp5_ = self->priv->subscribers;
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp5__length1 = self->priv->subscribers_length1;
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp6_ = ctr;
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp7_ = _tmp5_[_tmp6_];
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				if (_tmp7_ != NULL) {
#line 2899 "DataSource.c"
					DataView** _tmp8_;
					gint _tmp8__length1;
					gint _tmp9_;
					DataView* _tmp10_;
#line 442 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp8_ = self->priv->subscribers;
#line 442 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp8__length1 = self->priv->subscribers_length1;
#line 442 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp9_ = ctr;
#line 442 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp10_ = _tmp8_[_tmp9_];
#line 442 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					contact_subscriber (_tmp10_, contact_subscriber_target);
#line 2914 "DataSource.c"
				}
			}
		}
	}
#line 444 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->in_contact = FALSE;
#line 2921 "DataSource.c"
}


void
data_source_contact_subscribers_alteration (DataSource* self,
                                            Alteration* alteration)
{
	gboolean _tmp0_;
#line 447 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 447 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (alteration != NULL);
#line 448 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = self->priv->in_contact;
#line 448 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_vala_assert (!_tmp0_, "!in_contact");
#line 450 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->in_contact = TRUE;
#line 2940 "DataSource.c"
	{
		gint ctr = 0;
#line 451 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		ctr = 0;
#line 2945 "DataSource.c"
		{
			gboolean _tmp1_ = FALSE;
#line 451 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp1_ = TRUE;
#line 451 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			while (TRUE) {
#line 2952 "DataSource.c"
				gint _tmp3_;
				DataView** _tmp4_;
				gint _tmp4__length1;
				DataView** _tmp5_;
				gint _tmp5__length1;
				gint _tmp6_;
				DataView* _tmp7_;
#line 451 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				if (!_tmp1_) {
#line 2962 "DataSource.c"
					gint _tmp2_;
#line 451 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp2_ = ctr;
#line 451 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					ctr = _tmp2_ + 1;
#line 2968 "DataSource.c"
				}
#line 451 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp1_ = FALSE;
#line 451 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp3_ = ctr;
#line 451 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp4_ = self->priv->subscribers;
#line 451 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp4__length1 = self->priv->subscribers_length1;
#line 451 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				if (!(_tmp3_ < _tmp4__length1)) {
#line 451 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					break;
#line 2982 "DataSource.c"
				}
#line 452 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp5_ = self->priv->subscribers;
#line 452 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp5__length1 = self->priv->subscribers_length1;
#line 452 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp6_ = ctr;
#line 452 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_tmp7_ = _tmp5_[_tmp6_];
#line 452 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				if (_tmp7_ != NULL) {
#line 2994 "DataSource.c"
					DataView** _tmp8_;
					gint _tmp8__length1;
					gint _tmp9_;
					DataView* _tmp10_;
#line 453 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp8_ = self->priv->subscribers;
#line 453 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp8__length1 = self->priv->subscribers_length1;
#line 453 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp9_ = ctr;
#line 453 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					_tmp10_ = _tmp8_[_tmp9_];
#line 453 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
					data_object_notify_altered ((DataObject*) _tmp10_, alteration);
#line 3009 "DataSource.c"
				}
			}
		}
	}
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->in_contact = FALSE;
#line 3016 "DataSource.c"
}


static void
data_source_real_unlinked (DataSource* self,
                           SourceCollection* sources)
{
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (sources != NULL);
#line 3026 "DataSource.c"
}


static void
g_cclosure_user_marshal_VOID__DATA_COLLECTION (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__DATA_COLLECTION) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__DATA_COLLECTION callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (n_param_values == 2);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		data1 = closure->data;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		data2 = param_values->data[0].v_pointer;
#line 3052 "DataSource.c"
	} else {
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		data1 = param_values->data[0].v_pointer;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		data2 = closure->data;
#line 3058 "DataSource.c"
	}
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	callback = (GMarshalFunc_VOID__DATA_COLLECTION) (marshal_data ? marshal_data : cc->callback);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	callback (data1, value_get_data_collection (param_values + 1), data2);
#line 3064 "DataSource.c"
}


static void
data_source_real_relinked (DataSource* self,
                           SourceCollection* sources)
{
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (sources != NULL);
#line 3074 "DataSource.c"
}


static void
data_source_real_destroyed (DataSource* self)
{
}


static void
data_source_class_init (DataSourceClass * klass)
{
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	data_source_parent_class = g_type_class_peek_parent (klass);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_type_class_add_private (klass, sizeof (DataSourcePrivate));
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((DataObjectClass *) klass)->notify_membership_changed = (void (*) (DataObject *, DataCollection*)) data_source_real_notify_membership_changed;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((DataSourceClass *) klass)->notify_held_in_tank = (void (*) (DataSource *, SourceHoldingTank*)) data_source_real_notify_held_in_tank;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((DataObjectClass *) klass)->notify_altered = (void (*) (DataObject *, Alteration*)) data_source_real_notify_altered;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((DataSourceClass *) klass)->notify_unlinking = (void (*) (DataSource *, SourceCollection*)) data_source_real_notify_unlinking;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((DataSourceClass *) klass)->notify_unlinked = (void (*) (DataSource *)) data_source_real_notify_unlinked;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((DataSourceClass *) klass)->notify_relinking = (void (*) (DataSource *, SourceCollection*)) data_source_real_notify_relinking;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((DataSourceClass *) klass)->notify_relinked = (void (*) (DataSource *)) data_source_real_notify_relinked;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((DataSourceClass *) klass)->get_typename = (gchar* (*) (DataSource *)) data_source_real_get_typename;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((DataSourceClass *) klass)->get_instance_id = (gint64 (*) (DataSource *)) data_source_real_get_instance_id;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((DataSourceClass *) klass)->get_source_id = (gchar* (*) (DataSource *)) data_source_real_get_source_id;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((DataSourceClass *) klass)->commit_backlinks = (void (*) (DataSource *, SourceCollection*, const gchar*)) data_source_real_commit_backlinks;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((DataSourceClass *) klass)->save_snapshot = (SourceSnapshot* (*) (DataSource *)) data_source_real_save_snapshot;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((DataSourceClass *) klass)->internal_delete_backing = (gboolean (*) (DataSource *, GError**)) data_source_real_internal_delete_backing;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((DataSourceClass *) klass)->equals = (gboolean (*) (DataSource *, DataSource*)) data_source_real_equals;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((DataSourceClass *) klass)->destroy = (void (*) (DataSource *)) data_source_real_destroy;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((DataSourceClass *) klass)->unlinked = data_source_real_unlinked;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((DataSourceClass *) klass)->relinked = data_source_real_relinked;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((DataSourceClass *) klass)->destroyed = data_source_real_destroyed;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	G_OBJECT_CLASS (klass)->finalize = data_source_finalize;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	data_source_signals[DATA_SOURCE_UNLINKED_SIGNAL] = g_signal_new ("unlinked", TYPE_DATA_SOURCE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataSourceClass, unlinked), NULL, NULL, g_cclosure_user_marshal_VOID__DATA_COLLECTION, G_TYPE_NONE, 1, TYPE_SOURCE_COLLECTION);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	data_source_signals[DATA_SOURCE_RELINKED_SIGNAL] = g_signal_new ("relinked", TYPE_DATA_SOURCE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataSourceClass, relinked), NULL, NULL, g_cclosure_user_marshal_VOID__DATA_COLLECTION, G_TYPE_NONE, 1, TYPE_SOURCE_COLLECTION);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	data_source_signals[DATA_SOURCE_DESTROYED_SIGNAL] = g_signal_new ("destroyed", TYPE_DATA_SOURCE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataSourceClass, destroyed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3135 "DataSource.c"
}


static void
data_source_instance_init (DataSource * self)
{
	DataView** _tmp0_;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv = DATA_SOURCE_GET_PRIVATE (self);
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = g_new0 (DataView*, 4 + 1);
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->subscribers = _tmp0_;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->subscribers_length1 = 4;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->_subscribers_size_ = self->priv->subscribers_length1;
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->holding_tank = NULL;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->unlinked_from_collection = NULL;
#line 58 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->backlinks = NULL;
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->in_contact = FALSE;
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->marked_for_destroy = FALSE;
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->is_destroyed = FALSE;
#line 3165 "DataSource.c"
}


static void
data_source_finalize (GObject * obj)
{
	DataSource * self;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DATA_SOURCE, DataSource);
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->subscribers = (_vala_array_free (self->priv->subscribers, self->priv->subscribers_length1, (GDestroyNotify) g_object_unref), NULL);
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_source_holding_tank_unref0 (self->priv->holding_tank);
#line 58 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_g_object_unref0 (self->priv->backlinks);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	G_OBJECT_CLASS (data_source_parent_class)->finalize (obj);
#line 3183 "DataSource.c"
}


GType
data_source_get_type (void)
{
	static volatile gsize data_source_type_id__volatile = 0;
	if (g_once_init_enter (&data_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DataSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataSource), 0, (GInstanceInitFunc) data_source_instance_init, NULL };
		GType data_source_type_id;
		data_source_type_id = g_type_register_static (TYPE_DATA_OBJECT, "DataSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&data_source_type_id__volatile, data_source_type_id);
	}
	return data_source_type_id__volatile;
}


static void
source_snapshot_real_notify_broken (SourceSnapshot* self)
{
#line 468 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->snapshot_broken = TRUE;
#line 470 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_signal_emit (self, source_snapshot_signals[SOURCE_SNAPSHOT_BROKEN_SIGNAL], 0);
#line 3208 "DataSource.c"
}


void
source_snapshot_notify_broken (SourceSnapshot* self)
{
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	SOURCE_SNAPSHOT_GET_CLASS (self)->notify_broken (self);
#line 3219 "DataSource.c"
}


gboolean
source_snapshot_is_broken (SourceSnapshot* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 473 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = self->priv->snapshot_broken;
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	result = _tmp0_;
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return result;
#line 3236 "DataSource.c"
}


SourceSnapshot*
source_snapshot_construct (GType object_type)
{
	SourceSnapshot* self = NULL;
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self = (SourceSnapshot*) g_type_create_instance (object_type);
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return self;
#line 3248 "DataSource.c"
}


static void
source_snapshot_real_broken (SourceSnapshot* self)
{
}


static void
value_source_snapshot_init (GValue* value)
{
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	value->data[0].v_pointer = NULL;
#line 3263 "DataSource.c"
}


static void
value_source_snapshot_free_value (GValue* value)
{
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (value->data[0].v_pointer) {
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		source_snapshot_unref (value->data[0].v_pointer);
#line 3274 "DataSource.c"
	}
}


static void
value_source_snapshot_copy_value (const GValue* src_value,
                                  GValue* dest_value)
{
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (src_value->data[0].v_pointer) {
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		dest_value->data[0].v_pointer = source_snapshot_ref (src_value->data[0].v_pointer);
#line 3287 "DataSource.c"
	} else {
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		dest_value->data[0].v_pointer = NULL;
#line 3291 "DataSource.c"
	}
}


static gpointer
value_source_snapshot_peek_pointer (const GValue* value)
{
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return value->data[0].v_pointer;
#line 3301 "DataSource.c"
}


static gchar*
value_source_snapshot_collect_value (GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (collect_values[0].v_pointer) {
#line 3313 "DataSource.c"
		SourceSnapshot * object;
		object = collect_values[0].v_pointer;
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		if (object->parent_instance.g_class == NULL) {
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3320 "DataSource.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3324 "DataSource.c"
		}
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		value->data[0].v_pointer = source_snapshot_ref (object);
#line 3328 "DataSource.c"
	} else {
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		value->data[0].v_pointer = NULL;
#line 3332 "DataSource.c"
	}
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return NULL;
#line 3336 "DataSource.c"
}


static gchar*
value_source_snapshot_lcopy_value (const GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
	SourceSnapshot ** object_p;
	object_p = collect_values[0].v_pointer;
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (!object_p) {
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 3352 "DataSource.c"
	}
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (!value->data[0].v_pointer) {
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		*object_p = NULL;
#line 3358 "DataSource.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		*object_p = value->data[0].v_pointer;
#line 3362 "DataSource.c"
	} else {
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		*object_p = source_snapshot_ref (value->data[0].v_pointer);
#line 3366 "DataSource.c"
	}
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return NULL;
#line 3370 "DataSource.c"
}


GParamSpec*
param_spec_source_snapshot (const gchar* name,
                            const gchar* nick,
                            const gchar* blurb,
                            GType object_type,
                            GParamFlags flags)
{
	ParamSpecSourceSnapshot* spec;
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SOURCE_SNAPSHOT), NULL);
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return G_PARAM_SPEC (spec);
#line 3390 "DataSource.c"
}


gpointer
value_get_source_snapshot (const GValue* value)
{
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_SNAPSHOT), NULL);
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return value->data[0].v_pointer;
#line 3401 "DataSource.c"
}


void
value_set_source_snapshot (GValue* value,
                           gpointer v_object)
{
	SourceSnapshot * old;
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_SNAPSHOT));
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	old = value->data[0].v_pointer;
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (v_object) {
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_SNAPSHOT));
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		value->data[0].v_pointer = v_object;
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		source_snapshot_ref (value->data[0].v_pointer);
#line 3424 "DataSource.c"
	} else {
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		value->data[0].v_pointer = NULL;
#line 3428 "DataSource.c"
	}
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (old) {
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		source_snapshot_unref (old);
#line 3434 "DataSource.c"
	}
}


void
value_take_source_snapshot (GValue* value,
                            gpointer v_object)
{
	SourceSnapshot * old;
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_SNAPSHOT));
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	old = value->data[0].v_pointer;
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (v_object) {
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_SNAPSHOT));
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		value->data[0].v_pointer = v_object;
#line 3456 "DataSource.c"
	} else {
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		value->data[0].v_pointer = NULL;
#line 3460 "DataSource.c"
	}
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (old) {
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		source_snapshot_unref (old);
#line 3466 "DataSource.c"
	}
}


static void
source_snapshot_class_init (SourceSnapshotClass * klass)
{
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	source_snapshot_parent_class = g_type_class_peek_parent (klass);
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((SourceSnapshotClass *) klass)->finalize = source_snapshot_finalize;
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_type_class_add_private (klass, sizeof (SourceSnapshotPrivate));
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((SourceSnapshotClass *) klass)->notify_broken = (void (*) (SourceSnapshot *)) source_snapshot_real_notify_broken;
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((SourceSnapshotClass *) klass)->broken = source_snapshot_real_broken;
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	source_snapshot_signals[SOURCE_SNAPSHOT_BROKEN_SIGNAL] = g_signal_new ("broken", TYPE_SOURCE_SNAPSHOT, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceSnapshotClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3486 "DataSource.c"
}


static void
source_snapshot_instance_init (SourceSnapshot * self)
{
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv = SOURCE_SNAPSHOT_GET_PRIVATE (self);
#line 460 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->snapshot_broken = FALSE;
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->ref_count = 1;
#line 3499 "DataSource.c"
}


static void
source_snapshot_finalize (SourceSnapshot * obj)
{
	SourceSnapshot * self;
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SOURCE_SNAPSHOT, SourceSnapshot);
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_signal_handlers_destroy (self);
#line 3511 "DataSource.c"
}


GType
source_snapshot_get_type (void)
{
	static volatile gsize source_snapshot_type_id__volatile = 0;
	if (g_once_init_enter (&source_snapshot_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_source_snapshot_init, value_source_snapshot_free_value, value_source_snapshot_copy_value, value_source_snapshot_peek_pointer, "p", value_source_snapshot_collect_value, "p", value_source_snapshot_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SourceSnapshotClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_snapshot_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceSnapshot), 0, (GInstanceInitFunc) source_snapshot_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType source_snapshot_type_id;
		source_snapshot_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SourceSnapshot", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&source_snapshot_type_id__volatile, source_snapshot_type_id);
	}
	return source_snapshot_type_id__volatile;
}


gpointer
source_snapshot_ref (gpointer instance)
{
	SourceSnapshot * self;
	self = instance;
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_atomic_int_inc (&self->ref_count);
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return instance;
#line 3540 "DataSource.c"
}


void
source_snapshot_unref (gpointer instance)
{
	SourceSnapshot * self;
	self = instance;
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		SOURCE_SNAPSHOT_GET_CLASS (self)->finalize (self);
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 3555 "DataSource.c"
	}
}


static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1248 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1249 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1249 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1250 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1250 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1251 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _result_;
#line 1251 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 3581 "DataSource.c"
}


SourceBacklink*
source_backlink_construct (GType object_type,
                           const gchar* name,
                           const gchar* value)
{
	SourceBacklink* self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 511 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 511 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 511 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self = (SourceBacklink*) g_type_create_instance (object_type);
#line 512 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_vala_assert (source_backlink_validate_name_value (name, value), "validate_name_value (name, value)");
#line 514 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = string_strip (name);
#line 514 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_g_free0 (self->priv->_name);
#line 514 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->_name = _tmp0_;
#line 515 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp1_ = string_strip (value);
#line 515 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_g_free0 (self->priv->_value);
#line 515 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->_value = _tmp1_;
#line 511 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return self;
#line 3615 "DataSource.c"
}


SourceBacklink*
source_backlink_new (const gchar* name,
                     const gchar* value)
{
#line 511 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return source_backlink_construct (TYPE_SOURCE_BACKLINK, name, value);
#line 3625 "DataSource.c"
}


SourceBacklink*
source_backlink_construct_from_source (GType object_type,
                                       DataSource* source)
{
	SourceBacklink* self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
#line 518 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 518 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self = (SourceBacklink*) g_type_create_instance (object_type);
#line 519 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = data_source_get_typename (source);
#line 519 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp1_ = _tmp0_;
#line 519 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp2_ = string_strip (_tmp1_);
#line 519 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_g_free0 (self->priv->_name);
#line 519 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->_name = _tmp2_;
#line 519 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_g_free0 (_tmp1_);
#line 520 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp3_ = g_strdup_printf ("%" G_GINT64_FORMAT, data_source_get_instance_id (source));
#line 520 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp4_ = _tmp3_;
#line 520 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp5_ = string_strip (_tmp4_);
#line 520 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_g_free0 (self->priv->_value);
#line 520 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->_value = _tmp5_;
#line 520 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_g_free0 (_tmp4_);
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp6_ = self->priv->_name;
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp7_ = self->priv->_value;
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_vala_assert (source_backlink_validate_name_value (_tmp6_, _tmp7_), "validate_name_value (_name, _value)");
#line 518 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return self;
#line 3678 "DataSource.c"
}


SourceBacklink*
source_backlink_new_from_source (DataSource* source)
{
#line 518 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return source_backlink_construct_from_source (TYPE_SOURCE_BACKLINK, source);
#line 3687 "DataSource.c"
}


static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1417 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1417 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 3707 "DataSource.c"
}


static gboolean
source_backlink_validate_name_value (const gchar* name,
                                     const gchar* value)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 525 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 525 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (value != NULL, FALSE);
#line 526 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (!string_contains (name, "=")) {
#line 526 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp1_ = !string_contains (name, "|");
#line 3726 "DataSource.c"
	} else {
#line 526 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp1_ = FALSE;
#line 3730 "DataSource.c"
	}
#line 526 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp1_) {
#line 526 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp0_ = !string_contains (value, "|");
#line 3736 "DataSource.c"
	} else {
#line 526 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp0_ = FALSE;
#line 3740 "DataSource.c"
	}
#line 526 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	result = _tmp0_;
#line 526 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return result;
#line 3746 "DataSource.c"
}


gchar*
source_backlink_to_string (SourceBacklink* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
#line 529 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 530 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = source_backlink_get_name (self);
#line 530 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp1_ = _tmp0_;
#line 530 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp2_ = source_backlink_get_value (self);
#line 530 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp3_ = _tmp2_;
#line 530 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp4_ = g_strdup_printf ("Backlink %s=%s", _tmp1_, _tmp3_);
#line 530 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	result = _tmp4_;
#line 530 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return result;
#line 3775 "DataSource.c"
}


guint
source_backlink_hash_func (SourceBacklink* backlink)
{
	guint result = 0U;
	GHashFunc _tmp0_;
	const gchar* _tmp1_;
	GHashFunc _tmp2_;
	const gchar* _tmp3_;
#line 534 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = g_str_hash;
#line 534 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp1_ = backlink->priv->_name;
#line 534 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp2_ = g_str_hash;
#line 534 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp3_ = backlink->priv->_value;
#line 534 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	result = _tmp0_ (_tmp1_) ^ _tmp2_ (_tmp3_);
#line 534 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return result;
#line 3799 "DataSource.c"
}


gboolean
source_backlink_equal_func (SourceBacklink* alink,
                            SourceBacklink* blink)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GEqualFunc _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 538 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp1_ = g_str_equal;
#line 538 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp2_ = alink->priv->_name;
#line 538 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp3_ = blink->priv->_name;
#line 538 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp1_ (_tmp2_, _tmp3_)) {
#line 3820 "DataSource.c"
		GEqualFunc _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 538 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp4_ = g_str_equal;
#line 538 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp5_ = alink->priv->_value;
#line 538 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp6_ = blink->priv->_value;
#line 538 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp0_ = _tmp4_ (_tmp5_, _tmp6_);
#line 3832 "DataSource.c"
	} else {
#line 538 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp0_ = FALSE;
#line 3836 "DataSource.c"
	}
#line 538 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	result = _tmp0_;
#line 538 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return result;
#line 3842 "DataSource.c"
}


const gchar*
source_backlink_get_name (SourceBacklink* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 486 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 487 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = self->priv->_name;
#line 487 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	result = _tmp0_;
#line 487 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return result;
#line 3859 "DataSource.c"
}


const gchar*
source_backlink_get_value (SourceBacklink* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 492 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 493 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = self->priv->_value;
#line 493 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	result = _tmp0_;
#line 493 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return result;
#line 3876 "DataSource.c"
}


const gchar*
source_backlink_get_typename (SourceBacklink* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 499 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 500 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = self->priv->_name;
#line 500 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	result = _tmp0_;
#line 500 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return result;
#line 3893 "DataSource.c"
}


static gint64
int64_parse (const gchar* str)
{
	gint64 result = 0LL;
	gint64 _tmp0_;
#line 687 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 688 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = g_ascii_strtoll (str, NULL, (guint) 0);
#line 688 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp0_;
#line 688 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 3910 "DataSource.c"
}


gint64
source_backlink_get_instance_id (SourceBacklink* self)
{
	gint64 result;
	const gchar* _tmp0_;
#line 506 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 507 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = self->priv->_value;
#line 507 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	result = int64_parse (_tmp0_);
#line 507 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return result;
#line 3927 "DataSource.c"
}


static void
value_source_backlink_init (GValue* value)
{
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	value->data[0].v_pointer = NULL;
#line 3936 "DataSource.c"
}


static void
value_source_backlink_free_value (GValue* value)
{
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (value->data[0].v_pointer) {
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		source_backlink_unref (value->data[0].v_pointer);
#line 3947 "DataSource.c"
	}
}


static void
value_source_backlink_copy_value (const GValue* src_value,
                                  GValue* dest_value)
{
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (src_value->data[0].v_pointer) {
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		dest_value->data[0].v_pointer = source_backlink_ref (src_value->data[0].v_pointer);
#line 3960 "DataSource.c"
	} else {
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		dest_value->data[0].v_pointer = NULL;
#line 3964 "DataSource.c"
	}
}


static gpointer
value_source_backlink_peek_pointer (const GValue* value)
{
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return value->data[0].v_pointer;
#line 3974 "DataSource.c"
}


static gchar*
value_source_backlink_collect_value (GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (collect_values[0].v_pointer) {
#line 3986 "DataSource.c"
		SourceBacklink * object;
		object = collect_values[0].v_pointer;
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		if (object->parent_instance.g_class == NULL) {
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3993 "DataSource.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3997 "DataSource.c"
		}
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		value->data[0].v_pointer = source_backlink_ref (object);
#line 4001 "DataSource.c"
	} else {
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		value->data[0].v_pointer = NULL;
#line 4005 "DataSource.c"
	}
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return NULL;
#line 4009 "DataSource.c"
}


static gchar*
value_source_backlink_lcopy_value (const GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
	SourceBacklink ** object_p;
	object_p = collect_values[0].v_pointer;
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (!object_p) {
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 4025 "DataSource.c"
	}
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (!value->data[0].v_pointer) {
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		*object_p = NULL;
#line 4031 "DataSource.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		*object_p = value->data[0].v_pointer;
#line 4035 "DataSource.c"
	} else {
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		*object_p = source_backlink_ref (value->data[0].v_pointer);
#line 4039 "DataSource.c"
	}
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return NULL;
#line 4043 "DataSource.c"
}


GParamSpec*
param_spec_source_backlink (const gchar* name,
                            const gchar* nick,
                            const gchar* blurb,
                            GType object_type,
                            GParamFlags flags)
{
	ParamSpecSourceBacklink* spec;
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SOURCE_BACKLINK), NULL);
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return G_PARAM_SPEC (spec);
#line 4063 "DataSource.c"
}


gpointer
value_get_source_backlink (const GValue* value)
{
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_BACKLINK), NULL);
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return value->data[0].v_pointer;
#line 4074 "DataSource.c"
}


void
value_set_source_backlink (GValue* value,
                           gpointer v_object)
{
	SourceBacklink * old;
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_BACKLINK));
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	old = value->data[0].v_pointer;
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (v_object) {
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_BACKLINK));
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		value->data[0].v_pointer = v_object;
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		source_backlink_ref (value->data[0].v_pointer);
#line 4097 "DataSource.c"
	} else {
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		value->data[0].v_pointer = NULL;
#line 4101 "DataSource.c"
	}
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (old) {
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		source_backlink_unref (old);
#line 4107 "DataSource.c"
	}
}


void
value_take_source_backlink (GValue* value,
                            gpointer v_object)
{
	SourceBacklink * old;
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_BACKLINK));
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	old = value->data[0].v_pointer;
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (v_object) {
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_BACKLINK));
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		value->data[0].v_pointer = v_object;
#line 4129 "DataSource.c"
	} else {
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		value->data[0].v_pointer = NULL;
#line 4133 "DataSource.c"
	}
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (old) {
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		source_backlink_unref (old);
#line 4139 "DataSource.c"
	}
}


static void
source_backlink_class_init (SourceBacklinkClass * klass)
{
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	source_backlink_parent_class = g_type_class_peek_parent (klass);
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((SourceBacklinkClass *) klass)->finalize = source_backlink_finalize;
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_type_class_add_private (klass, sizeof (SourceBacklinkPrivate));
#line 4153 "DataSource.c"
}


static void
source_backlink_instance_init (SourceBacklink * self)
{
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv = SOURCE_BACKLINK_GET_PRIVATE (self);
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->ref_count = 1;
#line 4164 "DataSource.c"
}


static void
source_backlink_finalize (SourceBacklink * obj)
{
	SourceBacklink * self;
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SOURCE_BACKLINK, SourceBacklink);
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_signal_handlers_destroy (self);
#line 482 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_g_free0 (self->priv->_name);
#line 483 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_g_free0 (self->priv->_value);
#line 4180 "DataSource.c"
}


GType
source_backlink_get_type (void)
{
	static volatile gsize source_backlink_type_id__volatile = 0;
	if (g_once_init_enter (&source_backlink_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_source_backlink_init, value_source_backlink_free_value, value_source_backlink_copy_value, value_source_backlink_peek_pointer, "p", value_source_backlink_collect_value, "p", value_source_backlink_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SourceBacklinkClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_backlink_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceBacklink), 0, (GInstanceInitFunc) source_backlink_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType source_backlink_type_id;
		source_backlink_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SourceBacklink", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&source_backlink_type_id__volatile, source_backlink_type_id);
	}
	return source_backlink_type_id__volatile;
}


gpointer
source_backlink_ref (gpointer instance)
{
	SourceBacklink * self;
	self = instance;
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_atomic_int_inc (&self->ref_count);
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return instance;
#line 4209 "DataSource.c"
}


void
source_backlink_unref (gpointer instance)
{
	SourceBacklink * self;
	self = instance;
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		SOURCE_BACKLINK_GET_CLASS (self)->finalize (self);
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 4224 "DataSource.c"
	}
}


static void
_source_proxy_on_source_added_data_collection_items_added (DataCollection* _sender,
                                                           GeeIterable* added,
                                                           gpointer self)
{
#line 601 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	source_proxy_on_source_added ((SourceProxy*) self, added);
#line 4236 "DataSource.c"
}


static void
_source_proxy_on_snapshot_broken_source_snapshot_broken (SourceSnapshot* _sender,
                                                         gpointer self)
{
#line 590 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	source_proxy_on_snapshot_broken ((SourceProxy*) self);
#line 4246 "DataSource.c"
}


SourceProxy*
source_proxy_construct (GType object_type,
                        DataSource* source)
{
	SourceProxy* self = NULL;
	gchar* _tmp0_;
	SourceSnapshot* _tmp1_;
	SourceSnapshot* _tmp2_;
	SourceSnapshot* _tmp3_;
	DataCollection* _tmp4_;
	SourceCollection* _tmp5_;
	SourceCollection* _tmp6_;
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self = (SourceProxy*) g_type_create_instance (object_type);
#line 585 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->object_id = data_object_get_object_id ((DataObject*) source);
#line 586 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = data_object_to_string ((DataObject*) source);
#line 586 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_g_free0 (self->priv->source_string);
#line 586 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->source_string = _tmp0_;
#line 588 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp1_ = data_source_save_snapshot (source);
#line 588 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_source_snapshot_unref0 (self->priv->snapshot);
#line 588 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->snapshot = _tmp1_;
#line 589 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp2_ = self->priv->snapshot;
#line 589 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_vala_assert (_tmp2_ != NULL, "snapshot != null");
#line 590 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp3_ = self->priv->snapshot;
#line 590 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_signal_connect (_tmp3_, "broken", (GCallback) _source_proxy_on_snapshot_broken_source_snapshot_broken, self);
#line 592 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	source_proxy_set_source (self, source);
#line 594 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp4_ = data_object_get_membership ((DataObject*) source);
#line 594 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_data_collection_unref0 (self->priv->membership);
#line 594 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->membership = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_SOURCE_COLLECTION, SourceCollection);
#line 595 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp5_ = self->priv->membership;
#line 595 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_vala_assert (_tmp5_ != NULL, "membership != null");
#line 596 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp6_ = self->priv->membership;
#line 596 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_signal_connect ((DataCollection*) _tmp6_, "items-added", (GCallback) _source_proxy_on_source_added_data_collection_items_added, self);
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return self;
#line 4306 "DataSource.c"
}


static DataSource*
source_proxy_real_reconstitute (SourceProxy* self,
                                gint64 object_id,
                                SourceSnapshot* snapshot)
{
#line 604 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_critical ("Type `%s' does not implement abstract method `source_proxy_reconstitute'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 604 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return NULL;
#line 4319 "DataSource.c"
}


DataSource*
source_proxy_reconstitute (SourceProxy* self,
                           gint64 object_id,
                           SourceSnapshot* snapshot)
{
#line 604 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 604 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return SOURCE_PROXY_GET_CLASS (self)->reconstitute (self, object_id, snapshot);
#line 4332 "DataSource.c"
}


static void
source_proxy_real_notify_reconstituted (SourceProxy* self,
                                        DataSource* source)
{
#line 606 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (source != NULL);
#line 607 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_signal_emit (self, source_proxy_signals[SOURCE_PROXY_RECONSTITUTED_SIGNAL], 0, source);
#line 4344 "DataSource.c"
}


void
source_proxy_notify_reconstituted (SourceProxy* self,
                                   DataSource* source)
{
#line 606 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 606 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	SOURCE_PROXY_GET_CLASS (self)->notify_reconstituted (self, source);
#line 4356 "DataSource.c"
}


static void
source_proxy_real_notify_dehydrated (SourceProxy* self)
{
#line 611 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_signal_emit (self, source_proxy_signals[SOURCE_PROXY_DEHYDRATED_SIGNAL], 0);
#line 4365 "DataSource.c"
}


void
source_proxy_notify_dehydrated (SourceProxy* self)
{
#line 610 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 610 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	SOURCE_PROXY_GET_CLASS (self)->notify_dehydrated (self);
#line 4376 "DataSource.c"
}


static void
source_proxy_real_notify_broken (SourceProxy* self)
{
#line 615 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_signal_emit (self, source_proxy_signals[SOURCE_PROXY_BROKEN_SIGNAL], 0);
#line 4385 "DataSource.c"
}


void
source_proxy_notify_broken (SourceProxy* self)
{
#line 614 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 614 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	SOURCE_PROXY_GET_CLASS (self)->notify_broken (self);
#line 4396 "DataSource.c"
}


static void
source_proxy_on_snapshot_broken (SourceProxy* self)
{
#line 618 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 619 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	source_proxy_drop_source (self);
#line 621 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	source_proxy_notify_broken (self);
#line 4409 "DataSource.c"
}


static void
_source_proxy_on_destroyed_data_source_destroyed (DataSource* _sender,
                                                  gpointer self)
{
#line 628 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	source_proxy_on_destroyed ((SourceProxy*) self);
#line 4419 "DataSource.c"
}


static void
source_proxy_set_source (SourceProxy* self,
                         DataSource* source)
{
	DataSource* _tmp0_;
#line 624 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 624 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (source != NULL);
#line 625 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	source_proxy_drop_source (self);
#line 627 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = _g_object_ref0 (source);
#line 627 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_g_object_unref0 (self->priv->source);
#line 627 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->source = _tmp0_;
#line 628 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_signal_connect (source, "destroyed", (GCallback) _source_proxy_on_destroyed_data_source_destroyed, self);
#line 4442 "DataSource.c"
}


static void
source_proxy_drop_source (SourceProxy* self)
{
	DataSource* _tmp0_;
	DataSource* _tmp1_;
	guint _tmp2_;
#line 631 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 632 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = self->priv->source;
#line 632 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp0_ == NULL) {
#line 633 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		return;
#line 4460 "DataSource.c"
	}
#line 635 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp1_ = self->priv->source;
#line 635 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_signal_parse_name ("destroyed", TYPE_DATA_SOURCE, &_tmp2_, NULL, FALSE);
#line 635 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _source_proxy_on_destroyed_data_source_destroyed, self);
#line 636 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_g_object_unref0 (self->priv->source);
#line 636 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv->source = NULL;
#line 4472 "DataSource.c"
}


DataSource*
source_proxy_get_source (SourceProxy* self)
{
	DataSource* result = NULL;
	SourceSnapshot* _tmp0_;
	DataSource* _tmp1_;
	DataSource* new_source = NULL;
	gint64 _tmp4_;
	SourceSnapshot* _tmp5_;
	DataSource* _tmp6_;
	DataSource* _tmp7_;
	DataSource* _tmp8_;
	gint64 _tmp11_;
	DataSource* _tmp12_;
	DataSource* _tmp14_;
	gint64 _tmp15_;
	SourceCollection* _tmp16_;
	DataSource* _tmp17_;
	DataSource* _tmp18_;
	DataSource* _tmp19_;
#line 639 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 640 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = self->priv->snapshot;
#line 640 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (source_snapshot_is_broken (_tmp0_)) {
#line 641 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		result = NULL;
#line 641 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		return result;
#line 4506 "DataSource.c"
	}
#line 643 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp1_ = self->priv->source;
#line 643 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp1_ != NULL) {
#line 4512 "DataSource.c"
		DataSource* _tmp2_;
		DataSource* _tmp3_;
#line 644 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp2_ = self->priv->source;
#line 644 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 644 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		result = _tmp3_;
#line 644 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		return result;
#line 4523 "DataSource.c"
	}
#line 649 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp4_ = self->priv->object_id;
#line 649 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp5_ = self->priv->snapshot;
#line 649 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp6_ = source_proxy_reconstitute (self, _tmp4_, _tmp5_);
#line 649 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	new_source = _tmp6_;
#line 650 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp7_ = self->priv->source;
#line 650 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp8_ = new_source;
#line 650 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp7_ != _tmp8_) {
#line 4539 "DataSource.c"
		DataSource* _tmp9_;
		DataSource* _tmp10_;
#line 651 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp9_ = new_source;
#line 651 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp10_ = _g_object_ref0 (_tmp9_);
#line 651 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_g_object_unref0 (self->priv->source);
#line 651 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		self->priv->source = _tmp10_;
#line 4550 "DataSource.c"
	}
#line 652 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp11_ = self->priv->object_id;
#line 652 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp12_ = self->priv->source;
#line 652 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp11_ != data_object_get_object_id ((DataObject*) _tmp12_)) {
#line 4558 "DataSource.c"
		DataSource* _tmp13_;
#line 653 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp13_ = new_source;
#line 653 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		self->priv->object_id = data_object_get_object_id ((DataObject*) _tmp13_);
#line 4564 "DataSource.c"
	}
#line 654 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp14_ = self->priv->source;
#line 654 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp15_ = self->priv->object_id;
#line 654 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_vala_assert (data_object_get_object_id ((DataObject*) _tmp14_) == _tmp15_, "source.get_object_id () == object_id");
#line 655 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp16_ = self->priv->membership;
#line 655 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp17_ = self->priv->source;
#line 655 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_vala_assert (data_collection_contains ((DataCollection*) _tmp16_, (DataObject*) _tmp17_), "membership.contains (source)");
#line 657 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp18_ = self->priv->source;
#line 657 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp19_ = _g_object_ref0 (_tmp18_);
#line 657 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	result = _tmp19_;
#line 657 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_g_object_unref0 (new_source);
#line 657 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return result;
#line 4588 "DataSource.c"
}


static void
source_proxy_on_destroyed (SourceProxy* self)
{
	DataSource* _tmp0_;
#line 660 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = self->priv->source;
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_vala_assert (_tmp0_ != NULL, "source != null");
#line 664 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	source_proxy_drop_source (self);
#line 666 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	source_proxy_notify_dehydrated (self);
#line 4606 "DataSource.c"
}


static void
source_proxy_on_source_added (SourceProxy* self,
                              GeeIterable* added)
{
	DataSource* _tmp0_;
#line 669 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 669 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (added != NULL);
#line 671 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = self->priv->source;
#line 671 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (_tmp0_ != NULL) {
#line 672 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		return;
#line 4625 "DataSource.c"
	}
	{
		GeeIterator* _object_it = NULL;
		GeeIterator* _tmp1_;
#line 674 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_tmp1_ = gee_iterable_iterator (added);
#line 674 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_object_it = _tmp1_;
#line 674 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		while (TRUE) {
#line 4636 "DataSource.c"
			GeeIterator* _tmp2_;
			DataObject* object = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			DataObject* _tmp5_;
			gint64 _tmp6_;
			DataObject* _tmp7_;
			DataObject* _tmp8_;
#line 674 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp2_ = _object_it;
#line 674 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 674 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				break;
#line 4651 "DataSource.c"
			}
#line 674 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp3_ = _object_it;
#line 674 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 674 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			object = (DataObject*) _tmp4_;
#line 676 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp5_ = object;
#line 676 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp6_ = self->priv->object_id;
#line 676 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			if (data_object_get_object_id (_tmp5_) != _tmp6_) {
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				_g_object_unref0 (object);
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
				continue;
#line 4669 "DataSource.c"
			}
#line 680 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp7_ = object;
#line 680 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			source_proxy_set_source (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_DATA_SOURCE, DataSource));
#line 682 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_tmp8_ = object;
#line 682 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			source_proxy_notify_reconstituted (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_DATA_SOURCE, DataSource));
#line 684 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			_g_object_unref0 (object);
#line 684 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			break;
#line 4683 "DataSource.c"
		}
#line 674 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		_g_object_unref0 (_object_it);
#line 4687 "DataSource.c"
	}
}


static void
source_proxy_real_reconstituted (SourceProxy* self,
                                 DataSource* source)
{
#line 571 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (source != NULL);
#line 4698 "DataSource.c"
}


static void
source_proxy_real_dehydrated (SourceProxy* self)
{
}


static void
source_proxy_real_broken (SourceProxy* self)
{
}


static void
value_source_proxy_init (GValue* value)
{
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	value->data[0].v_pointer = NULL;
#line 4719 "DataSource.c"
}


static void
value_source_proxy_free_value (GValue* value)
{
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (value->data[0].v_pointer) {
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		source_proxy_unref (value->data[0].v_pointer);
#line 4730 "DataSource.c"
	}
}


static void
value_source_proxy_copy_value (const GValue* src_value,
                               GValue* dest_value)
{
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (src_value->data[0].v_pointer) {
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		dest_value->data[0].v_pointer = source_proxy_ref (src_value->data[0].v_pointer);
#line 4743 "DataSource.c"
	} else {
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		dest_value->data[0].v_pointer = NULL;
#line 4747 "DataSource.c"
	}
}


static gpointer
value_source_proxy_peek_pointer (const GValue* value)
{
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return value->data[0].v_pointer;
#line 4757 "DataSource.c"
}


static gchar*
value_source_proxy_collect_value (GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (collect_values[0].v_pointer) {
#line 4769 "DataSource.c"
		SourceProxy * object;
		object = collect_values[0].v_pointer;
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		if (object->parent_instance.g_class == NULL) {
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4776 "DataSource.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4780 "DataSource.c"
		}
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		value->data[0].v_pointer = source_proxy_ref (object);
#line 4784 "DataSource.c"
	} else {
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		value->data[0].v_pointer = NULL;
#line 4788 "DataSource.c"
	}
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return NULL;
#line 4792 "DataSource.c"
}


static gchar*
value_source_proxy_lcopy_value (const GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	SourceProxy ** object_p;
	object_p = collect_values[0].v_pointer;
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (!object_p) {
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 4808 "DataSource.c"
	}
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (!value->data[0].v_pointer) {
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		*object_p = NULL;
#line 4814 "DataSource.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		*object_p = value->data[0].v_pointer;
#line 4818 "DataSource.c"
	} else {
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		*object_p = source_proxy_ref (value->data[0].v_pointer);
#line 4822 "DataSource.c"
	}
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return NULL;
#line 4826 "DataSource.c"
}


GParamSpec*
param_spec_source_proxy (const gchar* name,
                         const gchar* nick,
                         const gchar* blurb,
                         GType object_type,
                         GParamFlags flags)
{
	ParamSpecSourceProxy* spec;
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SOURCE_PROXY), NULL);
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return G_PARAM_SPEC (spec);
#line 4846 "DataSource.c"
}


gpointer
value_get_source_proxy (const GValue* value)
{
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_PROXY), NULL);
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return value->data[0].v_pointer;
#line 4857 "DataSource.c"
}


void
value_set_source_proxy (GValue* value,
                        gpointer v_object)
{
	SourceProxy * old;
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_PROXY));
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	old = value->data[0].v_pointer;
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (v_object) {
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_PROXY));
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		value->data[0].v_pointer = v_object;
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		source_proxy_ref (value->data[0].v_pointer);
#line 4880 "DataSource.c"
	} else {
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		value->data[0].v_pointer = NULL;
#line 4884 "DataSource.c"
	}
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (old) {
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		source_proxy_unref (old);
#line 4890 "DataSource.c"
	}
}


void
value_take_source_proxy (GValue* value,
                         gpointer v_object)
{
	SourceProxy * old;
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_PROXY));
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	old = value->data[0].v_pointer;
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (v_object) {
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_PROXY));
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		value->data[0].v_pointer = v_object;
#line 4912 "DataSource.c"
	} else {
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		value->data[0].v_pointer = NULL;
#line 4916 "DataSource.c"
	}
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (old) {
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		source_proxy_unref (old);
#line 4922 "DataSource.c"
	}
}


static void
source_proxy_class_init (SourceProxyClass * klass)
{
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	source_proxy_parent_class = g_type_class_peek_parent (klass);
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((SourceProxyClass *) klass)->finalize = source_proxy_finalize;
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_type_class_add_private (klass, sizeof (SourceProxyPrivate));
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((SourceProxyClass *) klass)->reconstitute = (DataSource* (*) (SourceProxy *, gint64, SourceSnapshot*)) source_proxy_real_reconstitute;
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((SourceProxyClass *) klass)->notify_reconstituted = (void (*) (SourceProxy *, DataSource*)) source_proxy_real_notify_reconstituted;
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((SourceProxyClass *) klass)->notify_dehydrated = (void (*) (SourceProxy *)) source_proxy_real_notify_dehydrated;
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((SourceProxyClass *) klass)->notify_broken = (void (*) (SourceProxy *)) source_proxy_real_notify_broken;
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((SourceProxyClass *) klass)->reconstituted = source_proxy_real_reconstituted;
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((SourceProxyClass *) klass)->dehydrated = source_proxy_real_dehydrated;
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	((SourceProxyClass *) klass)->broken = source_proxy_real_broken;
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	source_proxy_signals[SOURCE_PROXY_RECONSTITUTED_SIGNAL] = g_signal_new ("reconstituted", TYPE_SOURCE_PROXY, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceProxyClass, reconstituted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_SOURCE);
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	source_proxy_signals[SOURCE_PROXY_DEHYDRATED_SIGNAL] = g_signal_new ("dehydrated", TYPE_SOURCE_PROXY, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceProxyClass, dehydrated), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	source_proxy_signals[SOURCE_PROXY_BROKEN_SIGNAL] = g_signal_new ("broken", TYPE_SOURCE_PROXY, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceProxyClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4956 "DataSource.c"
}


static void
source_proxy_instance_init (SourceProxy * self)
{
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->priv = SOURCE_PROXY_GET_PRIVATE (self);
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self->ref_count = 1;
#line 4967 "DataSource.c"
}


static void
source_proxy_finalize (SourceProxy * obj)
{
	SourceProxy * self;
	SourceCollection* _tmp0_;
	guint _tmp1_;
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SOURCE_PROXY, SourceProxy);
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_signal_handlers_destroy (self);
#line 600 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	source_proxy_drop_source (self);
#line 601 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_tmp0_ = self->priv->membership;
#line 601 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp1_, NULL, FALSE);
#line 601 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _source_proxy_on_source_added_data_collection_items_added, self);
#line 564 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_g_free0 (self->priv->source_string);
#line 565 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_g_object_unref0 (self->priv->source);
#line 566 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_source_snapshot_unref0 (self->priv->snapshot);
#line 567 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	_data_collection_unref0 (self->priv->membership);
#line 4997 "DataSource.c"
}


GType
source_proxy_get_type (void)
{
	static volatile gsize source_proxy_type_id__volatile = 0;
	if (g_once_init_enter (&source_proxy_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_source_proxy_init, value_source_proxy_free_value, value_source_proxy_copy_value, value_source_proxy_peek_pointer, "p", value_source_proxy_collect_value, "p", value_source_proxy_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SourceProxyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_proxy_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceProxy), 0, (GInstanceInitFunc) source_proxy_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType source_proxy_type_id;
		source_proxy_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SourceProxy", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&source_proxy_type_id__volatile, source_proxy_type_id);
	}
	return source_proxy_type_id__volatile;
}


gpointer
source_proxy_ref (gpointer instance)
{
	SourceProxy * self;
	self = instance;
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_atomic_int_inc (&self->ref_count);
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return instance;
#line 5026 "DataSource.c"
}


void
source_proxy_unref (gpointer instance)
{
	SourceProxy * self;
	self = instance;
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		SOURCE_PROXY_GET_CLASS (self)->finalize (self);
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 5041 "DataSource.c"
	}
}


SourceProxy*
proxyable_get_proxy (Proxyable* self)
{
#line 690 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 690 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	return PROXYABLE_GET_INTERFACE (self)->get_proxy (self);
#line 5053 "DataSource.c"
}


static void
proxyable_base_init (ProxyableIface * iface)
{
#line 689 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	static gboolean initialized = FALSE;
#line 689 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
	if (!initialized) {
#line 689 "/builddir/build/BUILD/photos-0.2.4/src/core/DataSource.vala"
		initialized = TRUE;
#line 5066 "DataSource.c"
	}
}


GType
proxyable_get_type (void)
{
	static volatile gsize proxyable_type_id__volatile = 0;
	if (g_once_init_enter (&proxyable_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ProxyableIface), (GBaseInitFunc) proxyable_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType proxyable_type_id;
		proxyable_type_id = g_type_register_static (G_TYPE_INTERFACE, "Proxyable", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (proxyable_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&proxyable_type_id__volatile, proxyable_type_id);
	}
	return proxyable_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



